// 3dDlg.cpp : implementation file
//
#include "stdafx.h"
#include "BkDoc.h"
#include "Bk.h"
#include "3dDlg.h"
#include "BkView.h"
#include "vicdefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// C3dDlg dialog
C3dDlg::C3dDlg(CWnd* pParent /*=NULL*/)
	: CDialog(C3dDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(C3dDlg)
	m_radioPas = -1;
	//}}AFX_DATA_INIT
}
void C3dDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(C3dDlg)
	DDX_Control(pDX, IDC_YPLUS, m_btnYplus);
	DDX_Control(pDX, IDC_YMOINS, m_btnYmoins);
	DDX_Control(pDX, IDC_XPLUS, m_btnXplus);
	DDX_Control(pDX, IDC_XMOINS, m_btnXmoins);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDVISU, m_btnVisu);
	DDX_Radio(pDX, IDC_PAS1, m_radioPas);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(C3dDlg, CDialog)
	//{{AFX_MSG_MAP(C3dDlg)
	ON_BN_CLICKED(IDVISU, OnVisu)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_XMOINS, OnXmoins)
	ON_BN_CLICKED(IDC_XPLUS, OnXplus)
	ON_BN_CLICKED(IDC_YMOINS, OnYmoins)
	ON_BN_CLICKED(IDC_YPLUS, OnYplus)
	ON_BN_CLICKED(IDC_ZMOINS, OnZmoins)
	ON_BN_CLICKED(IDC_ZPLUS, OnZplus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// C3dDlg message handlers
BOOL C3dDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,l,h,nbB;

	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
  if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument();
	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;

	m_OK=FALSE;
	m_iCarte=m_pApp->m_iCarte;
	m_pApp->m_iCarte=FALSE;
	m_radioPas=0;
	m_pApp->GetDocumentSansCourant(m_pDoc);
	m_pd=NULL;
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]==NULL)
		{
			m_pd=m_pApp->CreerNouvelleFenetre(l,h);
			//On sort...
			i=20;
		}
	}
	if (m_pd!=NULL)
	{
		m_pd->InitialiserImage(l,h,nbB);
		m_pd->DimensionnerFenetre(l,h);
		m_pd->DefinirCurseurs(l,h);
		m_pd->PositionnerFenetre(20,20);
		m_pd->m_sNomFic="Visualisation 3D";
		m_pd->m_iType=1;
		copyimage(m_ps->image,m_pd->image);
		if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
		if (m_pView!=NULL) 
		{
			m_pView->m_iPas=2;
			m_pView->MAJ_Fen();
		}
	}
	else
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnYplus.EnableWindow(FALSE);
		m_btnYmoins.EnableWindow(FALSE);
		m_btnVisu.EnableWindow(FALSE);
		AfxMessageBox("Fermer une fentre inutile.\nPuis rouvrir la bote de dialogue...");
	}

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void C3dDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void C3dDlg::OnCancel() 
{
	m_pApp->m_iCarte=m_iCarte;
	if (m_pd!=NULL)
	{
		//On passe par le presse papier pour pouvoir l'imprimer
		if (OpenClipboard())
		{
			EmptyClipboard();
			windowtoimage(m_pView->m_hWnd,m_pd->image);
			m_pd->m_iL=m_pd->image->endx-m_pd->image->stx+1;
			m_pd->m_iH=m_pd->image->endy-m_pd->image->sty+1;
			m_pd->m_iNbB=m_pd->image->bmh->biBitCount;


			//CString z;z.Format("%d",m_pd->image->bmh->biBitCount);AfxMessageBox(z);

		}
		m_pd->m_iType=0;
	}
	CDialog::OnCancel();
}
//________________________________________
void C3dDlg::OnVisu() 
{
	if (!m_OK)
	{
		m_btnVisu.SetWindowText("Arrter");
		m_btnCancel.EnableWindow(FALSE);
		UpdateData(TRUE);
		if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
		GetDlgItem(IDC_PAS1)->EnableWindow(FALSE);
		GetDlgItem(IDC_PAS2)->EnableWindow(FALSE);
		SetTimer(1,150,NULL);
	}
	else
	{
		KillTimer(1);
		GetDlgItem(IDC_PAS1)->EnableWindow(TRUE);
		GetDlgItem(IDC_PAS2)->EnableWindow(TRUE);
		m_btnVisu.SetWindowText("Visualiser auto.");
		m_btnCancel.EnableWindow(TRUE);
	}
	m_OK=!m_OK;
}
//________________________________________
void C3dDlg::OnTimer(UINT nIDEvent) 
{
	m_pApp->m_fAngleX -= 2.0f;
  m_pApp->m_fAngleY -= 20.0f;
  m_pApp->m_fAngleZ -= 10.0f;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void C3dDlg::OnXmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleY=m_pApp->m_fAngleY-20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnXplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleY=m_pApp->m_fAngleY+20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnYmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleX=m_pApp->m_fAngleX-20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnYplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleX=m_pApp->m_fAngleX+20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnZmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleZ=m_pApp->m_fAngleZ-20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
//________________________________________
void C3dDlg::OnZplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView->m_iPas=1; else m_pView->m_iPas=2;
	m_pApp->m_fAngleZ=m_pApp->m_fAngleZ+20;
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView!=NULL) m_pView->MAJ_Fen();
}
