// AcqProjMaDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "AcqProjMaDlg.h"
#include "BkDoc.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CAcqProjMaDlg dialog
CAcqProjMaDlg::CAcqProjMaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcqProjMaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcqProjMaDlg)
	m_s8 = _T("");
	m_iInterFr = 0;
	m_fPhase = 0.0f;
	//}}AFX_DATA_INIT
}
void CAcqProjMaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcqProjMaDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_IM_CAMERA, m_comboCamera);
	DDX_Text(pDX, IDC_STATIC8, m_s8);
	DDX_Text(pDX, IDC_INTER_FR1, m_iInterFr);
	DDX_Text(pDX, IDC_PHASE1, m_fPhase);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAcqProjMaDlg, CDialog)
	//{{AFX_MSG_MAP(CAcqProjMaDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CAcqProjMaDlg message handlers
BOOL CAcqProjMaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	//Image  projeter
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pProj=(CBkDoc*)pChild->GetActiveDocument(); else m_pProj=NULL;
	m_pApp->GetDocumentSansCourant(m_pDoc);
	short i;
	CString s;
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboCamera.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboCamera.AddString(s);
	//Par dfaut sur nouvelle image
	m_comboCamera.GetLBText(m_comboCamera.GetCount()-1,s);
	m_comboCamera.SetWindowText(s);	
	m_s8.Format("Image mire  projeter: %s ...",m_pProj->m_sNomFic);
	m_iInterFr=m_pApp->m_iInterFr;
	m_fPhase=m_pApp->m_fPhase;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CAcqProjMaDlg::OnOK() 
{
	UpdateData(TRUE);
	m_btnOK.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	GetDlgItem(IDC_INTER_FR1)->EnableWindow(FALSE);
	GetDlgItem(IDC_PHASE1)->EnableWindow(FALSE);
	GetDlgItem(IDC_IM_CAMERA)->EnableWindow(FALSE);

	if (m_iInterFr<1) m_iInterFr=1;
	m_pApp->m_iInterFr=m_iInterFr;
	m_pApp->m_fPhase=m_fPhase;

	//Image camra en provenance de la liste droulante...
	if (m_comboCamera.GetCurSel()<0)
		m_pCam=m_pDoc[m_comboCamera.GetCount()-1];
	else
		m_pCam=m_pDoc[m_comboCamera.GetCurSel()];

	CMDIChildWnd *pChild;
	if (m_pCam==NULL)
	{
		//Ouverture d'une nouvelle fentre  la taille de l'image courante
		m_pCam=m_pApp->CreerNouvelleFenetre(m_pProj->m_iL,m_pProj->m_iH);
	}
	//Caractristiques de l'image phase
	m_pCam->InitialiserImage(m_pProj->m_iL,m_pProj->m_iH,8);
	//Dimensionner l'image phase  la taille source
	m_pCam->m_iH=m_pProj->m_iH;
	m_pCam->m_iL=m_pProj->m_iL;
	m_pCam->m_iNbB=8;
	m_pCam->m_iType=0;
	m_pCam->InitTracker();//Pas de tracker sur la destination...
	m_pProj->m_sNomFic.Format("ImProjetee");
	m_pCam->m_sNomFic.Format("ImCamera%1.0f",180.0*m_fPhase);
	m_pCam->DefinirCurseurs(m_pProj->m_iL,m_pProj->m_iH);
	m_pCam->DimensionnerFenetre(m_pProj->m_iL,m_pProj->m_iH);
	m_pCam->PositionnerFenetre(m_pApp->m_iL+20,0);
	m_pProj->PositionnerFenetre(0,0);
	if (m_pApp->m_iCarte!=0) m_pCam->FigerAcq();
	GenererMire(m_iInterFr,m_fPhase);
	m_iN=0;SetTimer(20,50,NULL);
	//Fermer la fentre mire
	//m_pApp->FermerFenetre(m_pProj);
	//CDialog::OnOK();
}
//________________________________________
//________________________________________
void CAcqProjMaDlg::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent)
	{
		case 20:
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(20);
				if (m_pApp->m_iCarte!=0) m_pCam->AcqPerm();
				m_iN=0;SetTimer(21,50,NULL);
			}
		break;
		case 21:
			m_iN++;
			if (m_iN>20)
			{
				KillTimer(21);
				if (m_pApp->m_iCarte!=0) m_pCam->FigerAcq();
				m_fPhase=m_fPhase+0.5; if (m_fPhase>1.5) m_fPhase=0;
				m_s8="Incrmentation automatique de la phase...";
				m_btnCancel.EnableWindow(TRUE);
				GetDlgItem(IDC_INTER_FR1)->EnableWindow(TRUE);
				GetDlgItem(IDC_PHASE1)->EnableWindow(TRUE);
				//GetDlgItem(IDC_IM_CAMERA)->EnableWindow(TRUE);
				if (m_pApp->m_iNb>m_pApp->m_iNbMax) m_btnOK.EnableWindow(FALSE); else m_btnOK.EnableWindow(TRUE);
				UpdateData(FALSE);
			}
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//__________________________________________________
void CAcqProjMaDlg::GenererMire(short interfr,float phase) 
{
	short i,j;
	float 
		x,x0,xn,
		y,PI=4*atan(1);
	for (i=0;i<m_pProj->m_iL;i++)
	{
		y=sin(2*PI*i/interfr+phase*PI);
		for (j=0;j<m_pProj->m_iH;j++)
		{
			setpixelcolor(m_pProj->image,i,j,(int)((y+1)*127));
		}
	}
	m_pProj->m_iType=0;
	m_pProj->UpdateAllViews(NULL);
}
//________________________________________
void CAcqProjMaDlg::PostNcDestroy() 
{
	//KillTimer(20);
	//KillTimer(21);
	CDialog::PostNcDestroy();
}
//________________________________________
void CAcqProjMaDlg::OnCancel() 
{
	//CDialog::OnCancel();
}
