// AltitudeDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "AltitudeDlg.h"
#include "BkDoc.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CAltitudeDlg dialog
CAltitudeDlg::CAltitudeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAltitudeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAltitudeDlg)
	m_s19 = _T("");
	m_sH = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_ALTITUDE,pParent);
}
void CAltitudeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAltitudeDlg)
	DDX_Control(pDX, IDCONVERTIR, m_btnConvertir);
	DDX_Text(pDX, IDC_STATIC19, m_s19);
	DDX_Text(pDX, IDC_H, m_sH);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAltitudeDlg, CDialog)
	//{{AFX_MSG_MAP(CAltitudeDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDCONVERTIR, OnConvertir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CAltitudeDlg message handlers
BOOL CAltitudeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	SetTimer(51,100,NULL);
	return TRUE;
}
//________________________________________
void CAltitudeDlg::OnCancel() 
{
	KillTimer(51);
	m_pApp->m_pAltitudeDlg=NULL;	
	CDialog::OnCancel();
}
//________________________________________
void CAltitudeDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CAltitudeDlg::PostNcDestroy() 
{
	delete this;
	CDialog::PostNcDestroy();
}
//________________________________________
void CAltitudeDlg::OnTimer(UINT nIDEvent) 
{
	float h1,h2;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	if (m_pApp->m_iNb>=m_pApp->m_iNbMax)
	{
		m_btnConvertir.EnableWindow(FALSE);
	}
	else
	if (m_pDoc!=NULL)
	{
		if(m_pDoc->image->bmh->biBitCount!=24)
		{
			m_btnConvertir.EnableWindow(FALSE);
			if (m_pDoc->m_iDx==0 && m_pDoc->m_iDy==0)
			{
				//Absolu
				m_s19="H(m):";
				m_sH.Format("%1.2f",m_pDoc->m_fScanning*getpixelcolor(m_pDoc->image,m_pDoc->m_iX,m_pDoc->m_iY)/256);
			}
			else
			{
				//Relatif
				m_s19="dH(m):";
				h1=m_pDoc->m_fScanning*getpixelcolor(m_pDoc->image,m_pDoc->m_iX,m_pDoc->m_iY)/256;
				h2=m_pDoc->m_fScanning*getpixelcolor(m_pDoc->image,m_pDoc->m_iDx,m_pDoc->m_iDy)/256;
				m_sH.Format("%1.2f",h1-h2);
			}
		}
		else
		{
			m_btnConvertir.EnableWindow(TRUE);
			if (m_pDoc->m_iDx==0 && m_pDoc->m_iDy==0)
			{
				//Absolu
				m_s19="H(m):";
				m_sH.Format("%1.2f",m_pDoc->Altitude(m_pDoc->image,m_pDoc->m_iX,m_pDoc->m_iY,m_pDoc->m_fScanning));
			}
			else
			{
				//Relatif
				m_s19="dH(m):";
				h1=m_pDoc->Altitude(m_pDoc->image,m_pDoc->m_iX,m_pDoc->m_iY,m_pDoc->m_fScanning);
				h2=m_pDoc->Altitude(m_pDoc->image,m_pDoc->m_iDx,m_pDoc->m_iDy,m_pDoc->m_fScanning);
				m_sH.Format("%1.2f",h1-h2);
			}
		}
		UpdateData(FALSE);
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CAltitudeDlg::OnConvertir() 
{
	class CBkDoc *pDoc;
	short i,j,l,h;
	float a;
	l=m_pDoc->image->endx-m_pDoc->image->stx+1;
	h=m_pDoc->image->endy-m_pDoc->image->sty+1;
	pDoc=m_pApp->CreerNouvelleFenetre(l,h);
	pDoc->InitialiserImage(l,h,8);


	//On code l'image Dest en 8 bits  partir de l'image Coul
	long w;
	for (i=0;i<l;i++)
	{
		for (j=0;j<h;j++)
		{
			//a: altitude en m du pixel i,j;
			a=m_pDoc->Altitude(m_pDoc->image,i,j,m_pDoc->m_fScanning);
			if (a!=1e10)
			{
				a=255.0*a/m_pDoc->m_fScanning;
				w=(long)a;
			}
			else
				w=255;
			setpixelcolor(pDoc->image,i,j,w);
		}
	}

		pDoc->m_fScanning=m_pDoc->m_fScanning;
		pDoc->m_iPas=m_pDoc->m_iPas;

		pDoc->m_fEchZ=1e3*255.0/pDoc->m_fScanning;
		//Facteur suivant z: maxi 10 mm
		float z;
		z=10.0/pDoc->m_fEchZ;
		pDoc->m_fFactZ=1e-10;
		do
		{
			pDoc->m_fFactZ=pDoc->m_fFactZ*10;
		}
		while (fabs(z*pDoc->m_fFactZ)<=0.1);
		//CString z;
		//z.Format("%f, %f",m_pDoc->m_fEchZ,m_pDoc->m_fFactZ);
		//AfxMessageBox(z);
		pDoc->m_OKZ=TRUE;

	pDoc->UpdateAllViews(NULL);
	
}
