// BkDoc.cpp : implementation of the CBkDoc class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "vicdefs.h"
#include "geoana.h"
#include <math.h>
/**/
#include "WebCam.h"
/**/


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	short i;
	m_pApp=((CBkApp*)AfxGetApp());
	m_pWnd=NULL;				//Pointeur sur la fentre affect dans CBkView::OnInitialUpdate
	m_pView=NULL;				//Pointeur sur la vue affect dans CBkView::OnInitialUpdate
	//Tailles_______________________________
	m_iL=m_pApp->m_iL;
	m_iH=m_pApp->m_iH;
	m_iNbB=m_pApp->m_iNbB;
	m_iNo=m_pApp->m_iNo;
	//Recherche n buffer image disponible
	m_iBuffer=0;
	for (i=0;i<m_pApp->m_iNbMax;i++)
	{
		if (m_pApp->m_iBuffer[i]<0)
		{
			//Buffer trouv
			m_iBuffer=i;
			m_pApp->m_iBuffer[i]=m_iNo;//Buffer occup
			i=m_pApp->m_iNbMax;//On sort
		}
	}
	//m_sNomFic.Format("Image%d (%d)",m_iNo,m_iBuffer);
	m_sNomFic.Format("Image%d",m_iNo);
	m_pApp->m_iNo++;
	m_pApp->m_iNb++;
	image=new imgdes;
	allocimage(image,m_iL,m_iH,m_iNbB);
	zeroimage(255,image);
	//Attributions de l'image_______________
	m_iType=0;					//Bit0: Visu3D
											//Bit1: Trac dans Excel
											//Bit2: Trac de profil H
											//Bit3: Trac de profil V
											//Bit4: Trac de gaussienne H
											//Bit5: Trac de gaussienne V
											//Bit6: Trac de cotes
											//Bit7: Annotations
	//Coordonnes souris_____________________
	m_iX=m_iY=0;				//Coordonnes absolues
	m_iW=0;
	m_iDx=m_iDy=0;			//Coordonnes relatives
	m_iDw=0;
	//Echelles pour calibrage_______________
	if (m_pApp->m_OKCalb)
	{
		m_fEchXY=m_pApp->m_fEchXY;
		m_fEchZ=m_pApp->m_fEchZ;
		m_fFactXY=m_pApp->m_fFactXY;
		m_fFactZ=m_pApp->m_fFactZ;
		m_OKXY=m_OKZ=TRUE;
	}
	else
	{
		m_fEchXY=1;
		m_fEchZ=1;
		m_fFactXY=1;
		m_fFactZ=1;
		m_OKXY=m_OKZ=FALSE;
	}
	//Franges de moir______________________
	m_iM=-1;
	m_fDeltaZ=1.5;
	//Profil________________________________
	m_p.radioRouge=0,		//0:R, 1:V, 2:B
	m_p.iX1=-1;					//Positions de trac du profil
	m_p.iY1=-1;
	m_p.iX2=-1;
	m_p.iY2=-1;
	m_p.OK=FALSE;
  //Donnes (profil,...)__________________
	m_iNbMax=800;				//Nb. maxi de donnes
  m_iNb=0;						//Aucune donne pour l'instant
  m_fT=new float[m_iNbMax][6];
	if (AfxCheckMemory()==FALSE) AfxMessageBox("Erreur test mmoire dans fonction CBkDoc::CBkDoc");;
	//Dmodulation__________________________
	m_iM=0;
	//Tracker_______________________________
	InitTracker();
	m_radioTypeTracker=1;//0:Rectangle, 1:Ellipse
	//Cotation_______________________________________
	m_c.no=0;
	for (i=0;i<8;i++)
	{
		m_c.x1[i]=-1;m_c.y1[i]=-1;m_c.x2[i]=-1;m_c.y2[i]=-1;m_c.s[i]="";
	}
	/*
	//Carte d'imagerie Meteor_______________
	//Carte d'imagerie Orion________________
	MilImage=m_pApp->MilImage[m_iBuffer];
	BufferAttributes=m_pApp->BufferAttributes[m_iBuffer];
	*/
	//VSI
	m_fScanning=m_pApp->m_fScanning;//maxi 25 m
	m_iPas=m_pApp->m_iPas;//nm
	//Webcam
	/**/
	m_pWeb=new CWebCam(m_iL,m_iH);
	m_pApp->m_iCarte=4;
	/**/
}
//________________________________________
CBkDoc::~CBkDoc()
{
	//Carte d'imagerie Meteor_______________
	//Carte d'imagerie Orion________________
	/*
	if (m_pApp->m_iCarte!=0) 
	{
		RemoveFromDisplay();
		MbufClear(MilImage,0);
	}
	*/
	//Rendre le buffer image disponible
	m_pApp->m_iBuffer[m_iBuffer]=-1;
	m_pApp->m_iNb--;
	freeimage(image);
	delete image;
	delete[] m_fT;
	if (m_pApp->m_pDocACopier==this) m_pApp->m_pDocACopier=NULL;
	/**/
	//Webcam
	delete m_pWeb;
	/**/
}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}
//////////////////////////////////////////
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	TiffData tif;
	JpegData jpg;
	CString s,s1;
	CFile *fp=ar.GetFile();
	short i,rcode;
	//Carte d'imagerie
	if (m_pApp->GrabIsStarted) FigerAcq();
	//______________________________________
	s=fp->GetFilePath();
	if (ar.IsStoring())
	{
		//Ecriture
		//On ferme pour que la fonction saveim puisse ouvrir le mme fichier
		/*
		if (s.Find(".im")!=-1 || s.Find(".IM")!=-1)
		{
			fp->Close();
			rcode=Saveim(s,image);
			//On le rouvre pour ne pas faire boguer par la suite...
			fp->Open(s,CFile::modeWrite);	
			m_pApp->AddToRecentFileList(s);
			//Enlever les chemins
			i=s.ReverseFind('\\');
			if (i>1) s=s.Right(s.GetLength()-i-1);
			m_sNomFic.Format("%s",s);
		}
		else
		*/
		if (s.Find(".tif")!=-1 || s.Find(".TIF")!=-1)
		{
			fp->Close();
			rcode=savetif(s,image,0);
			fp->Open(s,CFile::modeWrite);	
			m_pApp->AddToRecentFileList(s);
		}
		else
		if (s.Find(".jpg")!=-1 || s.Find(".JPG")!=-1)
		{
			fp->Close();
			rcode=savejpg(s,image,75);
			fp->Open(s,CFile::modeWrite);	
			m_pApp->AddToRecentFileList(s);
		}
		else
		{
			i=s.Find(".");
			if (i==-1)
			{
				//Ajout extension .tif
				s=s+".tif";
				fp->Close();
				//AfxMessageBox(s);
				rcode=savetif(s,image,0);
				fp->Open(s,CFile::modeWrite);	
				m_pApp->AddToRecentFileList(s);
			}
			else
				rcode=1;
		}
	}
	else
	{
		//Lecture
		/*
		if (s.Find(".im")!=-1 || s.Find(".IM")!=-1)
		{
			fp->Close();
			//On ferme pour que la fonction loadim puisse ouvrir le mme fichier
			rcode=Loadim(s,image);
			//On le rouvre pour ne pas faire boguer par la suite...
			fp->Open(s,CFile::modeRead);	
			m_pApp->AddToRecentFileList(s);
		}
		else
		*/
		if (s.Find(".tif")!=-1 || s.Find(".TIF")!=-1)
		{
			fp->Close();
			rcode=tiffinfo(s,&tif);
			if (rcode==0)
			{
				InitialiserImage(tif.width,tif.length,tif.vbitcount);
				rcode=loadtif(s,image);
				if (rcode!=0) AfxMessageBox("Erreur loadtif");
			}
			fp->Open(s,CFile::modeRead);	
			m_pApp->AddToRecentFileList(s);
			//Enlever les chemins
			i=s.ReverseFind('\\');
			if (i>1) s=s.Right(s.GetLength()-i-1);
			m_sNomFic.Format("%s",s);
		}
		if (s.Find(".jpg")!=-1 || s.Find(".JPG")!=-1)
		{
			fp->Close();
			rcode=jpeginfo(s,&jpg);
			if (rcode==0)
			{
				InitialiserImage(jpg.width,jpg.length,jpg.vbitcount);
				rcode=loadjpg(s,image);
			}
			fp->Open(s,CFile::modeRead);	
			m_pApp->AddToRecentFileList(s);
			//Enlever les chemins
			i=s.ReverseFind('\\');
			if (i>1) s=s.Right(s.GetLength()-i-1);
			m_sNomFic.Format("%s",s);
		}
		//On recherche la profondeur de scanning dans le coin suprieur gauche de l'image
		short h;
		float r;
		if (image->bmh->biBitCount==24)
		{
			r=0.001*getpixelcolor(image,2,2);
			h=getpixelcolor(image,4,2);
			i=getpixelcolor(image,10,2);//1956: code de reconnaissance
			if (r>0 && r<25.0 && i==1956) m_fScanning=m_pApp->m_fScanning=r;
			if (h>0 && h<500*r && i==1956) m_iPas=m_pApp->m_iPas=h;
		}
	}
}
//________________________________________
void CBkDoc::OuEstLaFenetre(short *l,short *h)
{
	CRect	 MMRect1,MMRect2;
	short l1,h1,l2,h2;
	m_pWnd->GetWindowRect(MMRect1);
	m_pWnd->GetClientRect(MMRect2);
	l1=MMRect1.left;
	h1=MMRect1.top;
	l2=MMRect2.left;
	h2=MMRect2.top;
	//CString z;
	//z.Format("%d, %d\n%d,%d",l1,h1,l2,h2);AfxMessageBox(z);
	*l=l1-2;
	*h=h1-78;
}
//_________________________________________________
void CBkDoc::PositionnerFenetre(short l,short h)
{
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1;
	m_pWnd->GetWindowRect(MMRect1);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	MMRect.SetRect(0,0,l1,h1);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l,h,MMRect.right,MMRect.bottom,SWP_NOZORDER|SWP_DRAWFRAME|SWP_SHOWWINDOW);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
void CBkDoc::Lire_Ecrire(CArchive& ar)
{
	//Une ouverture MRU n'excute pas cette fonction !
	Serialize(ar);
	short 
		x,y,
		l=image->endx-image->stx+1,
		h=image->endy-image->sty+1;

	if (l<800)
		x=l;
	else
		x=800;
	if (h<600)
		y=h;
	else
		y=600;
	m_pView->SetScrollSizes(MM_TEXT, CSize(l,h));
	DimensionnerFenetre(x,y);
	short i=m_sNomFic.ReverseFind('\\');
	if (i>1) m_sNomFic=m_sNomFic.Right(m_sNomFic.GetLength()-i-1);
	SetTitle(m_sNomFic);
	//AfxMessageBox(m_sNomFic);
}
//////////////////////////////////////////
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkDoc commands
void CBkDoc::DimensionnerFenetre(short l,short h)
{
	if (l>800) l=800;
	if (h>600) h=600;
	
	CRect	 MMRect,MMRect1,MMRect2;
	short l1,h1,l2,h2;
	m_pWnd->GetWindowRect(MMRect1);
	m_pWnd->GetClientRect(MMRect2);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	l2=MMRect2.right-MMRect2.left;
	h2=MMRect2.bottom-MMRect2.top;
	MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
void CBkDoc::LimiterTailleFenetre(short l,short h)
{
	//Limite la taille de la fentre  l x h si elle est plus grande
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1,l2,h2;
	if (m_pWnd!=NULL)
	{
		m_pWnd->GetWindowRect(MMRect1);
		m_pWnd->GetClientRect(MMRect2);
		l1=MMRect1.right-MMRect1.left;
		h1=MMRect1.bottom-MMRect1.top;
		l2=MMRect2.right-MMRect2.left;
		h2=MMRect2.bottom-MMRect2.top;

		if (l1>l || h1>h)
		{
			MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
			MMRect.OffsetRect(-MMRect.left,-MMRect.top);
			m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
			m_pWnd->InvalidateRect(NULL,FALSE);
		}
	}
}
//________________________________________
void CBkDoc::DefinirCurseurs(short l,short h)
{
	m_pView->SetScrollSizes(MM_TEXT, CSize(l,h));
	m_pView->ScrollToPosition(CPoint(0,0));
	m_iXpos=m_pView->GetScrollPos(SB_HORZ);
	m_iYpos=m_pView->GetScrollPos(SB_VERT);
}
//_________________________________________________
void CBkDoc::EcritTitre(void)
{
	CString s;
	short x;
	if (GetPathName().GetLength()==0)
	{
	}
	else
	{
		//GetTitle ne renvoie pas l'extension...
		if (m_sNomFic.GetLength()==0) m_sNomFic=GetPathName();
		//On enlve le chemin pour ne garder que le nom du fichier avec extension
		x=m_sNomFic.ReverseFind('\\');
		if (x>=0)	m_sNomFic=m_sNomFic.Right(m_sNomFic.GetLength()-x-1);
	}
	//s.Format("(%d) %s (%dx%d)",m_iNo,m_sNomFic,m_iL,m_iH);
	s.Format("%s (%dx%d)",m_sNomFic,m_iL,m_iH);
	SetTitle(s);
}
//________________________________________
void CBkDoc::InitialiserImage(short l,short h,short nbB)
{
	short l1,h1,nbB1;
	int rcode=0;
	l1=image->endx-image->stx+1;
	h1=image->endy-image->sty+1;
	nbB1=image->bmh->biBitCount;
	//CString z;z.Format("%d,%d",l1,h1);AfxMessageBox(z);
	if (l!=l1 || h!=h1 || nbB!=nbB1)
	{
		freeimage(image);
		rcode=allocimage(image,l,h,nbB);
	}
	if (rcode==0) rcode=zeroimage(255,image);
	if (rcode!=0) AfxMessageBox("Erreur sur fonction CBkDoc::InitialiserImage");
	m_iL=l;m_iH=h;m_iNbB=nbB;
	//if (AfxCheckMemory()==FALSE) AfxMessageBox("Erreur test mmoire dans fonction CBkDoc::InitialiserImage");;
}
//________________________________________
short CBkDoc::DupliquerImageDansTempo(short No)
{
	int rcode=0;
	short 
		ld,hd,nbBd,	//Destination temporaire
		ls,hs,nbBs;	//Source
	ls=image->endx-image->stx+1;
	hs=image->endy-image->sty+1;
	nbBs=image->bmh->biBitCount;

	if (No>=m_pApp->m_iNbMax) return -10;
	ld=m_pApp->imt[No]->endx-m_pApp->imt[No]->stx+1;
	hd=m_pApp->imt[No]->endy-m_pApp->imt[No]->sty+1;
	nbBd=m_pApp->imt[No]->bmh->biBitCount;
	if (ld!=ls || hd!=hs || nbBd!=nbBs)
	{
		freeimage(m_pApp->imt[No]);
		rcode=allocimage(m_pApp->imt[No],ls,hs,nbBs);
	}
	if (rcode==0) rcode=copyimage(image,m_pApp->imt[No]);
	if (rcode!=0) AfxMessageBox("Erreur sur fonction CBkApp::DupliquerImageDansTempo");
	return rcode;
}
//________________________________________
short CBkDoc::DupliquerTempoDansImage(short No)
{
	int rcode=0;
	short 
		ld,hd,nbBd,	//Destination temporaire
		ls,hs,nbBs;	//Source

	if (No>=m_pApp->m_iNbMax) return -10;
	ls=m_pApp->imt[No]->endx-m_pApp->imt[No]->stx+1;
	hs=m_pApp->imt[No]->endy-m_pApp->imt[No]->sty+1;
	nbBs=m_pApp->imt[No]->bmh->biBitCount;

	ld=image->endx-image->stx+1;
	hd=image->endy-image->sty+1;
	nbBd=image->bmh->biBitCount;
	if (ld!=ls || hd!=hs || nbBd!=nbBs)
	{
		freeimage(image);
		rcode=allocimage(image,ls,hs,nbBs);

	}
	if (rcode==0) rcode=copyimage(m_pApp->imt[No],image);
	if (rcode!=0) AfxMessageBox("Erreur sur fonction CBkApp::DupliquerTempoDansImage");
	return rcode;
}
//________________________________________
//Calcul des fonctions profils et gaussiennes et affectation m_fT
void CBkDoc::CalculProfils(short rouge,short X1,short Y1,short X2,short Y2)
{
	short 
		x1,y1,x2,y2,
		i,nb,l,h,k;
	float 
		a,b,
		x,y,
		*t,sig,vc,
		PI=4*atan(1);
	long w;
	t=new float[m_iNbMax];
	class CGeoAna geo;
	//Initialisation tableau m_fT document destination
	for (l=0;l<m_iNbMax;l++)
	{
		for (h=0;h<6;h++) m_fT[l][h]=1e10;
	}

	if (X1<X2)
	{
		x1=X1;x2=X2;
	}
	else
	{
		x1=X2;x2=X1;
	}
	if (Y1<Y2)
	{
		y1=Y1;y2=Y2;
	}
	else
	{
		y1=Y2;y2=Y1;
	}
	geo.d2p(X1,Y1,X2,Y2,&a,&b);
	//Profil H____________________________
	k=0;
	for (l=x1;l<x2;l++)
	{
		geo.p2d(X1,Y1,a,l,0,PI/2,&x,&y);
		if (k<m_iNbMax && x!=1e10 && y!=1e10 && x>=0 && x<m_iL && y>=0 && y<m_iH)
		{
			w=getpixelcolor(image,l,(short)(y));
			w=composante(w,rouge);
			m_fT[k][0]=l;
			m_fT[k][1]=w;
			if (k<1024)
			{
				t[k]=(float)w;
				k++;
			}
		}
	}
	//Gauss H_____________________________
	nb=k;
	sig=sigma(t,nb);
	vc=val_cen(t,nb);
	if (vc==1e10)
		vc=127;
	else
		vc=vc+x1;
	//Maxi
	w=0;
	for (i=0;i<nb;i++)
	{
		if (i<m_iNbMax)
		{
			if (t[i]>w) w=(int)t[i];
		}
	}
	k=0;     
	for (l=x1;l<x2;l++)
	{
		if (k<m_iNbMax)
		{
			m_fT[k][2]=1.0*w*gauss(l,vc,sig);
			k++;
		}
	}
	//Profil V____________________________
	k=0;
	for (h=y1;h<y2;h++)
	{
		geo.p2d(X1,Y1,a,0,h,0,&x,&y);
		if (k<m_iNbMax && x!=1e10 && y!=1e10 && x>=0 && x<m_iL && y>=0 && y<m_iH)
		{
			w=getpixelcolor(image,(short)(x),h);
			w=composante(w,rouge);
			m_fT[k][3]=w;
			m_fT[k][4]=h;
			t[k]=(float)w;
			k++;
		}
	}	
	//Gauss V_____________________________
	nb=k;
	sig=sigma(t,nb);
	vc=val_cen(t,nb);
	if (vc==1e10)
		vc=127;
	else
		vc=vc+y1;
	//Maxi
	w=0;
	for (i=0;i<nb;i++)
	{
		if (i<m_iNbMax)
		{
			if (t[i]>w) w=(int)t[i];
		}
	}
	k=0;     
	for (h=y1;h<y2;h++)
	{
		if (k<m_iNbMax)
		{
			m_fT[k][5]=1.0*w*gauss(h,vc,sig);
		}
		k++;
	}
	m_iNb=m_iNbMax;
	delete[] t;
}
//________________________________________
long CBkDoc::composante(long w,short composante)
{
	long w1;
	switch (composante)
	{
		case 0://Composante rouge
			w1=w&255;
		break;
		case 1://Composante verte
			w1=(w/256)&255;
		break;
		case 2://Composante bleue
			w1=(w/65536)&255;
		break;
	}
	return w1;
}
//________________________________________
float CBkDoc::gauss(float p,float p0,float sigma)
{
	return (float)(exp(-pow(p-p0,2)/(2*pow(sigma,2))));
}
//________________________________________
float CBkDoc::val_cen(float t[1024],unsigned int n)
{
	float s=0,s1=0;
	int w;
	if (n==0) return 1e10;
	if (n>1024) n=1024;
	for (w=0;w<n;w++)
	{
		s=s+t[w]*(w+1);
		s1=s1+t[w];
	}
	if (fabs(s1)>1e-6) return s/s1; else return 1e10;
}
//________________________________________
float CBkDoc::sigma(float t[1024],unsigned int n)
{
	float r=0,s=0,s1=0,moy=0;
	int w;
	if (n==0) return 1e10;
	if (n>1024) n=1024;

	for (w=0;w<n;w++)
	{
		s=s+t[w]*(w+1);
		s1=s1+t[w];
	}
	moy=s/s1;
	for (w=0;w<n;w++)
	{
		r=r+pow(moy-(w+1),2)*t[w];
	}
	return (float)(pow(r/s1,0.5));
}
//________________________________________
void CBkDoc::InitTracker(void)
{                       
	m_tracker.m_rect.SetRectEmpty();
	m_tracker.m_nStyle=m_tracker.dottedLine;
	m_tracker.m_nHandleSize=5;
}
//________________________________________
//Sans carte d'imagerie Meteor, Orion, Primo
/*
void CBkDoc::FigerAcq(void) 
{
}
void CBkDoc::AcqPerm(void) 
{
}
*/
//WebCam
/**/
//________________________________________
void CBkDoc::Connexion(void) 
{
	m_iL=m_pApp->m_iL;
	m_iH=m_pApp->m_iH;
	DimensionnerFenetre(m_iL,m_iH);
	DefinirCurseurs(m_iL,m_iH);
	m_pWeb->Connexion(m_pView->m_HWND);
}
//________________________________________
void CBkDoc::AcqPerm(void) 
{
	m_pWeb->AfficheWebCam();
	m_pApp->GrabIsStarted=TRUE;	
}
//________________________________________
void CBkDoc::FigerAcq(void) 
{
	Figer();
}
//________________________________________
void CBkDoc::Figer(void) 
{
	m_pApp=((CBkApp*)AfxGetApp());
	if(m_pApp->GrabIsStarted)
	{
		m_pApp->GrabIsStarted=FALSE;
		m_pWeb->GrabStop();
		//Attention : utilisation image tempo n5
		m_pWeb->CopieImage(image);
		m_iNbB=image->bmh->biBitCount;
	}
}
//________________________________________
void CBkDoc::Deconnexion(void) 
{
	m_pWeb->Deconnexion();
}


/**/
//Carte d'imagerie Primo_________________
/*
void CBkDoc::FigerAcq(void) 
{
	int rcode;
	short l,h,nbB;
	m_pApp->ExecPrimo(2);Sleep(800);
	m_pApp->GrabIsStarted=FALSE;	
	//Chargement de l'image dans image temporaire 0
	l=m_pApp->imt[7]->endx-m_pApp->imt[7]->stx+1;
	h=m_pApp->imt[7]->endy-m_pApp->imt[7]->sty+1;
	nbB=m_pApp->imt[7]->bmh->biBitCount;
	if (l!=512 || h!=512 || nbB!=8)
	{
		freeimage(m_pApp->imt[7]);
		allocimage(m_pApp->imt[7],512,512,8);
	}
	rcode=loadtif("c:\\bk.tif",m_pApp->imt[7]);
	if (rcode==0)
	{
		l=image->endx-image->stx+1;
		h=image->endy-image->sty+1;
		nbB=image->bmh->biBitCount;
		if (l!=m_pApp->m_iL || h!=m_pApp->m_iH || nbB!=8)
		{
			freeimage(image);
			allocimage(image,m_pApp->m_iL,m_pApp->m_iH,8);
		}
		m_iL=m_pApp->m_iL;
		m_iH=m_pApp->m_iH;
		m_iNbB=8;
		DimensionnerFenetre(m_iL,m_iH);
		DefinirCurseurs(m_iL,m_iH);
		m_iType=0;
		//Dilatation de l'image imageori
		rcode=resize(m_pApp->imt[7],image);
		//CString z;z.Format("%d",rcode);AfxMessageBox(z);
		//Raffichage vues
		UpdateAllViews(NULL);
	}
}
//________________________________________
void CBkDoc::AcqPerm(void) 
{
	m_pApp->ExecPrimo(1);Sleep(1000);
	m_pApp->GrabIsStarted=TRUE;	
}
*/
//Carte d'imagerie Meteor_________________
//Carte d'imagerie Orion__________________
/*
//Function used to halt the grab, deselect the buffer and free the display
void CBkDoc::RemoveFromDisplay()
{
	//Halt grab if in process in THIS view
	if ((m_pApp->GrabInViewPtr==m_pView) && m_pApp->GrabIsStarted)
	{
		MdigHalt(m_pApp->MilDigitizer);
 		m_pApp->GrabIsStarted=FALSE;	
	}
	//Deselect the buffer from it's display object and given window 
	if (MilImage && MilDisplay)
	MdispDeselect(MilDisplay,MilImage);
	//Free the display
	if (MilDisplay) MdispFree(MilDisplay);
	MilDisplay=M_NULL;
}
//________________________________________
void CBkDoc::AcqPerm(void) 
{
	//MIL: Write code that will be executed on a grab start
	//Si on est en acquisition permanente dans une vue, arrt de cette acquisition
	if(m_pApp->GrabIsStarted)	m_pApp->GrabInViewPtr->SendMessage(WM_COMMAND,ID_ACQFIG,0);
	//Start a continuous grab in this view
	MdigGrabContinuous(m_pApp->MilDigitizer,MilImage);
	//A faire, sinon l'image n'apparat pas si Orion
	UpdateAllViews(NULL);
	//Update the variable GrabIsStarted
	m_pApp->GrabIsStarted=TRUE;	
	//GrabInViewPtr is now a pointer to this view
	m_pApp->GrabInViewPtr=m_pView;
}
*/
//Carte d'imagerie Orion en couleurs______
//Carte d'imagerie Meteor en couleurs_____
/*
void CBkDoc::FigerAcq(void) 
{
	if (m_pApp->GrabIsStarted)
	{
		//MIL: Write code that will be executed on a grab stop 
		MdigHalt(m_pApp->MilDigitizer);	
		m_pApp->GrabIsStarted=FALSE;
		//Copie de l'image dans l'image Victor
		short 
			i,j,
			l,h,nbB;
		const long larg=m_pApp->SizeX;
		const long haut=m_pApp->SizeY;
		unsigned char *p,*p1,*p2;
		p=new unsigned char[haut*larg];
		p1=new unsigned char[haut*larg];
		p2=new unsigned char[haut*larg];
		unsigned char R,V,B;

		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_RED,0,0,larg,haut,p);
		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_GREEN,0,0,larg,haut,p1);
		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_BLUE,0,0,larg,haut,p2);

		l=image->endx-image->stx+1;
		h=image->endy-image->sty+1;
		nbB=image->bmh->biBitCount;
		if (l!=m_pApp->SizeX || h!=m_pApp->SizeY || nbB!=24)
		{
			freeimage(image);
			allocimage(image,m_pApp->SizeX,m_pApp->SizeY,24);
			//Mmorisation caractristiques image
			m_iL=m_pApp->SizeX;
			m_iH=m_pApp->SizeY;
			m_iNbB=24;
		}
		//Mmorisation caractristiques image
		for (j=0;j<haut;j++)
		{
			for (i=0;i<larg;i++)
			{
				setpixelcolor(image,i,j,p[i+larg*j]+256*p1[i+larg*j]+256*256*p2[i+larg*j]);
			}
		}
		delete p;
		delete p1;
		delete p2;
		m_iType=0;
		DimensionnerFenetre(m_iL,m_iH);
		DefinirCurseurs(m_iL,m_iH);
		UpdateAllViews(NULL);	
	}	
}
*/
//Carte d'imagerie Meteor en N&B__________
//Carte d'imagerie Orion en N&B___________
/*
void CBkDoc::FigerAcq(void) 
{
	if (m_pApp->GrabIsStarted)
	{
		//MIL: Write code that will be executed on a grab stop 
		MdigHalt(m_pApp->MilDigitizer);	
		m_pApp->GrabIsStarted=FALSE;
		//Copie de l'image dans l'image Victor
		short 
			l,h,nbB,
			i,j;
		const long larg=m_pApp->SizeX;
		const long haut=m_pApp->SizeY;
		unsigned char *p;
		p=new unsigned char[haut*larg];

		MbufGetColor2d(MilImage,M_SINGLE_BAND,M_RED,0,0,larg,haut,p);
		//ou:
		//MbufGetColor(MilImage,M_SINGLE_BAND,M_RED,p);
		//Affectation image victor
		l=image->endx-image->stx+1;
		h=image->endy-image->sty+1;
		nbB=image->bmh->biBitCount;
		if (l!=m_pApp->SizeX || h!=m_pApp->SizeY || nbB!=8)
		{
			freeimage(image);
			allocimage(image,m_pApp->SizeX,m_pApp->SizeY,8);
			//Mmorisation caractristiques image
			m_iL=m_pApp->SizeX;
			m_iH=m_pApp->SizeY;
			m_iNbB=8;
		}
		for (j=0;j<haut;j++)
		{
			for (i=0;i<larg;i++)
			{
				setpixelcolor(image,i,j,p[i+larg*j]);
			}
		}
		delete p;
		m_iType=0;
		DimensionnerFenetre(m_iL,m_iH);
		DefinirCurseurs(m_iL,m_iH);
		UpdateAllViews(NULL);	
	}
}
*/
//________________________________________
short CBkDoc::Hysteresis(float x)
{
	//Hystrsis du translateur pizo
	//x:[0, 25 m]
	short h;//[0,1023]
	h=(short)(1e-6*pow(x,6)-3e-5*pow(x,5)-0.0017*pow(x,4)+0.114*pow(x,3)-2.4651*pow(x,2)+59.519*x+3.8113);
	return h;
}
//________________________________________
//Altitude en m en fonction luminance
float CBkDoc::Altitude(imgdes *im,short i,short j,float H)
{
	//H: hauteur scanne, maxi 25 m
	float r=0,k;
	short l,h,nbB,R,V,B;
	long w;
	l=im->endx-im->stx+1;
	h=im->endy-im->sty+1;
	nbB=im->bmh->biBitCount;

	if (i>=0 && i<l && j>=0 && j<h)
	{
		w=getpixelcolor(im,i,j);
		if (nbB==24)
		{
			R=w&255; 
			V=(w/256)&255; 
			B=(w/65536)&255;
			//Fonction inverse de la fonction Couleur
			if (R==0 && B==255 )
			{
				//k dans l'intervalle [0, 1023]
				k=V;
				//r : altitude en m, 1023 -> H m
				r=H*k/1023;
			}
			else
			if (V==255)
			{
				k=255.0+R;
				r=H*k/1023;
			}
			else
			if (R==255 && B==0)
			{
				k=511.0+(255-V);
				r=H*k/1023;
			}
			else
			if (V==0)
			{
				k=767.0+B;
				r=H*k/1023;
			}
			else
				r=1e10;
		}
		else
		{
			//Pour la course maxi du piezo altitude H m
			r=H*w/255;
		}
	}
	else
		r=1e10;

	return r;
}
