// BkView.cpp : implementation of the CBkView class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "ProfilDlg.h"
#include "CoteDlg.h"
#include "geoana.h"
#include "math.h"

#include "gl\gl.h"
#include "gl\glu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CScrollView)

BEGIN_MESSAGE_MAP(CBkView, CScrollView)
	//{{AFX_MSG_MAP(CBkView)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID__CUR_SOURIS,InitSouris)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()
//Menus contextuels_______________________
void CBkView::InitSouris()
{
	//Initialisation coordonnnes souris
	//Voir: CBkView::OnContextMenu
	//Coordonnes relatives souris
	class CBkDoc *pDoc=GetDocument();
	pDoc->m_iDx=0;
	pDoc->m_iDy=0;
	pDoc->m_iDw=0;
	MAJ_Fen();
}
// CBkView construction/destruction
CBkView::CBkView()
{
	//Pointeur sur l'application
	m_pApp=(CBkApp*)AfxGetApp();
}
//________________________________________
CBkView::~CBkView()
{
}
//________________________________________
BOOL CBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}
//////////////////////////////////////////
// CBkView drawing
void CBkView::OnDraw(CDC* pDC)
{
	//pDC->SetBkMode(TRANSPARENT);
	//pDC->SetBkColor(RGB(0,0,0));
	HDC hDC;
	m_HWND=m_hWnd;
	HPALETTE hpal;
	CRect rcClient;
	class CBkDoc* pDoc=GetDocument();
	//Nom fentre
	pDoc->EcritTitre();
	//Si acquisition fige...
	if (!m_pApp->GrabIsStarted)
	{
		//Visualisation image
		if (pDC->IsPrinting())
		{
			//if (pDoc->m_iType&1)
			{
				//3D
			}
			//else
			{
				short ech=3;
				hDC=pDC->m_hDC;
				pDC->SetMapMode(MM_ISOTROPIC);
				pDC->DPtoLP(rcClient);            
				//rcClient.BottomRight().x=(rcClient.BottomRight().xpDoc->m_iXpos)*ech;
				//rcClient.BottomRight().y=(rcClient.BottomRight().ypDoc->m_iYpos)*ech;
				pDC->SetWindowExt(pDoc->m_iL,pDoc->m_iH);
				pDC->SetViewportExt(pDoc->m_iL*ech,pDoc->m_iH*ech);
				viewimage(m_hWnd,hDC,&hpal,pDoc->m_iXpos,pDoc->m_iYpos,pDoc->image);
				if (m_pApp->m_pProfilDlg!=NULL) 
				{
					SegmentProfil(pDC);
				}
				else
				{
					if (pDoc->m_iDx!=0 && pDoc->m_iDy!=0) MarqueDePointage(pDC,pDoc->m_iDx,pDoc->m_iDy,1);//Plume n1

				}
				if (pDoc->m_p.OK) pDoc->CalculProfils(pDoc->m_p.radioRouge,pDoc->m_p.iX1,pDoc->m_p.iY1,pDoc->m_p.iX2,pDoc->m_p.iY2);
				if (pDoc->m_p.OK && pDoc->m_iType&4) ProfilH(pDC);
				if (pDoc->m_p.OK && pDoc->m_iType&8) ProfilV(pDC);
				if (pDoc->m_p.OK && pDoc->m_iType&16) GaussH(pDC);
				if (pDoc->m_p.OK && pDoc->m_iType&32) GaussV(pDC);
				if (pDoc->m_iType&64) DessineCotation(pDC);
			}
		}
		else
		{
			//Pour viter que a flashe quand on dimensionne la fentre...
			pDC->DPtoLP(rcClient);            
			if (pDoc->m_iType&1)
			{
				//3D
				CClientDC dc1(this);
				Init(&dc1);
				DrawScene();
				Libere(&dc1);
			}
			else
			{
				//Dclarer dc, sinon le scroll ne fonctionne pas !
				CClientDC dc(this);
				hDC=dc.m_hDC;
				//hDC=pDC->m_hDC;
				viewimage(m_hWnd,hDC,&hpal,pDoc->m_iXpos,pDoc->m_iYpos,pDoc->image);
				if (m_pApp->m_pMasqueDlg!=NULL)
				{
					TraceTracker(pDC,pDoc->m_radioTypeTracker); //Rectangle ou ellipse
				}
				else
				if (m_pApp->m_pExtractDlg!=NULL)
				{
					TraceTracker(pDC,0); //Rectangle
				}
				else
				if (m_pApp->m_pProfilDlg!=NULL)
				{
					SegmentProfil(&dc);
				}
				else
				if ((m_pApp->m_pAltitudeDlg!=NULL) && (getpixelcolor(pDoc->image,10,2)==1956))//1956: code de reconnaissance
				{
					//Profil dans image topographie 24 bits
					if (pDoc->m_iDx!=0 && pDoc->m_iDy!=0)	
					{
						CPen
							*pOldPen;
						pOldPen=pDC->SelectObject(&m_pApp->plume[7]);

						pDC->MoveTo(0,pDoc->m_iH-255);
						pDC->LineTo(pDoc->m_iL,pDoc->m_iH-255);
						pDC->MoveTo(255,pDoc->m_iH);
						pDC->LineTo(255,0);

						pDC->SelectObject(&m_pApp->plume[0]);
						pDC->MoveTo(pDoc->m_iDx,0);
						pDC->LineTo(pDoc->m_iDx,pDoc->m_iH);
						pDC->MoveTo(0,pDoc->m_iDy);
						pDC->LineTo(pDoc->m_iL,pDoc->m_iDy);

						pDC->SelectObject(pOldPen);

						MarqueDePointage(&dc,pDoc->m_iDx,pDoc->m_iDy,1);
						
						short i,j;
						float h;
						long w;
						pDC->MoveTo(0,0);
						for (i=0;i<pDoc->m_iL;i++)
						{
							h=pDoc->Altitude(pDoc->image,i,pDoc->m_iDy,pDoc->m_fScanning);
							w=(long)(255.0*h/25.0);
							pDC->LineTo(i,pDoc->m_iH-w);

						}
						pDC->MoveTo(0,0);
						for (i=0;i<pDoc->m_iH;i++)
						{
							h=pDoc->Altitude(pDoc->image,pDoc->m_iDx,i,pDoc->m_fScanning);
							w=(long)(255.0*h/25.0);
							pDC->LineTo(w,i);
						}
					}
				}
				else
				{
					if (pDoc->m_iDx!=0 && pDoc->m_iDy!=0)	
					{
						MarqueDePointage(&dc,pDoc->m_iDx,pDoc->m_iDy,1);
					}
				}
				if (pDoc->m_p.OK) pDoc->CalculProfils(pDoc->m_p.radioRouge,pDoc->m_p.iX1,pDoc->m_p.iY1,pDoc->m_p.iX2,pDoc->m_p.iY2);
				if (pDoc->m_p.OK && pDoc->m_iType&4) ProfilH(&dc);
				if (pDoc->m_p.OK && pDoc->m_iType&8) ProfilV(&dc);
				if (pDoc->m_p.OK && pDoc->m_iType&16) GaussH(&dc);
				if (pDoc->m_p.OK && pDoc->m_iType&32) GaussV(&dc);
				if (pDoc->m_iType&64) DessineCotation(&dc);
			}
		}
	}
}
//________________________________________
void CBkView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	short x,y;
	CBkDoc* pDoc=GetDocument();
	//Mmoriser le pointeur sur la fentre et la vue dans le document
	pDoc->m_pWnd=GetParent();
	pDoc->m_pView=this;

	if (pDoc->m_iL<800)
		x=pDoc->m_iL;
	else
		x=800;
	if (pDoc->m_iH<600)
		y=pDoc->m_iH;
	else
		y=600;
	SetScrollSizes(MM_TEXT, CSize(pDoc->m_iL,pDoc->m_iH));
	pDoc->DimensionnerFenetre(x,y);
	/*
	//Carte d'imagerie Meteor_______________
	//Carte d'imagerie Orion________________
	if (m_pApp->m_iCarte==1 || m_pApp->m_iCarte==2) AllocateDisplay();
	*/
	m_iPas=2;
}
//________________________________________
void CBkView::MAJ_Fen()
{
	CBkDoc* pDoc=GetDocument();
	CRect r;
	GetParent()->GetWindowRect(r);
	ScreenToClient(r);
	InvalidateRect(r,FALSE);
	pDoc->UpdateAllViews(this,(LPARAM)(LPCRECT)r);
}
//////////////////////////////////////////
// CBkView printing
BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
//________________________________________
void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}
//________________________________________
void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
//////////////////////////////////////////
// CBkView diagnostics
#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CScrollView::AssertValid();
}
//________________________________________
void CBkView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
//________________________________________
CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*)m_pDocument;
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkView message handlers
void CBkView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	CBkDoc* pDoc=GetDocument();
	long x,y;
	x=lpClientRect->right-lpClientRect->left;
	y=lpClientRect->bottom-lpClientRect->top;
	//Si la taille de la fentre est plus grande que l'image, on la limite
	if (x>pDoc->m_iL && y>pDoc->m_iH) pDoc->LimiterTailleFenetre(pDoc->m_iL,pDoc->m_iH);
	CScrollView::CalcWindowRect(lpClientRect,nAdjustType);
}
//________________________________________
void CBkView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
	//ScrollWindow(pDoc->m_iXpos,pDoc->m_iYpos,NULL,NULL);
	CScrollView::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CBkView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
	//ScrollWindow(pDoc->m_iXpos,pDoc->m_iYpos,NULL,NULL);
	CScrollView::OnVScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CBkView::OnSize(UINT nType, int cx, int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	
	//Visualisation 3D______________________
  if(cy>0 && GetDocument()->m_iType&1)
  {    
		//Taille fentre OpenGl
		glViewport(0,0,cx,cy);
    if((m_oldRect.right > cx) || (m_oldRect.bottom > cy)) RedrawWindow();
    m_oldRect.right=cx;
    m_oldRect.bottom=cy;
		//Modification de la matrice de projection
    glMatrixMode(GL_PROJECTION);
		//Vider la matrice de projection
    glLoadIdentity();
		//Cration matrice de vision en perspective
    gluPerspective(45.0f, (GLdouble)cx/cy,3.0f,7.0f);
    glMatrixMode(GL_MODELVIEW);
  }
	
	//______________________________________
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
}
//________________________________________
void CBkView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CRect r;
	short x,y;
	CBkDoc* pDoc=GetDocument();
	if (!m_pApp->GrabIsStarted)
	{
		x=point.x+pDoc->m_iXpos;
		y=point.y+pDoc->m_iYpos;
		if (nFlags==MK_LBUTTON && m_pApp->m_pProfilDlg!=NULL)
		{
				//Trac d'un segment profil
				m_pApp->m_pProfilDlg->Affecte(pDoc->m_iDx,pDoc->m_iDy,x,y);
				MAJ_Fen();
		}
		else
		if (nFlags==MK_LBUTTON && m_pApp->m_pCoteDlg!=NULL)
		{
				//Trac d'un segment profil
				m_pApp->m_pCoteDlg->Affecte(pDoc->m_iDx,pDoc->m_iDy,x,y);
				MAJ_Fen();
		}
		else
		{
			//Coordonnes absolues, il faut tenir compte des barres de dfilement
			pDoc->m_iX=(short)point.x+pDoc->m_iXpos;
			pDoc->m_iY=(short)point.y+pDoc->m_iYpos;
			pDoc->m_iW=getpixelcolor(pDoc->image,pDoc->m_iX,pDoc->m_iY);
		}
	}
	CScrollView::OnMouseMove(nFlags, point);
}
//________________________________________
void CBkView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	short x,y;
	CRect rect;
	CRectTracker tracker;
	CBkDoc* pDoc=GetDocument();
	if (!m_pApp->GrabIsStarted)
	{
		x=point.x+pDoc->m_iXpos;
		y=point.y+pDoc->m_iYpos;
		//Coordonnes relatives
		pDoc->m_iDx=x;
		pDoc->m_iDy=y;
		pDoc->m_iDw=getpixelcolor(pDoc->image,x,y);
		if (m_pApp->m_pMasqueDlg!=NULL || m_pApp->m_pExtractDlg!=NULL)
		{
			//Fentre graphique
			pDoc->m_tracker.GetTrueRect(rect);
			if (pDoc->m_tracker.HitTest(point)<0)
			{
				if (tracker.TrackRubberBand(this,point,TRUE))
				{
					//MessageBeep(0);//Beep
					tracker.m_rect.NormalizeRect();
					//if (rect.IntersectRect(tracker.m_rect, pDoc->m_tracker.m_rect))
					{
						if (pDoc->m_tracker.m_nStyle & CRectTracker::resizeInside)
						{
							pDoc->m_tracker.m_nStyle &= ~CRectTracker::resizeInside;
							pDoc->m_tracker.m_nStyle |= CRectTracker::resizeOutside;
						}
						else
						{
							pDoc->m_tracker.m_nStyle &= ~CRectTracker::resizeOutside;
							pDoc->m_tracker.m_nStyle |= CRectTracker::resizeInside;
						}
					}
				}
				//Mise  jour des coordonnes
				pDoc->m_tracker.m_rect=tracker.m_rect;
			}
			else
			if (pDoc->m_tracker.Track(this,point,FALSE))
			{
				//Quand on dplace la zone digitalise...
			}
			MAJ_Fen();
		}
		else
		if (m_pApp->m_pProfilDlg!=NULL)
		{
			//Suppression profils existants
			pDoc->m_p.iX1=-1;pDoc->m_p.iY1=-1;
			pDoc->m_p.iX2=-1;pDoc->m_p.iY2=-1;
			MAJ_Fen();
			m_pApp->m_pProfilDlg->MAJ();
		}
		else
		if (m_pApp->m_pCoteDlg!=NULL)
		{
			MAJ_Fen();
			m_pApp->m_pCoteDlg->MAJ();
		}
		/*
		else
		if (m_pApp->m_pZoomDlg!=NULL)
		{
			m_pApp->m_pZoomDlg->MAJ();
		}
		*/
		else
		
		{
			MAJ_Fen();
		}
	}
	CScrollView::OnLButtonDown(nFlags, point);
}
//________________________________________
void CBkView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	class CBkDoc* pDoc=GetDocument();
	CMenu menu;
	BOOL ok=menu.LoadMenu(IDR_POPUP);
	CMenu* pPopup=menu.GetSubMenu(0);
	if (m_pApp->GrabIsStarted)
	{
		menu.EnableMenuItem(ID__CUR_SOURIS,MF_GRAYED);
	}
	if (pPopup!=NULL) pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,NULL);
}
//________________________________________
void CBkView::MarqueDePointage(CDC *pDC,short x,short y,short NoPlume)
{
	CPen *pOldPen;
	short i,j,X,Y;

	class CBkDoc *pDoc=GetDocument();
	X=x-pDoc->m_iXpos;
	Y=y-pDoc->m_iYpos;
	pOldPen=pDC->SelectObject(&m_pApp->plume[0]);//0: plume de contour
	pDC->MoveTo(X-3,Y-3);
	pDC->LineTo(X+3,Y-3);
	pDC->LineTo(X+3,Y+3);
	pDC->LineTo(X-3,Y+3);
	pDC->LineTo(X-3,Y-3);
	pDC->SelectObject(&m_pApp->plume[NoPlume]);
	for (i=X-2;i<=X+2;i++)
	{
		pDC->MoveTo(i,Y-2);
		pDC->LineTo(i,Y+3);
	}
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::SegmentProfil(CDC *pDC)
{
	class CBkDoc *pDoc=GetDocument();
	CPen *pOld;
	pOld=pDC->SelectObject(&m_pApp->plume[2]);
	MarqueDePointage(pDC,pDoc->m_p.iX1,pDoc->m_p.iY1,2);
	MarqueDePointage(pDC,pDoc->m_p.iX2,pDoc->m_p.iY2,2);
	pDC->MoveTo(pDoc->m_p.iX1-pDoc->m_iXpos,pDoc->m_p.iY1-pDoc->m_iYpos);
	pDC->LineTo(pDoc->m_p.iX2-pDoc->m_iXpos,pDoc->m_p.iY2-pDoc->m_iYpos);
	pDC->SelectObject(pOld);
}
//________________________________________
void CBkView::ProfilH(CDC *pDC)
{
	short 
		X1,Y1,X2,Y2,
		i;
	CBkDoc* pDoc=GetDocument();
	CPen
		*pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[3]);

	//Trac profil H...
	if (pDoc->m_p.iX1!=-1 && pDoc->m_p.iY1!=-1 && pDoc->m_p.iX2!=-1 && pDoc->m_p.iY2!=-1)
	{
		SegmentProfil(pDC);
		X1=pDoc->m_p.iX1-pDoc->m_iXpos;
		Y1=pDoc->m_p.iY1-pDoc->m_iYpos;
		X2=pDoc->m_p.iX2-pDoc->m_iXpos;
		Y2=pDoc->m_p.iY2-pDoc->m_iYpos;

		pDC->MoveTo(X1,pDoc->m_iH-0-pDoc->m_iYpos);
		pDC->LineTo(X1,pDoc->m_iH-255-pDoc->m_iYpos);
		pDC->LineTo(X2,pDoc->m_iH-255-pDoc->m_iYpos);
		pDC->LineTo(X2,pDoc->m_iH-0-pDoc->m_iYpos);
		pDC->LineTo(X1,pDoc->m_iH-0-pDoc->m_iYpos);
		
		if (pDoc->m_fT[0][0]!=1e10 && pDoc->m_fT[0][1]!=1e10)
			pDC->MoveTo((short)(pDoc->m_fT[0][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[0][1]-pDoc->m_iYpos));
		for (i=1;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][0]!=1e10 && pDoc->m_fT[i][1]!=1e10)
				pDC->LineTo((short)(pDoc->m_fT[i][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[i][1]-pDoc->m_iYpos));
		}
	} 
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::ProfilV(CDC *pDC)
{
	short 
		X1,Y1,X2,Y2,
		i;
	CBkDoc* pDoc=GetDocument();
	CPen *pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[4]);

	//Trac profil V...
	if (pDoc->m_p.iX1!=-1 && pDoc->m_p.iY1!=-1 && pDoc->m_p.iX2!=-1 && pDoc->m_p.iY2!=-1)
	{
		SegmentProfil(pDC);
		X1=pDoc->m_p.iX1-pDoc->m_iXpos;
		Y1=pDoc->m_p.iY1-pDoc->m_iYpos;
		X2=pDoc->m_p.iX2-pDoc->m_iXpos;
		Y2=pDoc->m_p.iY2-pDoc->m_iYpos;

		pDC->MoveTo(0-pDoc->m_iXpos,Y1);
		pDC->LineTo(255-pDoc->m_iXpos,Y1);
		pDC->LineTo(255-pDoc->m_iXpos,Y2);
		pDC->LineTo(0-pDoc->m_iXpos,Y2);
		pDC->LineTo(0-pDoc->m_iXpos,Y1);
		
		if (pDoc->m_fT[0][3]!=1e10 && pDoc->m_fT[0][4]!=1e10)
			pDC->MoveTo((short)(pDoc->m_fT[0][3]-pDoc->m_iXpos),(short)(pDoc->m_fT[0][4]-pDoc->m_iYpos));
		for (i=1;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][3]!=1e10 && pDoc->m_fT[i][4]!=1e10)
				pDC->LineTo((short)(pDoc->m_fT[i][3]-pDoc->m_iXpos),(short)(pDoc->m_fT[i][4]-pDoc->m_iYpos));
		}
	} 
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::GaussH(CDC *pDC)
{
	short 
		i,X,Y;
	long w;
	float 
		x,y;
	CBkDoc* pDoc=GetDocument();
	CPen *pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[3]);
	//Trac gaussienne H...
	if (pDoc->m_p.iX1!=-1 && pDoc->m_p.iY1!=-1 && pDoc->m_p.iX2!=-1 && pDoc->m_p.iY2!=-1)
	{
		SegmentProfil(pDC);
		//Trac gaussienne horizontale thorique
		if (pDoc->m_fT[0][0]!=1e10 && pDoc->m_fT[0][2]!=1e10)
			pDC->MoveTo((short)(pDoc->m_fT[0][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[0][2]-pDoc->m_iYpos));
		for (i=1;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][0]!=1e10 && pDoc->m_fT[i][2]!=1e10)
				pDC->LineTo((short)(pDoc->m_fT[i][0]-pDoc->m_iXpos),(short)(pDoc->m_iH-pDoc->m_fT[i][2]-pDoc->m_iYpos));
		}
		//Matrialisation IMax/e                 
		//Maxi
		w=0;
		for (i=0;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][2]!=1e10)
			{
				if (pDoc->m_fT[i][2]>w) w=(int)pDoc->m_fT[i][2];
			}
		}
		i=0;
		do
		{
			if (pDoc->m_fT[i][2]!=1e10)
			{ 
				y=pDoc->m_fT[i][2];x=pDoc->m_fT[i][0];
			}
			else
			{
				x=0;y=0;
			}
			i++;
		}
		while (i<pDoc->m_iNbMax && y<1.0*w/7.39);
		y=-y+pDoc->m_iH;

		
		if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)
		{
			MarqueDePointage(pDC,x,y,3);//Plume n3
		}
		i=pDoc->m_iNbMax;
		do
		{
			if (pDoc->m_fT[i][2]!=1e10)
			{ 
				y=pDoc->m_fT[i][2];x=pDoc->m_fT[i][0];
			}
			else
			{
				x=0;y=0;
			}
			i--;
		}
		while (i>0 && y<1.0*w/7.39);
		y=-y+pDoc->m_iH;
		if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)		
		{
			MarqueDePointage(pDC,x,y,3);//Plume n3
		}
	}
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::GaussV(CDC *pDC)
{
	CBkDoc* pDoc=GetDocument();
	short 
		i,X,Y;
	long w;
		float 
			x,y;
	CPen *pOldPen;

	pOldPen=pDC->SelectObject(&m_pApp->plume[4]);
	//Trac gauss V...
	if (pDoc->m_p.iX1!=-1 && pDoc->m_p.iY1!=-1 && pDoc->m_p.iX2!=-1 && pDoc->m_p.iY2!=-1)
	{
		SegmentProfil(pDC);
		//Trac gaussienne verticale
		if (pDoc->m_fT[0][4]!=1e10 && pDoc->m_fT[0][5]!=1e10)
			pDC->MoveTo((short)(pDoc->m_fT[0][5]-pDoc->m_iXpos),(short)(pDoc->m_fT[0][4]-pDoc->m_iYpos));
		for (i=1;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][4]!=1e10 && pDoc->m_fT[i][5]!=1e10)
				pDC->LineTo((short)(pDoc->m_fT[i][5]-pDoc->m_iXpos),(short)(pDoc->m_fT[i][4]-pDoc->m_iYpos));
		}
		//Matrialisation IMax/e                 
		//Maxi
		w=0;
		for (i=0;i<pDoc->m_iNbMax;i++)
		{
			if (pDoc->m_fT[i][5]!=1e10)
			{
				if (pDoc->m_fT[i][5]>w) w=(int)pDoc->m_fT[i][5];
			}
		}
		i=0;
		do
		{
			if (pDoc->m_fT[i][5]!=1e10)
			{ 
				x=pDoc->m_fT[i][5];y=pDoc->m_fT[i][4];
			}
			else
			{
				x=0;y=0;
			}
			i++;
		}
		while (i<pDoc->m_iNbMax && x<1.0*w/7.39);
		if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)
		{
			MarqueDePointage(pDC,x,y,4);//Plume n4
		}
		i=pDoc->m_iNbMax;
		do
		{
			if (pDoc->m_fT[i][5]!=1e10)
			{ 
				x=pDoc->m_fT[i][5];y=pDoc->m_fT[i][4];
			}
			else
			{
				x=0;y=0;
			}
			i--;
		}
		while (i>0 && x<1.0*w/7.39);
		if (x>0 && x<pDoc->m_iL && y>=0 && y<pDoc->m_iH)
		{
			MarqueDePointage(pDC,x,y,4);//Plume n4
		}
	}
	pDC->SelectObject(pOldPen);
}
//________________________________________
void CBkView::DessineCotation(CDC *pDC)
{
	CGeoAna g;
	short 
		i,X1,Y1,X2,Y2,no;
	float a,d;
	CRgn Region1,Region2;
	class CBkDoc *pDoc=GetDocument();

	CFont *pOldF;
	CPen *pOld;
	pOld=pDC->SelectObject(&m_pApp->plume[5]);

	pOldF=pDC->SelectObject(&m_pApp->fonteC[0]);
	pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	COLORREF clrOld=pDC->SetTextColor(m_pApp->couleur[5]);
	int nOldMode=pDC->SetBkMode(TRANSPARENT);
	for (no=0;no<8;no++)
	{
		if (pDoc->m_c.s[no].GetLength()>0)
		{
			X1=pDoc->m_c.x1[no]-pDoc->m_iXpos;
			Y1=pDoc->m_c.y1[no]-pDoc->m_iYpos;
			X2=pDoc->m_c.x2[no]-pDoc->m_iXpos;
			Y2=pDoc->m_c.y2[no]-pDoc->m_iYpos;

			MarqueDePointage(pDC,X1,Y1,5);//Plume n5
			MarqueDePointage(pDC,X2,Y2,5);//Plume n5
			
			pDC->MoveTo(X1,Y1);
			pDC->LineTo(X2,Y2);

			g.d2p(X1,Y1,X2,Y2,&a,&d);
			//Angle d'orientation de la fonte
			float PI=4*atan(1);
			i=(short)(180*a/3.14);
			if (i<-90) i=90;
			if (i>89) i=89;
			//Slection fonte incline
			pDC->SelectObject(&m_pApp->fonteC[i+90]);
			pDC->TextOut((X2+X1)/2+(short)(sin(a)*3),(Y2+Y1)/2-(short)(cos(a)*2),pDoc->m_c.s[no]);
		}
	}
	pDC->SetTextColor(clrOld);
	pDC->SelectObject(pOld);
	pDC->SelectObject(pOldF);
	pDC->SetBkMode(nOldMode);
}
//________________________________________
void CBkView::TraceTracker(CDC *pDC,char Type)
{
	class CBkDoc* pDoc=GetDocument();
	CPen *pOld;
	pOld=pDC->SelectObject(&m_pApp->plume[7]);
	pDoc->m_tracker.Draw(pDC);
	if (Type==0)
	{
		//Rectangle
	}
	else
	{
		//Ellipse
		pDC->Arc(pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.bottom,pDoc->m_tracker.m_rect.right,pDoc->m_tracker.m_rect.top,pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.bottom,pDoc->m_tracker.m_rect.left,pDoc->m_tracker.m_rect.bottom);
	}
	pDC->SelectObject(pOld);        
}
//________________________________________
void CBkView::AllocateDisplay()
{
	//Carte d'imagerie Meteor________________
	//Carte d'imagerie Orion_________________
	/*
	class CBkDoc *pDoc=GetDocument();
	if (m_pApp->m_iCarte==1 || m_pApp->m_iCarte==2) 
	{	
		if (pDoc->MilImage)
		{
			//Allocate a display
			MdispAlloc(m_pApp->MilSystem,	M_DEFAULT, M_DISPLAY_SETUP, M_DEFAULT, &(pDoc->MilDisplay));
			// Do not allow example to run in dual screen mode
			if(MdispInquire(pDoc->MilDisplay, M_DISPLAY_MODE, M_NULL)!=M_WINDOWED)             
			{
				MessageBox("This program does not run in dual screen mode.",
					"MdispMFC example", MB_ICONINFORMATION );
				MdispFree(pDoc->MilDisplay);
				pDoc->MilDisplay=(MIL_ID) NULL;
			}
			if (pDoc->MilDisplay)
			{
				//Disable scroll bars on display
   			MdispControl(pDoc->MilDisplay,M_WINDOW_SCROLLBAR,M_DISABLE);
   			//Select the buffer from it's display object and given window
   			MdispSelectWindow(pDoc->MilDisplay,pDoc->MilImage,m_hWnd);
			}
		}
	}
	*/
}
//Visualisation 3D________________________
short CBkView::Init(CDC *pDC)
{
  PIXELFORMATDESCRIPTOR pfd;
  int     n;
	HGLRC		hrc;
	GLfloat fMaxObjSize,fAspect;
	GLfloat	fNearPlane,fFarPlane;

  if (!bSetupPixelFormat(pDC))
	{
		AfxMessageBox("Erreur bSetupPixelFormat !");
		return-2;
	}
  n=::GetPixelFormat(pDC->GetSafeHdc());
  ::DescribePixelFormat(pDC->GetSafeHdc(),n,sizeof(pfd), &pfd);
  //Invalid le 08/10/03, a fonctionne quand mme !!
	//CreateRGBPalette(pDC);
  hrc=wglCreateContext(pDC->GetSafeHdc());
	if (hrc==NULL)
	{
		AfxMessageBox("Erreur wglCreateContext !");
		return-3;
	}
  if (!wglMakeCurrent(pDC->GetSafeHdc(),hrc))
	{
		AfxMessageBox("Erreur wglMakeCurrent !");
		return-4;
	}
  GetClientRect(&m_oldRect);
  glClearDepth(1.0f);
  glEnable(GL_DEPTH_TEST);
	if (m_oldRect.bottom)
		fAspect=(GLfloat)m_oldRect.right/m_oldRect.bottom;
	else	// don't divide by zero, not that we should ever run into that...
		fAspect=1.0f;

	fNearPlane=3.0f;
	fFarPlane=7.0f;
	fMaxObjSize=3.0f;
	m_pApp->m_fRadius=fNearPlane + fMaxObjSize/2.0f;
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0f,fAspect,fNearPlane,fFarPlane);
  glMatrixMode(GL_MODELVIEW);
	return 0;
}
//________________________________________
void CBkView::Libere(CDC *pDC)
{
	HGLRC	hrc;
	hrc=::wglGetCurrentContext();
  ::wglMakeCurrent(NULL,NULL);
  if (hrc) ::wglDeleteContext(hrc);
  //Invalid le 08/10/03, a fonctionne quand mme !!
  //if (m_pOldPalette) pDC->SelectPalette(m_pOldPalette,FALSE);

  //if (m_pDC) delete m_pDC;
}
//________________________________________
void CBkView::DrawScene()
{
	class CBkDoc *pDoc=GetDocument();
	short i,j;
	long w,w1;
	float r,v,b;

  if(m_pApp->m_bBusy)	return;
    
	m_pApp->m_bBusy=TRUE;
  //Couleur de vidage
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	//Vidage fentre
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//Fait descendre d'un niveau toutes les matrices de la pile. Voir fonction OnSize
  glPushMatrix();

  glTranslatef(0.0f, 0.0f,-m_pApp->m_fRadius);
	glRotatef(m_pApp->m_fAngleX, 1.0f, 0.0f, 0.0f);
  glRotatef(m_pApp->m_fAngleY, 0.0f, 1.0f, 0.0f);
  glRotatef(m_pApp->m_fAngleZ, 0.0f, 0.0f, 1.0f);
	if (m_iPas<1) m_iPas=1;
	if (m_iPas>2) m_iPas=2;
	glBegin(GL_POINTS);
	for(i=5;i<pDoc->m_iL-5;i=i+m_iPas)
	{
		for (j=5;j<pDoc->m_iH-20;j=j+m_iPas)
		{
			w=getpixelcolor(pDoc->image,i,j);
			w=w&255;
			w1=w*4;
			w1=1023-w1;
			if (w1<256)
			{
				r=0;
				v=w1;
				b=255;
			}
			else
			if (w1>=256 && w1<512)
			{
				b=511-w1;
				v=255;
				r=w1-256;
			}
			else
			if (w1>=512 && w1<768)
			{
				r=255;
				v=767-w1;
				b=0;
			}
			else
			{
				r=1023-w1;
				b=w1-768;
				v=0;
			}

			r=r/255;
			v=v/255;
			b=b/255;

			glColor3f(r,v,b);
			if (w!=0)
				glColor3f(r,v,b);
			else
				glColor3f(0,0,0);
			glVertex3f((float)0.004*(i-pDoc->m_iL/2),(float) 0.004*(j-pDoc->m_iH/2), (float)0.004*w);
		}
	}
	glEnd();
  glPopMatrix();
  glFinish();
  SwapBuffers(wglGetCurrentDC());
  m_pApp->m_bBusy=FALSE;
}
//________________________________________
BOOL CBkView::bSetupPixelFormat(CDC *pDC)
{
  static PIXELFORMATDESCRIPTOR pfd = 
	{
    sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
    1,                              // version number
    PFD_DRAW_TO_WINDOW |            // support window
    PFD_SUPPORT_OPENGL |						// support OpenGL
    PFD_DOUBLEBUFFER,								// double buffered
    PFD_TYPE_RGBA,                  // RGBA type
    24,                             // 24-bit color depth
    0, 0, 0, 0, 0, 0,               // color bits ignored
    0,                              // no alpha buffer
    0,                              // shift bit ignored
    0,                              // no accumulation buffer
    0, 0, 0, 0,                     // accum bits ignored
    32,                             // 32-bit z-buffer
    0,                              // no stencil buffer
    0,                              // no auxiliary buffer
    PFD_MAIN_PLANE,                 // main layer
    0,                              // reserved
    0, 0, 0                         // layer masks ignored
  };
  int pixelformat;
  if ( (pixelformat = ChoosePixelFormat(pDC->GetSafeHdc(), &pfd)) == 0 )
  {
    AfxMessageBox("ChoosePixelFormat failed");
    return FALSE;
  }
  if (SetPixelFormat(pDC->GetSafeHdc(), pixelformat, &pfd) == FALSE)
  {
	   AfxMessageBox("SetPixelFormat failed");
     return FALSE;
  }
  return TRUE;
}
//________________________________________
