// CalbDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CalbDlg.h"
#include "CalcDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCalbDlg dialog
CCalbDlg::CCalbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalbDlg)
	m_OKCalb = FALSE;
	m_OKXY = FALSE;
	m_OKZ = FALSE;
	m_s = _T("");
	m_fPixX = 0.0f;
	m_fMmX = 0.0f;
	m_fWZ = 0.0f;
	m_fMmZ = 0.0f;
	//}}AFX_DATA_INIT
}
void CCalbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalbDlg)
	DDX_Control(pDX, IDSPEC_MOIRE, m_btnSpeck);
	DDX_Check(pDX, IDC_NOUV_IM, m_OKCalb);
	DDX_Check(pDX, IDC_COORD_XY, m_OKXY);
	DDX_Check(pDX, IDC_COORD_Z, m_OKZ);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_PIXX, m_fPixX);
	DDX_Text(pDX, IDC_MMX, m_fMmX);
	DDX_Text(pDX, IDC_W, m_fWZ);
	DDX_Text(pDX, IDC_MMZ, m_fMmZ);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCalbDlg, CDialog)
	//{{AFX_MSG_MAP(CCalbDlg)
	ON_BN_CLICKED(IDC_COORD_XY, OnCoordXy)
	ON_BN_CLICKED(IDC_COORD_Z, OnCoordZ)
	ON_BN_CLICKED(IDSPEC_MOIRE, OnMoire)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CCalbDlg message handlers
BOOL CCalbDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	if(m_pApp->m_OKCalb) m_OKCalb=TRUE;
	m_OKXY=m_pDoc->m_OKXY;
	m_OKZ=m_pDoc->m_OKZ;
	if (!m_OKXY && !m_OKZ)
	{
		GetDlgItem(IDC_NOUV_IM)->EnableWindow(FALSE);
		m_OKCalb=FALSE;
	}
	else
		GetDlgItem(IDC_NOUV_IM)->EnableWindow(TRUE);

	
	if (1.0/m_pDoc->m_fEchXY>1)
	{
		m_fPixX=1;
		m_fMmX=1/m_pDoc->m_fEchXY;
	}
	else
	{
		m_fPixX=1*m_pDoc->m_fEchXY;
		m_fMmX=1;
	}

	if (1.0/m_pDoc->m_fEchZ>1)
	{
		m_fWZ=1;
		m_fMmZ=1/m_pDoc->m_fEchZ;
	}
	else
	{
		m_fWZ=1*m_pDoc->m_fEchZ;
		m_fMmZ=1;
	}
	if (m_pDoc->m_iNbB==8)
		m_s.Format("Image courante: %s",m_pDoc->m_sNomFic);
	else
		m_s="Image couleur: Calibrage en z sur composante rouge UNIQUEMENT !";
	if (!m_OKXY)
	{
		GetDlgItem(IDC_PIXX)->EnableWindow(FALSE);
		GetDlgItem(IDC_MMX)->EnableWindow(FALSE);
	}
	if (!m_OKZ)
	{
		GetDlgItem(IDC_W)->EnableWindow(FALSE);
		GetDlgItem(IDC_MMZ)->EnableWindow(FALSE);
		m_btnSpeck.EnableWindow(FALSE);
	}

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CCalbDlg::OnOK() 
{
	float x,z;
	UpdateData(TRUE);
	if (m_OKXY)
	{
		//En mm suivant XY
		m_fPixX=fabs(m_fPixX);
		if (m_fPixX==0) m_fPixX=1;
		m_fMmX=fabs(m_fMmX);
		if (m_fMmX==0) m_fMmX=1;

		x=m_fPixX/m_fMmX;
		m_pDoc->m_fEchXY=x;
		//Facteur suivant xy
		x=m_pDoc->m_iL/x;
		m_pDoc->m_fFactXY=1e-10;
		do
		{
			m_pDoc->m_fFactXY=m_pDoc->m_fFactXY*10;
		}
		while (fabs(x*m_pDoc->m_fFactXY)<1);	
		if (x*m_pDoc->m_fFactXY<2) m_pDoc->m_fFactXY=m_pDoc->m_fFactXY*10;
	}
	else
	{
		//En pixel
	}
	if (m_OKZ)
	{
		m_fWZ=fabs(m_fWZ);
		if (m_fWZ==0) m_fWZ=1;
		m_fMmZ=fabs(m_fMmZ);
		if (m_fMmZ==0) m_fMmZ=1;
		m_pDoc->m_fEchZ=m_fWZ/m_fMmZ;
		//Facteur suivant z: maxi 10 mm
		z=10.0/m_pDoc->m_fEchZ;
		m_pDoc->m_fFactZ=1e-10;
		do
		{
			m_pDoc->m_fFactZ=m_pDoc->m_fFactZ*10;
		}
		while (fabs(z*m_pDoc->m_fFactZ)<=0.1);
		//CString z;
		//z.Format("%f, %f",m_pDoc->m_fEchZ,m_pDoc->m_fFactZ);
		//AfxMessageBox(z);
	}
	m_pApp->m_OKCalb=m_OKCalb;
	if (m_OKCalb)
	{
		//Calibration applique  toutes les nouvelles images
		m_pApp->m_fEchXY=m_pDoc->m_fEchXY;
		m_pApp->m_fEchZ=m_pDoc->m_fEchZ;
		m_pApp->m_fFactXY=m_pDoc->m_fFactXY;
		m_pApp->m_fFactZ=m_pDoc->m_fFactZ;
	}
	m_pDoc->m_OKXY=m_OKXY;
	m_pDoc->m_OKZ=m_OKZ;
	CDialog::OnOK();
}
//________________________________________
void CCalbDlg::OnCoordXy() 
{
	UpdateData(TRUE);
	if (!m_OKXY)
	{
		GetDlgItem(IDC_PIXX)->EnableWindow(FALSE);
		GetDlgItem(IDC_MMX)->EnableWindow(FALSE);
		m_s="Units x&y: pixel";
	}
	else
	{
		GetDlgItem(IDC_PIXX)->EnableWindow(TRUE);
		GetDlgItem(IDC_MMX)->EnableWindow(TRUE);
		m_s="Units x&y: mm";
	}

	if (!m_OKXY && !m_OKZ) 
	{
		GetDlgItem(IDC_NOUV_IM)->EnableWindow(FALSE);
		m_OKCalb=FALSE;
	}
	else
		GetDlgItem(IDC_NOUV_IM)->EnableWindow(TRUE);
	UpdateData(FALSE);
}
//________________________________________
void CCalbDlg::OnCoordZ() 
{
	UpdateData(TRUE);	
	if (!m_OKZ)
	{
		GetDlgItem(IDC_W)->EnableWindow(FALSE);
		GetDlgItem(IDC_MMZ)->EnableWindow(FALSE);
		m_btnSpeck.EnableWindow(FALSE);
		m_s="Unit z: luminance [0, 255]";
	}
	else
	{
		GetDlgItem(IDC_W)->EnableWindow(TRUE);
		GetDlgItem(IDC_MMZ)->EnableWindow(TRUE);
		m_btnSpeck.EnableWindow(TRUE);
		m_s="Unit z: mm";
	}
	if (!m_OKXY && !m_OKZ)
	{
		GetDlgItem(IDC_NOUV_IM)->EnableWindow(FALSE);
		m_OKCalb=FALSE;
	}
	else
		GetDlgItem(IDC_NOUV_IM)->EnableWindow(TRUE);
	UpdateData(FALSE);
}
//________________________________________
void CCalbDlg::OnMoire() 
{
	CCalcDlg d;
	if (d.DoModal()==IDOK)
	{
		m_fWZ=1;
		m_fMmZ=m_pDoc->m_fEchZ;
		UpdateData(FALSE);
	}
}
