// Demodul.h : header file
//
#include "vicdefs.h"
/////////////////////////////////////////////////////////////////////////////
const long V_ADD=0;
const long V_BIN=1;
const long V_NOT=2;
const long V_AND=3;
const long V_MUL=4;
const long V_SUB=5;
//__________________________________________________
//Classe CDemodul, dmodulation images phases
class CDemodul : public CWnd
{
// Construction
public:
	CDemodul(class CBkDoc *,class CBkDoc *,long,class CBkDoc *,class CBkDoc *,class CBkDoc *);

// Attributes
public:

// Operations
public:
 	CStringArray m_liste;
protected:
	void Ajoute(CString s);
	class CBkApp* m_pApp;
	class CBkDoc *m_pIn,*m_pOut,*m_pLabel,*m_pCorrection,*m_pMasque;
	struct fn
	{
		short x,y;
	};
	typedef struct fn file_node;
	file_node *(f[55]);
	//file_node* *file[55];
	//file_node* *file_fin[55];
	long repartition[55];
	long *file;
	long *file_fin;

	short *pt_lapl,*pt_image,*pt_corr;
	short n_zone;
	//long pix_per_row;

	//Images correspondantes au document
	imgdes *in,*out,*labl,*correction,*brouillon,*imt,*mask;
	//Type d'oprations  raliser
	long mode,qual;

public:
	//1. Fonctions logiques
	void IpBoolimg(imgdes*,imgdes*,imgdes*,long);
	void IpBoolVal(imgdes*,long,imgdes*,long);
	//2. Fonctions arithmtiques
	void IpAritval(imgdes*,double,imgdes*,long);
	void IpAritimg(imgdes* nfi1,imgdes* nfi2,imgdes* nfo,const long mode);
	//3. Valeur absolue
	void IpAbs(imgdes*,imgdes*);
	//4. Masquage
	void IpMask(imgdes*,imgdes*,imgdes*);
	//5. Anamorphose
	void IpAnam(imgdes*,imgdes*,long*,long*,long,long);
	//6. Seuillage
	void IpThr(imgdes*,imgdes*,float*,float*,long);
	//7. Dilatation
	void IpDilate(imgdes*,imgdes*,long);
	//8. Erosion
	void IpErode(imgdes*,imgdes*,long);
	//9. Reconstruction
	void IpRecon(imgdes*,imgdes*,imgdes*);
	//10. Histogramme
	void IpHisto(imgdes*,long,long,long*,long*,long*);
	//11. Comparaison de deux images
	BOOL IpCompare(imgdes* nfi1,imgdes* nfi2);
	//Fonctions de mrite_____________________________
	//1. Moindres carrs 3x3
	int smincarre(imgdes*,imgdes*);
	//2. Reprage des points foireux (dtection des discontinuits)
	int sptsfoi(imgdes*,imgdes*);
	//3. Variance
	int sunwvar(imgdes*,imgdes*);
	//4. Linarit
	int sunlin(imgdes*,imgdes*);
	//5. Filtre maison
	int sunwfilt(imgdes*,imgdes*);
	//6. Moindres carrs 5x5
	int s55mincarre(imgdes*,imgdes*);
	//7. Laplacien
	int sunwlapl(imgdes*,imgdes*);
	//________________________________________________
	short sdewrap(void);

protected:
	//Signe___________________________________________
	short signe(short);
	//Unwrapping du point_____________________________
	short unw(short,short);
	//Valeur abs de a-b_______________________________
	short hum(short,short);
	//?b______________________________________________
	short d(short,short);
	//________________________________________________
	short diff(short,short);

	//Recherche du premier point d'intensit nulle au voisinage de x et y
	int recherche(imgdes*,short*,short*);
	//Dewrapping d'un point
	void ajoute(int);
	//Lecture/Ecriture ligne__________________________
	short WriteRow(imgdes*,short,short*);
	short ReadRow(imgdes*,short,short*);
	short WriteColumn(imgdes*,short,short*);
	void ZeroImage(long w,imgdes* nfi);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDemodul)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDemodul();

	// Generated message map functions
protected:
	//{{AFX_MSG(CDemodul)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
