// FftDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "FftDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include "fft.h"
#include "vicdefs.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CFftDlg dialog
CFftDlg::CFftDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFftDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFftDlg)
	m_s = _T("");
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CFftDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFftDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_STATIC_TEXTE1, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CFftDlg, CDialog)
	//{{AFX_MSG_MAP(CFftDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CFftDlg message handlers
BOOL CFftDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;

	m_pApp->GetDocumentSansCourant(m_pDOC);
	for (i=0;i<20;i++)
	{
		if (m_pDOC[i]!=NULL)
		{
			s.Format("%s",m_pDOC[i]->m_sNomFic);	
			m_comboDest.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboDest.AddString(s);
	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	m_s.Format("Image courante : %s",m_pDoc->m_sNomFic);
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CFftDlg::OnCancel() 
{
	CDialog::OnCancel();
}
//________________________________________
void CFftDlg::OnOK() 
{
	short 
		i,l,h,nbB,l1,h1,nbB1,ld,hd,
		lt,ht,nbBt,
		no;
	float r;
	long w;
	float 
		**tfre,**tfim,**pix;
	class CBkDoc* pd;
	class CFft *pFft=new CFft();;

	m_btnCancel.EnableWindow(FALSE);
	m_btnOK.EnableWindow(FALSE);
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	//Image destination
	//Si l'utilisateur n'a pas touch au combo...
	if (m_comboDest.GetCurSel()<0) 
		pd=m_pDOC[m_comboDest.GetCount()-1];
	else
		pd=m_pDOC[m_comboDest.GetCurSel()];

	//Si la fentre destination des franges n'existe pas, il faut la crer...
	if (pd==NULL)	pd=m_pApp->CreerNouvelleFenetre(m_pDoc->m_iL,m_pDoc->m_iH);

	
	ld=m_pDoc->image->endx-m_pDoc->image->stx+1;
	hd=m_pDoc->image->endy-m_pDoc->image->sty+1;
	nbB=m_pDoc->image->bmh->biBitCount;

	//On ramne l'image  une taille infrieure  512x512 pour gagner du temps
	if (ld>511 || hd>511)
	{
		do
		{
			ld=(short)(1.0*ld*0.95);
			hd=(short)(1.0*hd*0.95);
		}
		while (ld>511 || hd>511);
	}

	//Pour faire fft puissance de 2 immdiatement sup
	//ld,hd:taille image originale
	//l,h: taille image originale puissance de 2
	l=pFft->_ISNextPowerOfTwo(ld);
	h=pFft->_ISNextPowerOfTwo(hd);

	//On met l'image rduite dans l'image temporaire n0
	lt=m_pApp->imt[0]->endx-m_pApp->imt[0]->stx+1;
	ht=m_pApp->imt[0]->endy-m_pApp->imt[0]->sty+1;
	nbBt=m_pApp->imt[0]->bmh->biBitCount;

	if (lt!=l || ht!=h || nbBt!=nbB)
	{
		freeimage(m_pApp->imt[0]);
		allocimage(m_pApp->imt[0],l,h,nbB);
	}
	resize(m_pDoc->image,m_pApp->imt[0]);

	m_s1.Format("Image FFT de %dx%d pixels.\nCalcul en cours...",l,h);
	UpdateData(FALSE);
	
	//Image destination
	l1=pd->image->endx-pd->image->stx+1;
	h1=pd->image->endy-pd->image->sty+1;
	nbB1=pd->image->bmh->biBitCount;
	if (l!=l1 || h!=h1 || nbB1!=8)
	{
		freeimage(pd->image);
		allocimage(pd->image,l,h,8);
		//Dimensionner l'image destination  la taille source
		pd->m_iH=h;
		pd->m_iL=l;
		pd->m_iNbB=8;
	}

	//Calcul de la FFT
	//Allocation mmoire
	//ATTENTION: les tableaux sont dclars en ligne(h->hauteur)-colonnes(l->largeur)
	tfre=pFft->allocate2D(h,l);
	tfim=pFft->allocate2D(h,l);
	pix=pFft->allocate2D(h,l);
	//Initialisation du tableau pix
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{	
			pix[h1][l1]=0;
		}
	}
	//Affectation du tableau pix avec la luminance
	for( h1=0;h1<hd;h1++)
	{
		for( l1=0;l1<ld;l1++)
		{	
			w=getpixelcolor(m_pApp->imt[0],l1,h1);
			pix[h1][l1]=w&255;//8 bits de poids faible uniquement
		}
	}
	//On doit pouvoir y aller
	pFft->fft2d(pix,tfre,tfim,l,h);
	float maxi=-1e10,mini=1e10;
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{
			//Module
			pix[h1][l1]=pow((tfre[h1][l1]*tfre[h1][l1]+tfim[h1][l1]*tfim[h1][l1]),0.5);
			if (fabs(l1-l/2)<1 || fabs(h1-h/2)<1)
			{
				//On exclut les lignes centrales du calcul maxi/mini
			}
			else
			/*
			if ((fabs(l1-l/2)<5 && fabs(h1-h/2)<5))
			{
				//On exclut aussi le centre...
			}
			else
			*/
			{
				if (pix[h1][l1]<mini)
				{
					mini=pix[h1][l1];
				}
				if (pix[h1][l1]>maxi) 
					maxi=pix[h1][l1];
			}
		}
	}
	//CString z;
	//z.Format("Maxi:%f, mini:%f",maxi,mini);
	//AfxMessageBox(z);
	
	//Etendre la luminance dans l'intervalle [0, 255]
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{
			r=255.0*(pix[h1][l1]-mini)/(maxi-mini);
			if (pix[h1][l1]<=maxi && pix[h1][l1]>=mini)
				w=long(r);
			else
				w=255;
			setpixelcolor(pd->image,l1,h1,w);
		}
	}
	//Libration mmoire
	pFft->free2D(tfre,h);
	pFft->free2D(tfim,h);
	pFft->free2D(pix,h);

	//Appliquer le carr...
	for( h1=0;h1<h;h1++)
	{
		for( l1=0;l1<l;l1++)
		{
			w=getpixelcolor(pd->image,l1,h1);
			w=(long)(w*w);
			if (w>255) w=255;
			setpixelcolor(pd->image,l1,h1,w);
		}
	}
	
	//Mettre l'image pd au-dessus
	pd->PositionnerFenetre(20,20);
	pd->DimensionnerFenetre(l,h);
	pd->DefinirCurseurs(l,h);

	pd->m_iType=0;
	pd->m_sNomFic.Format("Fft2D");
	pd->UpdateAllViews(NULL);
	delete pFft;
	m_btnCancel.EnableWindow(TRUE);
	m_btnOK.EnableWindow(TRUE);
	GetDlgItem(IDC_DEST)->EnableWindow(TRUE);
	CDialog::OnOK();
}
//________________________________________
