// MainFrm.cpp : implementation of the CMainFrame class
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "LogDlg.h"
#include "ProfilDlg.h"
#include "MasqueDlg.h"
#include "AjustDlg.h"
#include "MathDlg.h"
#include "MireDlg.h"
#include "DemodDlg.h"
#include "Phas4Dlg.h"
#include "3dDlg.h"
#include "CalbDlg.h"
#include "PseuDlg.h"
#include "TemReDlg.h"
#include "FiltreDlg.h"
#include "MorphoDlg.h"
#include "SeuilDlg.h"
#include "ExtractDlg.h"
#include "ZoomDlg.h"
#include "ConvDlg.h"
#include "FftDlg.h"
#include "CoteDlg.h"
#include "AcqPhasDlg.h"
#include "VideoDlg.h"
#include "SurcoDlg.h"
#include "DepMaDlg.h"
#include "TempsMoyDlg.h"
#include "TailleWeb.h"

//VSI__________________
#include "TopoDlg.h"
#include "PiezoDlg.h"
#include "AltitudeDlg.h"
//PSI__________________
#include "PsiDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMainFrame
IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_FICHIER_OUVRIR, OnUpdateFichierOuvrir)
	ON_COMMAND(ID_FICHIER_OUVRIR, OnFichierOuvrir)
	ON_COMMAND(ID_FICHIER_SAUVER, OnFichierSauver)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_COMMAND(ID_OP_MATH_LOG, OnOpMathLog)
	ON_UPDATE_COMMAND_UI(ID_PROFILS, OnUpdateProfils)
	ON_COMMAND(ID_PROFILS, OnProfils)
	ON_UPDATE_COMMAND_UI(ID_MASQUE, OnUpdateMasque)
	ON_COMMAND(ID_MASQUE, OnMasque)
	ON_UPDATE_COMMAND_UI(ID_ACQFIG, OnUpdateAcqfig)
	ON_COMMAND(ID_ACQFIG, OnAcqfig)
	ON_UPDATE_COMMAND_UI(ID_ACQPERM, OnUpdateAcqperm)
	ON_COMMAND(ID_ACQPERM, OnAcqperm)
	ON_UPDATE_COMMAND_UI(ID_APP_EXIT, OnUpdateAppExit)
	ON_COMMAND(ID_FICHIER_ENREGIS_SOUS, OnFichierEnregisSous)
	ON_COMMAND(ID_AJUSTER_PARAMETRES, OnAjusterParametres)
	ON_COMMAND(ID_MUL_CTE, OnMulCte)
	ON_COMMAND(ID_GENERATION_MIRE, OnGenerationMire)
	ON_COMMAND(ID_DEMODUL, OnDemodul)
	ON_UPDATE_COMMAND_UI(ID_CALCUL_IM_PHASE4, OnUpdateCalculImPhase4)
	ON_COMMAND(ID_CALCUL_IM_PHASE4, OnCalculImPhase4)
	ON_COMMAND(ID_VISU_3D, OnVisu3d)
	ON_COMMAND(ID_CALIBRATION, OnCalibration)
	ON_UPDATE_COMMAND_UI(ID_VISU_PSEUDO, OnUpdateVisuPseudo)
	ON_COMMAND(ID_VISU_PSEUDO, OnVisuPseudo)
	ON_UPDATE_COMMAND_UI(ID_TEMPS_REEL, OnUpdateTempsReel)
	ON_COMMAND(ID_TEMPS_REEL, OnTempsReel)
	ON_COMMAND(ID_FILTRES, OnFiltres)
	ON_COMMAND(ID_FILTRAGE_MORPHOLOGIQUE, OnFiltrageMorphologique)
	ON_COMMAND(ID_SEUILLAGE, OnSeuillage)
	ON_UPDATE_COMMAND_UI(ID_EXTRACTION, OnUpdateExtraction)
	ON_COMMAND(ID_EXTRACTION, OnExtraction)
	ON_COMMAND(ID_ZOOM_IMAGE, OnZoomImage)
	ON_COMMAND(ID_CONVERSION, OnConversion)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_COLLER_PRESSE_PAPIER, OnCollerPressePapier)
	ON_COMMAND(ID_FFT2D, OnFft2d)
	ON_UPDATE_COMMAND_UI(ID_COTATION, OnUpdateCotation)
	ON_COMMAND(ID_COTATION, OnCotation)
	ON_COMMAND(ID_ACQ_IM_PHAS4, OnAcqImPhas4)
	ON_COMMAND(ID_PILOTAGE_DEPH_STEIN, OnPilotageDephStein)
	ON_COMMAND(ID_AXE_SORTIE_SURCOURSE, OnAxeSortieSurcourse)
	ON_UPDATE_COMMAND_UI(ID_AXE_SORTIE_SURCOURSE, OnUpdateAxeSortieSurcourse)
	ON_UPDATE_COMMAND_UI(ID_DEP_MANU_MOT, OnUpdateDepManuMot)
	ON_COMMAND(ID_DEP_MANU_MOT, OnDepManuMot)
	ON_COMMAND(ID_TEMPS_MOY, OnTempsMoy)
	ON_COMMAND(ID_ACQ_TOPO, OnAcqTopo)
	ON_UPDATE_COMMAND_UI(ID_ALTITUDE, OnUpdateAltitude)
	ON_COMMAND(ID_ALTITUDE, OnAltitude)
	ON_UPDATE_COMMAND_UI(ID_VISU_3D, OnUpdateVisu3d)
	ON_COMMAND(ID_WEBCAM_TAILLE, OnWebcamTaille)
	ON_UPDATE_COMMAND_UI(ID_PSI_ACQ_TOPO, OnUpdatePsiAcqTopo)
	ON_COMMAND(ID_PSI_ACQ_TOPO, OnPsiAcqTopo)
	//}}AFX_MSG_MAP
	// Global help commands
	//Coordonnes dfilantes de la souris
	ON_UPDATE_COMMAND_UI(ID_BK, OnUpdateCoordonnees)
	//N de la fentre courante
	ON_UPDATE_COMMAND_UI(ID_BK1, OnUpdateNoFen)
	//Units
	ON_UPDATE_COMMAND_UI(ID_BK2, OnUpdateUnites)
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           //Status line indicator
	ID_BK1,									//N de la fentre active
	ID_BK,									//Coordonnes dfilantes de la souris
	ID_BK2,									//Units
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
//////////////////////////////////////////
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
}
CMainFrame::~CMainFrame()
{
}
//________________________________________
void CMainFrame::FigerAcq(void)
{
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		CBkDoc *pDoc;
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
		if (pDoc!=NULL && m_pApp->GrabIsStarted)
		{
			pDoc->FigerAcq();
			if (m_pApp->m_iCarte==4) pDoc->Deconnexion(); //Webcam
		}
	}
}
//________________________________________
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	m_pApp=((CBkApp*)AfxGetApp());
	//Ouverture plein cran
	ShowWindow(SW_SHOWMAXIMIZED);

	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}
//////////////////////////////////////////
// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG
//////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnUpdateUnites(CCmdUI *pCmdUI)
{
	short i,j;
	CString 
		r,l,
		s1="",s="";

	class CBkDoc* pDoc=NULL;
	m_wndStatusBar.SetPaneInfo(3,ID_BK2,SBPS_NORMAL,250);		
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	if (pDoc!=NULL)
	{
		if (pDoc->m_OKXY)
			s.Format("X,Y(mm)*%1.0e",1/pDoc->m_fFactXY);
		else
			s.Format("X,Y(pixel)");
		
		//Suppression des 0 de X,Y(mm)*1E+002
		for (j=0;j<2;j++)
		{
			i=s.GetLength()-2;
			if (s.GetAt(i)=='0')
			{
				r=s.Right(1);
				l=s.Left(i-1);
				s=l+r;
			}
		}
		if (pDoc->m_iNbB!=24)
		{
			if (pDoc->m_OKZ)
				s1.Format("%s, Z(mm)*%1.0e",s,1/pDoc->m_fFactZ);
			else
				s1.Format("%s, W(luminance)",s);
		}
		else
		{
			if (pDoc->m_OKZ)
				s1.Format("%s, ZR(mm)*%1.0e",s,1/pDoc->m_fFactZ);
			else
				s1.Format("%s, RVB(luminance)",s);
		}
		//Suppression des 0 de Z(mm)*1E+002
		for (j=0;j<2;j++)
		{
			i=s1.GetLength()-2;
			if (s1.GetAt(i)=='0')
			{
				r=s1.Right(1);
				l=s1.Left(i-1);
				s1=l+r;
			}
		}
	}
	pCmdUI->SetText(s1); 
}
//________________________________________
void CMainFrame::OnUpdateCoordonnees(CCmdUI *pCmdUI)
{
	CString 
		str="",s,s1,s2,s3,s4;
	short x,y;
	float xmm,ymm,zmm;
	long w;
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	m_wndStatusBar.SetPaneInfo(2,ID_BK,SBPS_NORMAL,300);		
	if (pDoc!=NULL)
	{
		if (m_pApp->GrabIsStarted)
		{
			str="Acquisition permanente..."; 
		}
		else
		{
			x=pDoc->m_iX-pDoc->m_iDx;
			y=pDoc->m_iY-pDoc->m_iDy;
			if (pDoc->m_iNbB!=24)
			{
				//Image en 8 bits
				w=pDoc->m_iW-pDoc->m_iDw;
				if (pDoc->m_iDx==0 && pDoc->m_iDy==0)
				{
					//Coordonnes absolues
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("X:%1.3f",xmm);
						s1.Format("Y:%1.3f",ymm);
					}
					else
					{
						//Pixel
						s.Format("X:%d",x);
						s1.Format("Y:%d",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						zmm=1.0*w*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("Z:%1.3f",zmm);
					}
					else
					{
						//Luminance
						s2.Format("W:%d",w);
					}
				}
				else
				{
					//Coordonnes relatives
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f",xmm);
						s1.Format("dY:%1.3f",ymm);
					}
					else
					{
						//pixel
						s.Format("dX:%d",x);
						s1.Format("dY:%d",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						zmm=1.0*w*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("dZ:%1.3f",zmm);
					}
					else
					{
						//Luminance
						s2.Format("dW:%d",w);
					}
				}
				str.Format("%s, %s, %s",s,s1,s2);
			}
			else
			if (pDoc->m_iNbB!=8)
			{
				//Image en 24 bits
				if (pDoc->m_iDx==0 && pDoc->m_iDy==0)
				{
					w=pDoc->m_iW-pDoc->m_iDw;
					//Coordonnes absolues
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f,",xmm);
						s1.Format("dY:%1.3f,",ymm);
					}
					else
					{
						//pixel
						s.Format("X:%d,",x);
						s1.Format("Y:%d,",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						zmm=1.0*(w&255)*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("ZR:%1.3f",zmm);
						s3=s4="";
					}
					else
					{
						//luminance
						s2.Format("R:%d,",w&255); 
						s3.Format("V:%d,",(w/256)&255); 
						s4.Format("B:%d",(w/65536)&255);
					}
				}
				else
				{
					//Coordonnes relatives
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f,",xmm);
						s1.Format("dY:%1.3f,",ymm);
					}
					else
					{
						//pixel
						s.Format("dX:%d,",x);
						s1.Format("dY:%d,",y);
					}
					if (pDoc->m_OKZ)
					{
						//mm
						w=(pDoc->m_iW&255)-(pDoc->m_iDw&255);
						zmm=1.0*w*pDoc->m_fFactZ/pDoc->m_fEchZ;
						s2.Format("dZR:%1.3f",zmm);
						s3=s4="";
					}
					else
					{
						//luminance
						w=(pDoc->m_iW&255)-(pDoc->m_iDw&255);
						s2.Format("dR:%d,",w);
						w=((pDoc->m_iW/256)&255)-((pDoc->m_iDw/256)&255);
						s3.Format("dV:%d,",w); 
						w=((pDoc->m_iW/65536)&255)-((pDoc->m_iDw/65536)&255);
						s4.Format("dB:%d",w);
					}
				}
				str.Format("%s %s %s %s %s",s,s1,s2,s3,s4);
			}		 
		}
	}
	else
	{
		str="";
	}
	pCmdUI->SetText(str);
}
//________________________________________
void CMainFrame::OnUpdateNoFen(CCmdUI *pCmdUI)
{
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	CString s="";
	if (pDoc!=NULL)
	{
		m_wndStatusBar.SetPaneInfo(1,ID_BK1,SBPS_NORMAL,30);		
		s.Format("(%d)",pDoc->m_iNo); 
	}
	pCmdUI->SetText(s); 
}
//________________________________________
void CMainFrame::OnUpdateFileNouveau(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1)  
	{
		pCmdUI->Enable(FALSE);
	}
}
void CMainFrame::OnUpdateFichierOuvrir(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFichierOuvrir() 
{
	CString s;
	static char BASED_CODE szFilter[]="Fichiers images (*tif;*.jpg;*.im)|*.tif;*.im;*.jpg|Fichiers images (*.tif)|*.tif|Fichiers images (*.jpg)|*.jpg|Fichiers visuim (*.im)|*.im|Tous les fichiers (*.*)|*.*||";
	CFileDialog dlg(TRUE,"","",0,szFilter,NULL) ;
	if (dlg.DoModal()==IDOK)
	{
		s=dlg.GetPathName();
		CFile f;
		char buf[512];
		if(!f.Open(s,CFile::modeRead) )
		{
			AfxMessageBox("Erreur d'ouverture fichier:"+s);
		}
		else
		{
			SendMessage(WM_COMMAND,ID_FILE_NEW,0);
			CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
			CBkDoc *pDoc;
			if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
			if (pDoc)
			{
				CArchive ar(&f,CArchive::load,512,buf);
				pDoc->Lire_Ecrire(ar);
			}
		}
	}	
}
//________________________________________
void CMainFrame::OnFichierSauver() 
{
	CFile f;
	char buf[512];
	CFileException p_Error;
	BOOL ok;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	CBkDoc *pDoc;
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	CArchive ar(&f,CArchive::store,512,buf);
	if (pDoc)
	{
		ok=f.Open(pDoc->m_sNomFic,CFile::modeWrite|CFile::modeCreate,&p_Error);
		if (!ok)
		{
			AfxMessageBox("Erreur d'criture fichier:"+pDoc->m_sNomFic);
		}
		else
		{
			CArchive ar(&f,CArchive::store,512,buf);
			pDoc->Lire_Ecrire(ar);
		}
	}
}
//________________________________________
void CMainFrame::OnFichierEnregisSous() 
{
	CString s;
	CFile f;
	char buf[512];
	static char BASED_CODE szFilter[]="Fichier image (*.tif)|*.tif|Fichier image (*.jpg)|*.jpg|Fichier visuim (*.im)|*.im||";
	CFileException p_Error;
	BOOL ok;
	short j=IDYES;

	CFileDialog dlg(FALSE,"","",0,szFilter,NULL) ;
	if (dlg.DoModal()==IDOK)
	{
		s=dlg.GetPathName();
		//Ouverture du fichier en mode READ			
		ok=f.Open(dlg.GetPathName(),CFile::modeRead,&p_Error);
		if (ok)
		{
			j=AfxMessageBox("Ce fichier existe dj. Voulez-vous le remplacer ?",MB_YESNO);
		} 
		if (j==IDYES)
		{
			if (ok) f.Close();
			//Ouverture du fichier en mode CREATE			
			ok=f.Open(dlg.GetPathName(),CFile::modeWrite|CFile::modeCreate,&p_Error);
			if (!ok)
			{
				AfxMessageBox("Erreur d'criture fichier:"+s);
			}
			else
			{
				CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
				CBkDoc *pDoc;
				if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
				CArchive ar(&f,CArchive::store,512,buf);
				if (pDoc)
				{
					pDoc->m_sNomFic=dlg.GetPathName();
					CArchive ar(&f,CArchive::store,512,buf);
					pDoc->Lire_Ecrire(ar);
				}
			}
		}	
	}
}
//________________________________________
void CMainFrame::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnOpMathLog() 
{
	FigerAcq();
	CLogDlg d;
	d.DoModal();
}

//________________________________________
void CMainFrame::OnUpdateProfils(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pProfilDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnProfils() 
{
	//Trac de profil(s) dans l'image
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	if (m_pApp->m_pProfilDlg==NULL) 
	{
		FigerAcq();
		m_pApp->m_pProfilDlg=new CProfilDlg(this);
	}
}
//________________________________________
void CMainFrame::OnUpdateMasque(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pMasqueDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnMasque() 
{
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	if (m_pApp->m_pMasqueDlg==NULL) 
	{
		FigerAcq();
		m_pApp->m_pMasqueDlg=new CMasqueDlg(this);
	}
}
//________________________________________
void CMainFrame::OnUpdateAcqfig(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_iCarte!=0 || m_pApp->GrabIsStarted==FALSE || m_pApp->m_iNb==0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnAcqfig() 
{
	FigerAcq();
}
//________________________________________
void CMainFrame::OnUpdateAcqperm(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_iCarte!=0 || m_pApp->GrabIsStarted==TRUE || m_pApp->m_iNb==0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnAcqperm() 
{
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		CBkDoc *pDoc;
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
		if (m_pApp->m_iCarte==4) pDoc->Connexion(); //Webcam
		if (pDoc!=NULL) pDoc->AcqPerm();
	}
}
//________________________________________
void CMainFrame::OnUpdateAppExit(CCmdUI* pCmdUI) 
{
	FigerAcq();
}
//________________________________________
void CMainFrame::OnAjusterParametres() 
{
	FigerAcq();
	CAjustDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnMulCte() 
{
	FigerAcq();
	CMathDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnGenerationMire() 
{
	FigerAcq();
	CMireDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnDemodul() 
{
	FigerAcq();
	CDemodDlg d;
	d.DoModal();
}
//________________________________________
/*
void CMainFrame::OnAcqImPhas4Video() 
{
	FigerAcq();
	CVideoDlg d;
	d.DoModal();
}
*/
//________________________________________
void CMainFrame::OnUpdateCalculImPhase4(CCmdUI* pCmdUI) 
{
	//Il faut au moins 4 fentres ouvertes
	if (m_pApp->m_iNb<4) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnCalculImPhase4() 
{
	FigerAcq();
	CPhas4Dlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateVisu3d(CCmdUI* pCmdUI) 
{
	//Uniquement sur N&B
	class CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if (pDoc->image->bmh->biBitCount!=8) pCmdUI->Enable(FALSE);
		}
	}		
}
//________________________________________
void CMainFrame::OnVisu3d() 
{
	FigerAcq();
	C3dDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnCalibration() 
{
	FigerAcq();
	CCalbDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateVisuPseudo(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnVisuPseudo() 
{
	FigerAcq();
	CPseuDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateTempsReel(CCmdUI* pCmdUI) 
{
	//if (m_pApp->m_iCarte==0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnTempsReel() 
{
	FigerAcq();
	CTemReDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnFiltres() 
{
	FigerAcq();
	CFiltreDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnFiltrageMorphologique() 
{
	FigerAcq();
	CMorphoDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnSeuillage() 
{
	FigerAcq();
	CSeuilDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateExtraction(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pExtractDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnExtraction() 
{
	if (m_pApp->m_pExtractDlg==NULL) 
	{
		FigerAcq();
		m_pApp->m_pExtractDlg=new CExtractDlg(this);
	}
}
//________________________________________
void CMainFrame::OnZoomImage() 
{
	FigerAcq();
	CZoomDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnConversion() 
{
	FigerAcq();
	CConvDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnEditCopy() 
{
	//Copier
	unsigned char huge *dib;
	short 
		rcode;
	HGLOBAL hMem;
	class CBkDoc* pDoc;
	class CBkView* pView;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			pView=(CBkView*)pChild->GetActiveView();
			FigerAcq();
			//N image  copier
			m_pApp->m_pDocACopier=pDoc;
			pDoc->DupliquerImageDansTempo(0);
			windowtoimage(pView->m_hWnd,m_pApp->imt[0]);
			//Copier aussi dans le presse-papier Windows
			if (OpenClipboard())
			{
				EmptyClipboard();
				rcode=imagetodib(m_pApp->imt[0],&dib);
				if (rcode==0)
				{
					hMem=(HGLOBAL)GlobalHandle(dib);
					GlobalUnlock(hMem);
					SetClipboardData(CF_DIB,hMem);
					CloseClipboard();	
				}		
			}
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pDocACopier==NULL) 	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnEditPaste() 
{
	class CBkDoc* pDoc;
	short l,h,nbB;
	l=m_pApp->m_pDocACopier->image->endx-m_pApp->m_pDocACopier->image->stx+1;
	h=m_pApp->m_pDocACopier->image->endy-m_pApp->m_pDocACopier->image->sty+1;
	nbB=m_pApp->m_pDocACopier->image->bmh->biBitCount;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			FigerAcq();
			pDoc->InitialiserImage(l,h,nbB);
			pDoc->m_iL=l;
			pDoc->m_iH=h;
			pDoc->m_iNbB=pDoc->image->bmh->biBitCount;
			copyimage(m_pApp->m_pDocACopier->image,pDoc->image);
			pDoc->DimensionnerFenetre(l,h);
			pDoc->DefinirCurseurs(l,h);
			pDoc->m_iType=0;
		}
	}		
}
//________________________________________
void CMainFrame::OnCollerPressePapier() 
{
	//Coller en provenance du presse-papier Windows
	unsigned char huge *dib;
	short 
		rcode;
	short l,h,n;
	HGLOBAL hMem;
	CBkDoc *pDoc;
	CBkView *pView;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			pView=(CBkView*)pChild->GetActiveView();
			if (OpenClipboard())
			{
				FigerAcq();
				if ((hMem=GetClipboardData(CF_DIB))!=0)
				{
					dib=(unsigned char huge *)GlobalLock(hMem);
					dibtoimage(dib,pDoc->image);
					GlobalUnlock(hMem);
				}
				CloseClipboard();	
				l=pDoc->image->endx-pDoc->image->stx+1;
				h=pDoc->image->endy-pDoc->image->sty+1;
				pDoc->m_iL=l;
				pDoc->m_iH=h;
				pDoc->m_iNbB=pDoc->image->bmh->biBitCount;
				//Paramtrer la fentre destination
				pDoc->DimensionnerFenetre(l,h);
				pDoc->DefinirCurseurs(l,h);
				pDoc->m_iType=0;
			}
		}
	}
}
//________________________________________
void CMainFrame::OnFft2d() 
{
	FigerAcq();
	CFftDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateCotation(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pCoteDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnCotation() 
{
	if (m_pApp->m_pCoteDlg==NULL) 
	{
		FigerAcq();
		m_pApp->m_pCoteDlg=new CCoteDlg(this);
	}
}
//________________________________________
void CMainFrame::OnAcqImPhas4() 
{
	FigerAcq();
	CAcqPhasDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnPilotageDephStein() 
{
	FigerAcq();
	CPiezoDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateAxeSortieSurcourse(CCmdUI* pCmdUI) 
{
  if (!(GetVersion() & 0x80000000))
	{
		pCmdUI->Enable(FALSE);
	}	
}
//________________________________________
void CMainFrame::OnAxeSortieSurcourse() 
{
	FigerAcq();
	CSurcoDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateDepManuMot(CCmdUI* pCmdUI) 
{
  if (!(GetVersion() & 0x80000000))
	{
		pCmdUI->Enable(FALSE);
	}	
}
//________________________________________
void CMainFrame::OnDepManuMot() 
{
	FigerAcq();
	CDepMaDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnTempsMoy() 
{
	FigerAcq();
	CTempsMoyDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnAcqTopo() 
{
	FigerAcq();
	if (m_pApp->m_iNb>6) AfxMessageBox("ATTENTION !\nVous devriez fermer les fentres inutiles.");
	CTopoDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateAltitude(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pAltitudeDlg!=NULL)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnAltitude() 
{
	if (m_pApp->m_pAltitudeDlg==NULL) 
	{
		FigerAcq();
		m_pApp->m_pAltitudeDlg=new CAltitudeDlg(this);
	}
}
//________________________________________
void CMainFrame::OnWebcamTaille() 
{
	CTailleWeb d;
	d.DoModal();	
}
//________________________________________
void CMainFrame::OnUpdatePsiAcqTopo(CCmdUI* pCmdUI) 
{
	
}
//________________________________________
void CMainFrame::OnPsiAcqTopo() 
{
	FigerAcq();
	if (m_pApp->m_iNb>6) AfxMessageBox("ATTENTION !\nVous devriez fermer les fentres inutiles.");
	CPsiDlg d;
	d.DoModal();
}
