// MasqueDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "MasqueDlg.h"
#include "BkDoc.h"
#include "BkView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMasqueDlg dialog
CMasqueDlg::CMasqueDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMasqueDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMasqueDlg)
	m_sTexte = _T("");
	m_sSource = _T("");
	m_radioTypeTracker = -1;
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_MASQUE,pParent);
}
void CMasqueDlg::DoDataExchange(CDataExchange* m_pdX)
{
	CDialog::DoDataExchange(m_pdX);
	//{{AFX_DATA_MAP(CMasqueDlg)
	DDX_Control(m_pdX, IDC_DEST, m_comboDest);
	DDX_Text(m_pdX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Text(m_pdX, IDC_STATIC_SOURCE, m_sSource);
	DDX_Radio(m_pdX, IDC_TYPE_TRACKER, m_radioTypeTracker);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CMasqueDlg, CDialog)
	//{{AFX_MSG_MAP(CMasqueDlg)
	ON_BN_CLICKED(IDAJOUTER, OnAjouter)
	ON_BN_CLICKED(IDRETIRER, OnRetirer)
	ON_BN_CLICKED(IDC_TYPE_TRACKER, OnTypeTracker)
	ON_BN_CLICKED(IDC_TYPE_TRACKER2, OnTypeTracker2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CMasqueDlg message handlers
void CMasqueDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
BOOL CMasqueDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j;
	CString s;
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	if (m_ps!=NULL)
	{
		//Tableau de pointeurs sur les documents ouverts, sauf la courante qui est exclue de la liste...
		m_pApp->GetDocumentSansCourant(m_pDoc);
		for (i=0;i<20;i++)
		{
			if (m_pDoc[i]!=NULL)
			{
				s.Format("%s",m_pDoc[i]->m_sNomFic);	
				m_comboDest.AddString(s);
			}         
		}
		s="NOUVELLE IMAGE";
		m_comboDest.AddString(s);
		//Par dfaut sur nouvelle image
		m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
		m_comboDest.SetWindowText(s);	
		//Premire fois
		m_OKP=TRUE;
		m_radioTypeTracker=m_ps->m_radioTypeTracker;
		m_ps->InitTracker();
		m_sSource.Format("%s",m_ps->m_sNomFic);	
		UpdateData(FALSE);
	}
	return TRUE;
}
//________________________________________
void CMasqueDlg::OnAjouter() 
{
	short 
		x1,y1,a,b,
		x,y,xd,xa,yd,ya;
	float r;
	long w;

	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	if (m_ps!=NULL)
	{
		UpdateData(TRUE);
		m_sSource.Format("%s",m_ps->m_sNomFic);	
		UpdateData(FALSE);
		xd=m_ps->m_tracker.m_rect.left;	
		xa=m_ps->m_tracker.m_rect.right;
		yd=m_ps->m_tracker.m_rect.top;
		ya=m_ps->m_tracker.m_rect.bottom;
		if (xa>0 && ya>0 && xd>0 && yd>0 && xa!=xd && ya!=yd)
		{
			m_sTexte.Format("Zone (%d,%d), (%d,%d) ajoute...",xd,yd,xa,ya);
			UpdateData(FALSE);
			if (m_OKP) PremiereFois();
			if (m_radioTypeTracker==0)
			{
				//Rectangulaire
				for(x=xd;x<=xa;x++)
				{
					for(y=yd;y<=ya;y++)
					{
						w=getpixelcolor(m_pApp->imt[0],x,y);
						//IMPORTANT: les pts d'intensit nulle du masque sont ignors  la dmodulation
						//w++;
						//if (w>255) w=255;
						w=255;
						setpixelcolor(m_pd->image,x,y,w);
					}
				}
			}
			else
			{
				//Elliptique
				x1=(xa+xd)/2;
				y1=(ya+yd)/2;
				a=abs(xa-x1);
				b=abs(ya-y1);
				for(x=-a;x<=a;x++)
				{
					for(y=-b;y<b;y++)
					{
						r=pow(1.0*b*b*(1-1.0*x*x/(1.0*a*a)),0.5);
						if ((y<=(int)r && -y>=(int)r) || (y>=(int)r && -y<=(int)r))
						{
						}
						else
						{
							w=getpixelcolor(m_pApp->imt[0],x1+x,y1+y);
							//IMPORTANT: les pts d'intensit nulle du masque sont ignors  la dmodulation
							//w++;
							//if (w>255) w=255;
							w=255;
							setpixelcolor(m_pd->image,x1+x,y1+y,w);
						}
					}
				}
			}
			m_ps->InitTracker();
			m_pd->InitTracker();
			m_pd->UpdateAllViews(NULL);
			m_ps->UpdateAllViews(NULL);
		}
	}
}
//________________________________________
void CMasqueDlg::OnRetirer() 
{
	short
		x1,y1,a,b,
		x,y,xd,xa,yd,ya;
	float r;
	long w;

	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	if (m_ps!=NULL)
	{
		UpdateData(TRUE);
		m_sSource.Format("%s",m_ps->m_sNomFic);	
		UpdateData(FALSE);
		xd=m_ps->m_tracker.m_rect.left;	
		xa=m_ps->m_tracker.m_rect.right;
		yd=m_ps->m_tracker.m_rect.top;
		ya=m_ps->m_tracker.m_rect.bottom;
		if (xa>0 && ya>0 && xd>0 && yd>0 && xa!=xd && ya!=yd)
		{
			m_sTexte.Format("Zone (%d,%d), (%d,%d) retire...",xd,yd,xa,ya);
			UpdateData(FALSE);
			if (m_OKP) PremiereFois();
			if (m_radioTypeTracker==0)
			{
				//Rectangulaire
				for(x=xd;x<=xa;x++)
				{
					for(y=yd;y<=ya;y++)
					{
						setpixelcolor(m_pd->image,x,y,0);
					}
				}
			}
			else
			{
				//Elliptique
				x1=(xa+xd)/2;
				y1=(ya+yd)/2;
				a=abs(xa-x1);
				b=abs(ya-y1);
				for(x=-a;x<=a;x++)
				{
					for(y=-b;y<b;y++)
					{
						r=pow(1.0*b*b*(1-1.0*x*x/(1.0*a*a)),0.5);
						if ((y<=(int)r && -y>=(int)r) || (y>=(int)r && -y<=(int)r))
						{
						}
						else
						{
							setpixelcolor(m_pd->image,x1+x,y1+y,0);
						}
					}
				}
			}
			m_ps->InitTracker();
			m_pd->InitTracker();
			m_pd->UpdateAllViews(NULL);
			m_ps->UpdateAllViews(NULL);
		}
	}
}
//________________________________________
void CMasqueDlg::OnCancel() 
{
	m_pApp->m_pMasqueDlg=NULL;	
	CBkDoc *m_ps;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild)	m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	if (m_ps!=NULL)	m_ps->m_radioTypeTracker=m_radioTypeTracker;
	CDialog::OnCancel();
}
//________________________________________
void CMasqueDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CMasqueDlg::OnTypeTracker() 
{
	CBkDoc *m_ps;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else  m_ps=NULL;
	if (m_ps!=NULL)
	{
		m_ps->m_radioTypeTracker=0;	
		m_ps->UpdateAllViews(NULL);
	}
}
//________________________________________
void CMasqueDlg::OnTypeTracker2() 
{
	CBkDoc *m_ps;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild)	m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	if (m_ps!=NULL)
	{
		m_ps->m_radioTypeTracker=1;	
		m_ps->UpdateAllViews(NULL);
	}
}
//________________________________________
void CMasqueDlg::PremiereFois(void) 
{
	short l,h,nbB;
	m_OKP=FALSE;
	//Si la fentre destination n'existe pas, il faut la crer...
	CMDIChildWnd *pChild;
	//Si l'utilisateur n'a pas touch aux combos, premier de la liste
	if (m_comboDest.GetCurSel()<0)
		m_pd=m_pDoc[m_comboDest.GetCount()-1];
	else
		m_pd=m_pDoc[m_comboDest.GetCurSel()];

	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;
	if (m_pd==NULL)	m_pd=m_pApp->CreerNouvelleFenetre(l,h);

	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	m_pd->InitialiserImage(l,h,8);
	zeroimage(0,m_pd->image);
	//Dimensionner l'image destination  la taille source
	m_pd->DimensionnerFenetre(l,h);
	m_pd->DefinirCurseurs(l,h);
	m_pd->m_iType=0;
	m_pd->m_sNomFic.Format("Masque%d",m_pd->m_iNo);
	m_pd->PositionnerFenetre(5,5);
	m_comboDest.SetWindowText(m_pd->m_sNomFic);	
	//Copie image source dans temporaire n0
	m_ps->DupliquerImageDansTempo(0);
}