// MireDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "MireDlg.h"
#include "Bkdoc.h"
#include "Vicdefs.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMireDlg dialog
CMireDlg::CMireDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMireDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMireDlg)
	m_iInterFr = 0;
	m_fPhase = 0.0f;
	m_radioType = -1;
	m_fContraste = 0.0f;
	m_iImoy = 0;
	//}}AFX_DATA_INIT
}
void CMireDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMireDlg)
	DDX_Text(pDX, IDC_INTER_FR, m_iInterFr);
	DDX_Text(pDX, IDC_PHASE, m_fPhase);
	DDX_Radio(pDX, IDC_RADIO1, m_radioType);
	DDX_Text(pDX, IDC_CONTRASTE, m_fContraste);
	DDX_Text(pDX, IDC_IMOY, m_iImoy);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CMireDlg, CDialog)
	//{{AFX_MSG_MAP(CMireDlg)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CMireDlg message handlers
BOOL CMireDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;

	m_iInterFr=m_pApp->m_iInterFr;
	m_iImoy=m_pApp->m_iImoy;
	m_fContraste=m_pApp->m_fContraste;
	m_fPhase=m_pApp->m_fPhase;
	m_radioType=0;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CMireDlg::OnOK() 
{
	float x,x0,xn,y,PI=4*atan(1);
	short i,j;
	UpdateData(TRUE);
	if (m_iInterFr<1) m_iInterFr=1;
	if (m_fContraste<0) m_fContraste=0;
	if (m_fContraste>1) m_fContraste=1;
	if (m_iImoy>255) m_iImoy=255;
	if (m_iImoy<0) m_iImoy=0;
	m_pApp->m_iInterFr=m_iInterFr;
	m_pApp->m_iImoy=m_iImoy;
	m_pApp->m_fContraste=m_fContraste;
	m_pApp->m_fPhase=m_fPhase+0.5;
	if (m_pApp->m_fPhase>1.999) m_pApp->m_fPhase=m_pApp->m_fPhase-2;
	if (m_pApp->m_fPhase<-1.999) m_pApp->m_fPhase=m_pApp->m_fPhase+2;
	UpdateData(FALSE);

	short l,h;
	l=m_pDoc->image->endx-m_pDoc->image->stx+1;
	h=m_pDoc->image->endy-m_pDoc->image->sty+1;

	m_pDoc->InitialiserImage(l,h,8);//Image en 8 bits...
	
	if (m_radioType==0)
	{	
		for (i=0;i<m_pDoc->m_iL;i++)
		{
			//Sinus
			y=1.0*m_iImoy*(1+m_fContraste*cos(2*PI*i/m_iInterFr+m_fPhase*PI));
			if (y<0) y=0;
			if (y>255) y=255;
			for (j=0;j<m_pDoc->m_iH;j++)
			{
				setpixelcolor(m_pDoc->image,i,j,(long)(y));
			}
		}
	}		
	else
	{
		//Triangles
		x0=m_fPhase*PI;
		xn=x0;

		do
		{
			for (x=xn;x<xn+m_iInterFr;x++)
			{
				y=255.0*(x-xn)/m_iInterFr;
				for (j=0;j<m_pDoc->m_iH;j++)
				{
					if (x>=0 && x<m_pDoc->m_iL) setpixelcolor(m_pDoc->image,(int)x,j,(int)(y));
				}
			}
			x=xn;
			xn=xn+m_iInterFr;
		}
		while (xn<m_pDoc->m_iL);
	}
	m_pDoc->m_sNomFic.Format("Mire%1.0f",m_fPhase*180);
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}
//________________________________________
void CMireDlg::OnRadio1() 
{
	GetDlgItem(IDC_CONTRASTE)->EnableWindow(TRUE);
	GetDlgItem(IDC_IMOY)->EnableWindow(TRUE);
}
//________________________________________
void CMireDlg::OnRadio3() 
{
	GetDlgItem(IDC_CONTRASTE)->EnableWindow(FALSE);
	GetDlgItem(IDC_IMOY)->EnableWindow(FALSE);
}
