// PiDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "PiDlg.h"
#include "BkDoc.h"
#include "math.h"
#include "C832.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CPiDlg dialog
CPiDlg::CPiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPiDlg)
	m_s17 = _T("");
	m_s14 = _T("");
	m_sX1 = _T("");
	m_sX2 = _T("");
	m_sX3 = _T("");
	m_sX4 = _T("");
	//}}AFX_DATA_INIT
}
void CPiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPiDlg)
	DDX_Control(pDX, IDACQAUTO1, m_btnAuto);
	DDX_Control(pDX, IDVISU1, m_btnVisu);
	DDX_Control(pDX, IDC_REF, m_comboRef);
	DDX_Control(pDX, IDC_IMPHASE1, m_comboSM256);
	DDX_Control(pDX, IDSOUSTRACTION, m_btnSM256);
	DDX_Control(pDX, IDIMTEMPO, m_btnTempo);
	DDX_Text(pDX, IDC_STATIC17, m_s17);
	DDX_Text(pDX, IDC_STATIC14, m_s14);
	DDX_Text(pDX, IDC_X1, m_sX1);
	DDX_Text(pDX, IDC_X2, m_sX2);
	DDX_Text(pDX, IDC_X3, m_sX3);
	DDX_Text(pDX, IDC_X4, m_sX4);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPiDlg, CDialog)
	//{{AFX_MSG_MAP(CPiDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDSOUSTRACTION, OnSoustraction)
	ON_BN_CLICKED(IDACQAUTO1, OnAcqauto1)
	ON_BN_CLICKED(IDIMTEMPO, OnImtempo)
	ON_BN_CLICKED(IDVISU1, OnVisu1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CPiDlg message handlers
BOOL CPiDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//m_s="Dphaseur P.I.";
	short i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	//Image camra
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	m_btnSM256.EnableWindow(FALSE);	
	m_btnTempo.EnableWindow(FALSE);	
	m_OKP=TRUE;
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboRef.AddString(s);
			m_comboSM256.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboSM256.AddString(s);//Image soustraction M256
	s="AUCUNE";
	m_comboRef.AddString(s);//Rfrence

	//Par dfaut sur nouvelle image
	m_comboSM256.GetLBText(m_comboSM256.GetCount()-1,s);
	m_comboSM256.SetWindowText(s);	

	m_comboRef.GetLBText(m_comboRef.GetCount()-1,s);
	m_comboRef.SetWindowText(s);	

	m_iNb=0;
	m_s17=m_ps->m_sNomFic;
	m_s14="Spcifier les valeurs en mm de dphasage...";

	m_fX1=m_pApp->m_fPhX[0];	
	m_fX2=m_pApp->m_fPhX[1];	
	m_fX3=m_pApp->m_fPhX[2];	
	m_fX4=m_pApp->m_fPhX[3];	
	m_sX1.Format("%1.3f",m_fX1);
	m_sX2.Format("%1.3f",m_fX2);
	m_sX3.Format("%1.3f",m_fX3);
	m_sX4.Format("%1.3f",m_fX4);

	UpdateData(FALSE);
	//Platine motorise
	m_pC832=new CC832(120000);
	if (m_pC832->OK(1))
	{
		m_pC832->RT(1);
		m_pC832->IT(1);
		m_pC832->SV(1,20);
		//Validit des images
		SetTimer(0,100,NULL);
	}
	else
	{
		m_btnVisu.EnableWindow(FALSE);
		m_btnAuto.EnableWindow(FALSE);
		m_s14="Carte de motorisation P.I. C832 non trouve !";
	}
	m_OKP=TRUE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CPiDlg::PremiereFois() 
{
	m_OKP=FALSE;
	m_ps->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,8);
	m_ps->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_ps->DupliquerImageDansTempo(0);
	m_ps->DupliquerImageDansTempo(1);
	m_ps->DupliquerImageDansTempo(2);
	m_ps->DupliquerImageDansTempo(3);
	im0=m_pApp->imt[0];
	im90=m_pApp->imt[1];
	im180=m_pApp->imt[2];
	im270=m_pApp->imt[3];

	GetDlgItem(IDC_IMPHASE1)->EnableWindow(FALSE);
	GetDlgItem(IDC_REF)->EnableWindow(FALSE);
	//Image source: m_ps
	//Image destination phase: m_pp 

	if (m_comboSM256.GetCurSel()<0)
		m_pp=m_pDoc[m_comboSM256.GetCount()-1];
	else
		m_pp=m_pDoc[m_comboSM256.GetCurSel()];

	//Si la fentre m_pp n'existe pas, il faut la crer  la taille de ps
	if (m_pp==NULL)	m_pp=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);
	//Caractristiques de l'image phase
	m_pp->InitialiserImage(m_ps->m_iL,m_ps->m_iH,8);
	//Dimensionner l'image phase  la taille source
	m_pp->m_iH=m_ps->m_iH;
	m_pp->m_iL=m_ps->m_iL;
	m_pp->m_iNbB=8;
	m_pp->m_iType=0;
	m_pp->InitTracker();//Pas de tracker sur la destination...
	m_pp->m_sNomFic.Format("ImPhasee%d",m_pp->m_iNo);
	m_comboSM256.SetWindowText(m_pp->m_sNomFic);	
	
	m_pp->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_pp->DimensionnerFenetre(m_ps->m_iL,m_ps->m_iH);
	UpdateData(FALSE);
	m_ps->UpdateAllViews(NULL);
}
//________________________________________
float CPiDlg::atan3(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=1e10;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}
		}
	}
	return r;
}
//________________________________________
void CPiDlg::OnTimer(UINT nIDEvent) 
{
	short j,duree=3;
	switch(nIDEvent)
	{
		case 0://Image phase REF et l'image destination ne peuvent pas tre identiques...
			UpdateData(TRUE);
			if (m_comboSM256.GetCurSel()<0) 
				m_pp=NULL;
			else
			if (m_comboSM256.GetCurSel()==m_comboSM256.GetCount()-1) 
				m_pp=NULL;
			else
				m_pp=m_pDoc[m_comboSM256.GetCurSel()];

			if (m_comboRef.GetCurSel()<0)//Aucune
				m_pr=NULL;
			else
			if (m_comboRef.GetCurSel()==m_comboRef.GetCount()-1)//Aucune
				m_pr=NULL;
			else
				m_pr=m_pDoc[m_comboRef.GetCurSel()];

			if (m_pr!=NULL && m_pp!=NULL)
			{
				if (m_pr==m_pp)
				{
					m_btnVisu.EnableWindow(FALSE); 
					m_btnAuto.EnableWindow(FALSE); 
				}
				else
				{
					m_btnVisu.EnableWindow(TRUE);
					m_btnAuto.EnableWindow(TRUE);
				}
			}
			else
			{
				m_btnVisu.EnableWindow(TRUE);
				m_btnAuto.EnableWindow(TRUE);
			}
		break;
		case 3://Temporisation 250 ms, puis acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(3);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(1,50,NULL);
			}
		break;
		case 1://Temporisation 250 ms, puis acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(1);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(2,50,NULL);
			}
		break;
		case 2://Mmorisation des images
			m_iN++;
			if (m_iN>duree)//Attente aprs acq. fige 1 seconde pour carte primo
			{
				KillTimer(2);
				switch (m_iNb)
				{
					case 0://im0
						copyimage(m_ps->image,im0);
						m_s14="Image phase 0 acquise.";
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 90");
						m_iNb++;
						UpdateData(FALSE);
						m_btnVisu.EnableWindow(TRUE);
					break;
					case 1://im90
						copyimage(m_ps->image,im90);
						m_s14="Image phase 90 acquise.";
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 180");
						m_iNb++;
						UpdateData(FALSE);
						m_btnVisu.EnableWindow(TRUE);
					break;
					case 2://im180
						copyimage(m_ps->image,im180);
						m_s14="Image phase 180 acquise.";
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 270");
						m_iNb++;
						UpdateData(FALSE);
						m_btnVisu.EnableWindow(TRUE);
					break;
					case 3://im270
						copyimage(m_ps->image,im270);
						m_s14="Image phase 270 acquise.";
						m_iNb++;
						UpdateData(FALSE);
						GetDlgItem(IDVISU1)->SetWindowText("&Calcul im. phase");
						m_btnVisu.EnableWindow(TRUE);
					break;
					case 4://image phase
						m_iNb=0;
						m_btnVisu.EnableWindow(FALSE);
						m_iI=0;m_btnTempo.EnableWindow(TRUE);
						Calcul();
						m_btnVisu.EnableWindow(TRUE);
						GetDlgItem(IDC_X1)->EnableWindow(TRUE);
						GetDlgItem(IDC_X2)->EnableWindow(TRUE);
						GetDlgItem(IDC_X3)->EnableWindow(TRUE);
						GetDlgItem(IDC_X4)->EnableWindow(TRUE);
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. phase 0");
						if (m_pr!=NULL)	m_btnSM256.EnableWindow(TRUE);
					break;
				}
			}
		break;
		//Acq. automatique_____________________________
		case 10://Tension U1
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(10);
				m_pC832->MA(1,m_fX1);
				while (!m_pC832->MD(1))
				{
					;
				}
				m_iN=0;SetTimer(11,50,NULL);
			}
		break;
		case 11://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(11);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(12,50,NULL);
			}
		break;
		case 12://Acquisition Im0
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(12);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(13,50,NULL);
			}
		break;
		case 13://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(13);
				copyimage(m_ps->image,im0);
				m_s14="Image phase 0 acquise.";
				GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 90");
				UpdateData(FALSE);
				m_iN=0;SetTimer(14,50,NULL);
			}
		break;
		case 14://Tension U2
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(14);
				m_pC832->MA(1,m_fX2);
				while (!m_pC832->MD(1))
				{
					;
				}
				m_iN=0;SetTimer(15,50,NULL);
			}
		break;
		case 15://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(15);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(16,50,NULL);
			}
		break;
		case 16://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(16);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(17,50,NULL);
			}
		break;
		case 17://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(17);
				copyimage(m_ps->image,im90);
				m_s14="Image phase 90 acquise.";
				GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 180");
				UpdateData(FALSE);
				m_iN=0;SetTimer(18,50,NULL);
			}
		break;
		case 18://Tension U3
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(18);
				m_pC832->MA(1,m_fX3);
				while (!m_pC832->MD(1))
				{
					;
				}
				m_iN=0;SetTimer(19,50,NULL);
			}
		break;
		case 19://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(19);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(20,50,NULL);
			}
		break;
		case 20://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(20);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(21,50,NULL);
			}
		break;
		case 21://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(21);
				copyimage(m_ps->image,im180);
				m_s14="Image phase 180 acquise.";
				GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 270");
				UpdateData(FALSE);
				m_iN=0;SetTimer(22,50,NULL);
			}
		break;
		case 22://Tension U4
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(22);
				m_pC832->MA(1,m_fX4);
				while (!m_pC832->MD(1))
				{
					;
				}
				m_iN=0;SetTimer(23,50,NULL);
			}
		break;
		case 23://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(23);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(24,50,NULL);
			}
		break;
		case 24://Acquisition Im270
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(24);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(25,50,NULL);
			}
		break;
		case 25://Copie vers image temporaire
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(25);
				copyimage(m_ps->image,im270);
				m_s14="Image phase 270 acquise.";
				GetDlgItem(IDVISU1)->SetWindowText("&Calcul im. phase");
				UpdateData(FALSE);
				m_iN=0;SetTimer(26,50,NULL);
			}
		break;
		case 26://Calcul image phase
			KillTimer(26);
			Calcul();
			GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 0");
			//Piezo
			GetDlgItem(IDC_X1)->EnableWindow(TRUE);
			GetDlgItem(IDC_X2)->EnableWindow(TRUE);
			GetDlgItem(IDC_X3)->EnableWindow(TRUE);
			GetDlgItem(IDC_X4)->EnableWindow(TRUE);
			m_iI=0;m_btnTempo.EnableWindow(TRUE);
			if (m_pr!=NULL)	m_btnSM256.EnableWindow(TRUE);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//_________________________________________________
void CPiDlg::Calcul() 
{
	//Calcul de l'image phase
	UpdateData(TRUE);
	CRect	 MMRect;
	MMRect.SetRect(0,0,m_ps->m_iL+14,m_ps->m_iH+30);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	long w,w1,w2,w3,w4;
	float r;
	short i,j;

	m_s14="Calcul image phase...";
	UpdateData(FALSE);

	for (i=0;i<m_ps->m_iL;i++)
	{
		for (j=0;j<m_ps->m_iH;j++)
		{
			w1=getpixelcolor(im0,i,j);
			w2=getpixelcolor(im90,i,j);
			w3=getpixelcolor(im180,i,j);
			w4=getpixelcolor(im270,i,j);
			if(w1-w3==0)
			{
				r=0;
			}
			else
			{
				r=atan3(1.0*(w4-w2),1.0*(w1-w3));
			}
			//Intervalle [0, 255]
			r=255.0*r/6.28;
			if (r<0) r=0;
			if (r>255) r=255;
			w=(long)(r);
			setpixelcolor(m_pp->image,i,j,w);
		}
	}
	//Dimensionner et positionner l'image phase en haut  gauche et la mettre au dessus
	m_pp->UpdateAllViews(NULL);
	m_pp->PositionnerFenetre(20,20);

	m_btnVisu.EnableWindow(TRUE);
	m_btnAuto.EnableWindow(TRUE);

	m_s14="Image phase calcule...";
	UpdateData(FALSE);
	//m_pp->m_pView->MAJ_Fen();
}
//________________________________________
void CPiDlg::OnSoustraction() 
{
	//Soustraction M256 avec l'image rfrence
	long w1,w2,w3;
	short i,j;

	m_s14.Format("Soustraction de l'image phase  %s.",m_pr->m_sNomFic);
	m_pp->m_sNomFic.Format("ImPhasee%dSM256",m_pp->m_iNo);
	m_comboSM256.SetWindowText(m_pp->m_sNomFic);	
	UpdateData(FALSE);
	for (i=0;i<m_ps->m_iL;i++)
	{
		for (j=0;j<m_ps->m_iH;j++)
		{
			w1=getpixelcolor(m_pp->image,i,j);
			w2=getpixelcolor(m_pr->image,i,j);
			if (w2-w1<0)
				w3=256+w2-w1;
			else
				w3=w2-w1;
			setpixelcolor(m_pp->image,i,j,w3);
		}
	}
	m_pp->UpdateAllViews(NULL);	
}
//________________________________________
void CPiDlg::PostNcDestroy() 
{
	//C'est l'image par dfaut, quand on revient...
	if (!m_OKP) m_ps->PositionnerFenetre(40,40);
	delete m_pC832;
	CDialog::PostNcDestroy();
}
//________________________________________
void CPiDlg::OnAcqauto1() 
{
	//Acq. automatique suivie du calcul de l'image phase
	KillTimer(0);
	if (m_OKP) PremiereFois();
	m_OKP=FALSE;
	Validite();
	//Piezo
	GetDlgItem(IDC_X1)->EnableWindow(FALSE);
	GetDlgItem(IDC_X2)->EnableWindow(FALSE);
	GetDlgItem(IDC_X3)->EnableWindow(FALSE);
	GetDlgItem(IDC_X4)->EnableWindow(FALSE);
	GetDlgItem(IDC_IMPHASE1)->EnableWindow(FALSE);
	m_btnAuto.EnableWindow(FALSE);
	m_btnSM256.EnableWindow(FALSE);
	m_btnVisu.EnableWindow(FALSE);
	m_btnTempo.EnableWindow(FALSE);
	//Dimensionner et positionner les images
	m_ps->m_sNomFic.Format("ImCamera%d",m_ps->m_iNo);
	m_ps->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_s17=m_ps->m_sNomFic;
	UpdateData(FALSE);
	//Image live
	m_ps->PositionnerFenetre(20,0);
	//Acq. fige, sinon mire n'est pas gnre...
	if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
	m_iN=0;SetTimer(10,50,NULL);
}
//________________________________________
void CPiDlg::Validite() 
{
	short i;
	//Test de validit des entres
	UpdateData(TRUE);
	i=sscanf(m_sX1,"%f",&m_fX1);
	if (i==0) m_fX1=0;
	i=sscanf(m_sX2,"%f",&m_fX2);
	if (i==0) m_fX2=0;
	i=sscanf(m_sX3,"%f",&m_fX3);
	if (i==0) m_fX3=0;
	i=sscanf(m_sX4,"%f",&m_fX4);
	if (i==0) m_fX4=0;

	if (m_fX1<0) m_fX1=0;
	if (m_fX1>10) m_fX1=10;
	m_pApp->m_fPhX[0]=m_fX1;	

	if (m_fX2<0) m_fX2=0;
	if (m_fX2>10) m_fX2=10;
	m_pApp->m_fPhX[1]=m_fX2;	


	if (m_fX3<0) m_fX3=0;
	if (m_fX3>10) m_fX3=10;
	m_pApp->m_fPhX[2]=m_fX3;	


	if (m_fX4<0) m_fX4=0;
	if (m_fX4>10) m_fX4=10;
	m_pApp->m_fPhX[3]=m_fX4;	

	
	m_sX1.Format("%1.3f",m_fX1);
	m_sX2.Format("%1.3f",m_fX2);
	m_sX3.Format("%1.3f",m_fX3);
	m_sX4.Format("%1.3f",m_fX4);
	UpdateData(FALSE);
}
//________________________________________
void CPiDlg::OnImtempo() 
{
	switch (m_iI)
	{
		case 0:
			copyimage(im0,m_ps->image);
			m_s14="Image temporaire 0 visualise.";
			m_ps->m_sNomFic.Format("ImTempo0");
			m_ps->PositionnerFenetre(40,40);
		break;
		case 1:
			copyimage(im90,m_ps->image);
			m_s14="Image temporaire 90 visualise.";
			m_ps->m_sNomFic.Format("ImTempo90");
			m_ps->PositionnerFenetre(40,40);
		break;
		case 2:
			copyimage(im180,m_ps->image);
			m_s14="Image temporaire 180 visualise.";
			m_ps->m_sNomFic.Format("ImTempo180");
			m_ps->PositionnerFenetre(40,40);
		break;
		case 3:
			copyimage(im270,m_ps->image);
			m_s14="Image temporaire 270 visualise.";
			m_ps->m_sNomFic.Format("ImTempo270");
			m_ps->PositionnerFenetre(40,40);
		break;
		case 4:
			m_s14="Image phase visualise.";
			m_pp->PositionnerFenetre(20,20);
		break;
	}
	UpdateData(FALSE);
	m_iI++; if (m_iI>4) m_iI=0;
}
//_______________________________________
void CPiDlg::OnVisu1() 
{
	short i;
	KillTimer(0);
	if (m_OKP) PremiereFois();
	Validite();
	//Conversion CString -> int
	GetDlgItem(IDC_IMPHASE1)->EnableWindow(FALSE);
	//Piezo
	GetDlgItem(IDC_X1)->EnableWindow(FALSE);
	GetDlgItem(IDC_X2)->EnableWindow(FALSE);
	GetDlgItem(IDC_X3)->EnableWindow(FALSE);
	GetDlgItem(IDC_X4)->EnableWindow(FALSE);
	m_btnAuto.EnableWindow(FALSE);
	m_btnSM256.EnableWindow(FALSE);
	m_btnTempo.EnableWindow(FALSE);
	//Dimensionner et positionner les images
	m_ps->m_sNomFic.Format("ImCamera%d",m_ps->m_iNo);
	m_s17=m_ps->m_sNomFic;
	UpdateData(FALSE);
	m_ps->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_ps->PositionnerFenetre(20,0);
	m_ps->DefinirCurseurs(m_pApp->m_iL,m_pApp->m_iH);

	switch (m_iNb)
	{
		case 0://im0
			m_btnVisu.EnableWindow(FALSE);
			m_pC832->MA(1,m_fX1);
			while (!m_pC832->MD(1))
			{
				;
			}
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 1://im90
			m_btnVisu.EnableWindow(FALSE);
			m_pC832->MA(1,m_fX2);
			while (!m_pC832->MD(1))
			{
				;
			}
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 2://im180
			m_btnVisu.EnableWindow(FALSE);
			m_pC832->MA(1,m_fX3);
			while (!m_pC832->MD(1))
			{
				;
			}
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 3://im270
			m_btnVisu.EnableWindow(FALSE);
			m_pC832->MA(1,m_fX4);
			while (!m_pC832->MD(1))
			{
				;
			}
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 4://calcul image phase
			m_btnVisu.EnableWindow(FALSE);
			m_iN=0;SetTimer(3,50,NULL);
		break;
	}
}
