// Piezo.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "piezo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
CPiezo::CPiezo(int iNoCom)
{
	//Port srie
	m_radioCom=iNoCom;
	switch (m_radioCom)
	{
		case 0://COM1
			m_hCom=CreateFile("COM1",GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if (m_hCom==INVALID_HANDLE_VALUE)
			{
				DWORD dwErreur=GetLastError();
				//AfxMessageBox("Erreur d'initialisation de COM1 !");
			}
			else
				if (!InitRs232(m_hCom)) /*AfxMessageBox("Erreur InitRs232 sur COM1 !")*/;
		break;
		case 1://COM2
			m_hCom=CreateFile("COM2",GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if (m_hCom==INVALID_HANDLE_VALUE)
			{
				DWORD dwErreur=GetLastError();
				//AfxMessageBox("Erreur d'initialisation de COM2 !");
			}
			else
				if (!InitRs232(m_hCom)) /*AfxMessageBox("Erreur InitRs232 sur COM2 !")*/;
		break;
	}
}
//________________________________________
CPiezo::~CPiezo()
{
	if (m_hCom) CloseHandle(m_hCom);
}
//________________________________________
BOOL CPiezo::InitRs232(HANDLE m_hCom)
{
	DWORD taille;
	BOOL ok=TRUE;
	DCB dcb;
	//Dans StdAfx.h:
	//#define VC_EXTRALEAN	//Mettre l'instruction en remarque...
	GetCommState(m_hCom,&dcb);
	COMMTIMEOUTS ctmo;
	ok=GetCommTimeouts(m_hCom,&ctmo);
	if (ok)
	{
		ctmo.ReadIntervalTimeout=MAXDWORD;
		ctmo.ReadTotalTimeoutMultiplier=0;
		ctmo.ReadTotalTimeoutConstant=0;
		ctmo.WriteTotalTimeoutConstant=0;
		ctmo.WriteTotalTimeoutMultiplier=0;
		SetCommTimeouts(m_hCom,&ctmo);
	}
	//Paramtres du port srie
	//9600,8,'N',1
	//dcb.BaudRate=CBR_9600;	//9600 bauds
	//dcb.ByteSize=8;					//8 bits
	//dcb.StopBits=ONESTOPBIT;//ONESTOPBIT;//1 bit stop
	//dcb.fParity=1;					//Enable parity checking
	//dcb.Parity=0;						//0:no, 1:odd, 2:even, 3:mark, 4:space

	//Remplac le 15/10/03 par une fonction BuildCommDCB ...
	//CString s="baud=9600 parity=N data=8 stop=1";
	CString s="96,n,8,1,x";
	ok=BuildCommDCB(s,&dcb);
	if (!ok) AfxMessageBox("Erreur fonction BuildCommDCB");

	/*
	dcb.fOutxCtsFlow=0;			//CTS
	dcb.fOutxDsrFlow=0;			//DSR
	dcb.fDtrControl=DTR_CONTROL_DISABLE;
	dcb.fDsrSensitivity=0;
	dcb.fTXContinueOnXoff=1;
	dcb.fOutX=1;						//Protocole XON/XOFF
	dcb.fInX=1;
	dcb.fErrorChar=0;//1;
	dcb.fNull=0;//1;
	dcb.fRtsControl=0;			//RTS_CONTROL_HANDSHAKE
	dcb.fAbortOnError=1;
	dcb.fDummy2=0;//17;
	dcb.XonLim=2048;
	dcb.XoffLim=512;
	dcb.XonChar=17;
	dcb.XoffChar=19;
	dcb.ErrorChar=0;
	dcb.EofChar='\n';
	dcb.EvtChar=2;
	dcb.fBinary=1;					//Obligatoirement TRUE
	*/
	SetCommState(m_hCom,&dcb);
	return ok;
}
//________________________________________
BOOL CPiezo::WriteCom(CString s)
{
	DWORD i;
	BOOL ok;
	if (m_hCom!=INVALID_HANDLE_VALUE)
	{
		ok=WriteFile(m_hCom,s,s.GetLength(),&i,NULL);
	}
	else
		ok=FALSE;
	return ok;
}
//________________________________________
//u dans l'untervalle [0, 100]
BOOL CPiezo::Tension(short u)
{
  unsigned short i;
	BOOL ok;
  i=(int)(1023.0*u/100.0); 
  if (i>1023) i=1023;
  if (i<0) i=0;
	ok=Pilote(i);
	return ok;
}
//________________________________________
//i dans l'untervalle [0, 1023]
BOOL CPiezo::Pilote(short i)
{
	//char s2[2];
	BOOL ok;
  CString s;
  if (i>1023) i=1023;
  if (i<0) i=0;
  s.Format("%d\r",i);
	if (s.GetLength()==2) s="000"+s;
	else
	if (s.GetLength()==3) s="00"+s;
	else
	if (s.GetLength()==4) s="0"+s;
	ok=WriteCom(s);
	/*
	//On envoie caractre par caractre
	for (i=0;i<s.GetLength();i++)
	{
 		sprintf(s2,"%c",s.GetAt(i));
 		ok==WriteCom(s2);
 		Sleep(0);
	}
	*/
	return ok;
}