// ProjAutoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "ProjAutoDlg.h"
#include "Bkdoc.h"
#include "Bkview.h"
#include "demodul.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CProjAutoDlg dialog
CProjAutoDlg::CProjAutoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProjAutoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProjAutoDlg)
	m_s = _T("");
	m_sInterFr = _T("");
	//}}AFX_DATA_INIT
}
void CProjAutoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProjAutoDlg)
	DDX_Control(pDX, IDIMTEMPO, m_btnTempo);
	DDX_Control(pDX, IDC_DEST1, m_comboDest);
	DDX_Control(pDX, IDEMODUL, m_btnDemodul);
	DDX_Control(pDX, IDC_REF, m_comboRef);
	DDX_Control(pDX, IDC_IM_PHASE, m_comboSM256);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDACQAUTO, m_btnAuto);
	DDX_Text(pDX, IDC_STATIC5, m_s);
	DDX_Text(pDX, IDC_FREQ, m_sInterFr);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CProjAutoDlg, CDialog)
	//{{AFX_MSG_MAP(CProjAutoDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDACQAUTO, OnAcqauto)
	ON_BN_CLICKED(IDEMODUL, OnEmodul)
	ON_EN_CHANGE(IDC_FREQ, OnChangeInterFr)
	ON_BN_CLICKED(IDIMTEMPO, OnImtempo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CProjAutoDlg message handlers
BOOL CProjAutoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	//Image camra
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	m_btnDemodul.EnableWindow(FALSE);	
	m_btnTempo.EnableWindow(FALSE);	
	m_OKP=TRUE;
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboRef.AddString(s);
			m_comboDest.AddString(s);
			m_comboSM256.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboDest.AddString(s);//Mire  projeter
	m_comboSM256.AddString(s);//Image dmodule
	s="AUCUNE";
	m_comboRef.AddString(s);//Rfrence par dfaut

	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	//Par dfaut sur nouvelle image
	m_comboSM256.GetLBText(m_comboSM256.GetCount()-1,s);
	m_comboSM256.SetWindowText(s);	

	m_comboRef.GetLBText(m_comboRef.GetCount()-1,s);
	m_comboRef.SetWindowText(s);	

	m_iNb=0;m_iI=0;
	m_iInterFr=m_pApp->m_iInterFr;
	m_sInterFr.Format("%d",m_iInterFr);
	UpdateData(FALSE);
	SetTimer(0,100,NULL);
	return TRUE;
}
//________________________________________
void CProjAutoDlg::GenererMire(short interfr,float phase) 
{
	short i,j;
	float 
		x,x0,xn,
		y,PI=4*atan(1);
	for (i=0;i<m_pd->m_iL;i++)
	{
		y=sin(2*PI*i/interfr+phase*PI);
		for (j=0;j<m_pd->m_iH;j++)
		{
			setpixelcolor(m_pd->image,i,j,(int)((y+1)*127));
		}
	}
	m_pd->m_iType=0;
	m_pd->UpdateAllViews(NULL);
}
//________________________________________
void CProjAutoDlg::PremiereFois() 
{
	CString z;
	KillTimer(0);


	m_ps->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,8);
	m_ps->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_ps->DupliquerImageDansTempo(0);
	m_ps->DupliquerImageDansTempo(1);
	m_ps->DupliquerImageDansTempo(2);
	m_ps->DupliquerImageDansTempo(3);
	im0=m_pApp->imt[0];
	im90=m_pApp->imt[1];
	im180=m_pApp->imt[2];
	im270=m_pApp->imt[3];


	GetDlgItem(IDC_DEST1)->EnableWindow(FALSE);
	GetDlgItem(IDC_IM_PHASE)->EnableWindow(FALSE);
	GetDlgItem(IDC_REF)->EnableWindow(FALSE);
	//Image source: m_ps
	//Image destination phase: m_pp 
	//Image des franges  projeter: m_pd
	//Si la fentre m_pp n'existe pas, il faut la crer  la taille de ps
	if (m_pp==NULL)	m_pp=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);
	//Caractristiques de l'image phase
	m_pp->InitialiserImage(m_ps->m_iL,m_ps->m_iH,8);
	//Dimensionner l'image phase  la taille source
	m_pp->m_iH=m_ps->m_iH;
	m_pp->m_iL=m_ps->m_iL;
	m_pp->m_iNbB=8;
	m_pp->m_iType=0;
	m_pp->InitTracker();//Pas de tracker sur la destination...
	m_pp->m_sNomFic.Format("ImPhasee%dSM256",m_pp->m_iNo);
	m_pp->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_pp->DimensionnerFenetre(m_ps->m_iL,m_ps->m_iH);
	//Image destination des franges
	//Si la fentre destination des franges n'existe pas, il faut la crer...
	if (m_pd==NULL)	m_pd=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);
	//Caractristiques de l'image destination
	m_pd->InitialiserImage(m_ps->m_iL,m_ps->m_iH,8);
	m_pd->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_pd->m_iType=0;
	m_pd->InitTracker();//Pas de tracker sur la destination...
	m_pd->m_sNomFic.Format("Im0_270");
	m_ps->m_sNomFic.Format("ImCamera");
	m_ps->UpdateAllViews(NULL);
}
//________________________________________
float CProjAutoDlg::atan3(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=1e10;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}
		}
	}
	return r;
}
//________________________________________
void CProjAutoDlg::OnTimer(UINT nIDEvent) 
{
	short duree;
	if (m_pApp->m_iCarte==3) duree=20; else duree=5;
	short j;
	switch (nIDEvent)
	{
		case 0://Test validit images
			UpdateData(TRUE);
			m_pr=NULL;
			if (m_comboRef.GetCurSel()<0)//Aucune
				m_pr=NULL;
			else
			if (m_comboRef.GetCurSel()==m_comboRef.GetCount()-1)//Aucune
				m_pr=NULL;
			else
				m_pr=m_pDoc[m_comboRef.GetCurSel()];


			if (m_comboDest.GetCurSel()<0)
				m_pd=m_pDoc[m_comboDest.GetCount()-1];
			else
				m_pd=m_pDoc[m_comboDest.GetCurSel()];

			if (m_comboSM256.GetCurSel()<0) 
				m_pp=m_pDoc[m_comboSM256.GetCount()-1];
			else
				m_pp=m_pDoc[m_comboSM256.GetCurSel()];

			if (m_pd==NULL && m_pp==NULL && m_pd==NULL)
			{
				m_s.Format("ATTENTION ! L'image camra sera : %s\nToujours l'image active.",m_ps->m_sNomFic);
				m_btnAuto.EnableWindow(TRUE);
			}
			else
			if (m_pd!=NULL && m_pp!=NULL && m_pd==m_pp)
			{
				m_s.Format("Les images sont identiques !");
				m_btnAuto.EnableWindow(FALSE); 
			}
			else
			if (m_pr!=NULL && m_pp!=NULL && m_pr==m_pp)
			{
				m_s.Format("Les images sont identiques !");
				m_btnAuto.EnableWindow(FALSE); 
			}
			else
			if (m_pr!=NULL && m_pd!=NULL && m_pr==m_pd)
			{
				m_s.Format("Les images sont identiques !");
				m_btnAuto.EnableWindow(FALSE); 
			}
			else
			{
				m_s.Format("ATTENTION !!\nL'image camra sera : %s",m_ps->m_sNomFic);
				m_btnAuto.EnableWindow(TRUE);
			}
			UpdateData(FALSE);
		break;
		//Acq. automatique_____________________________
		case 10://Gnration mire 0
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(10);
				m_sInterFr.Format("%d",m_iInterFr);
				UpdateData(FALSE);
				GenererMire(m_iInterFr,0.0);
				m_iN=0;SetTimer(11,50,NULL);
			}
		break;
		case 11://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(11);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(12,50,NULL);
			}
		break;
		case 12://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(12);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(13,50,NULL);
			}
		break;
		case 13://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(13);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im0);
					m_s="Image phase 0 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im0);
					m_s="Image phase 0 simule.";
				}
				UpdateData(FALSE);
				m_iN=0;SetTimer(14,50,NULL);
			}
		break;
		case 14://Gnration mire 90
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(14);
				GenererMire(m_iInterFr,0.5);
				m_iN=0;SetTimer(15,50,NULL);
			}
		break;//Acq. permanente
		case 15:
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(15);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(16,50,NULL);
			}
		break;
		case 16://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(16);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(17,50,NULL);
			}
		break;
		case 17://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(17);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im90);
					m_s="Image phase 90 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im90);
					m_s="Image phase 90 simule.";
				}
				UpdateData(FALSE);
				m_iN=0;SetTimer(18,50,NULL);
			}
		break;
		case 18://Gnration mire 180
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(18);
				GenererMire(m_iInterFr,1.0);
				m_iN=0;SetTimer(19,50,NULL);
			}
		break;
		case 19://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(19);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(20,50,NULL);
			}
		break;
		case 20://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(20);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(21,50,NULL);
			}
		break;
		case 21://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(21);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im180);
					m_s="Image phase 180 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im180);
					m_s="Image phase 180 simule.";
				}
				UpdateData(FALSE);
				m_iN=0;SetTimer(22,50,NULL);
			}
		break;
		case 22://Gnration mire 270
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(22);
				GenererMire(m_iInterFr,1.5);
				m_iN=0;SetTimer(23,50,NULL);
			}
		break;
		case 23://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(23);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(24,50,NULL);
			}
		break;
		case 24://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(24);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(25,50,NULL);
			}
		break;
		case 25://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(25);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im270);
					m_s="Image phase 270 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im270);
					m_s="Image phase 270 simule.";
				}
				UpdateData(FALSE);
				m_iN=0;SetTimer(26,50,NULL);
			}
		break;
		case 26://Calcul image phase
			//Nom des images
			m_comboSM256.SetWindowText(m_pp->m_sNomFic);	
			m_comboDest.SetWindowText(m_pd->m_sNomFic);	
			KillTimer(26);
			Calcul();
			m_btnTempo.EnableWindow(TRUE);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

//________________________________________
void CProjAutoDlg::OnAcqauto() 
{
	//Acq. automatique suivie du calcul de l'image phase
	if (m_OKP) PremiereFois();
	m_OKP=FALSE;

	UpdateData(TRUE);
	if (m_iInterFr<5) m_iInterFr=5;
	if (m_iInterFr>500) m_iInterFr=500;
	UpdateData(FALSE);

	m_pApp->m_iInterFr=m_iInterFr;
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	GetDlgItem(IDC_IM_PHASE)->EnableWindow(FALSE);
	GetDlgItem(IDC_FREQ)->EnableWindow(FALSE);
	m_ps->m_sNomFic.Format("ImCamera");
	m_ps->UpdateAllViews(NULL);
	m_btnAuto.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnTempo.EnableWindow(FALSE);

	//Dimensionner et positionner les images
	//Image live
	m_ps->PositionnerFenetre(m_pApp->m_iL+20,0);
	m_pd->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_pd->PositionnerFenetre(0,0);
	m_pd->DefinirCurseurs(m_pApp->m_iL,m_pApp->m_iH);

	//Acq. fige, sinon mire n'est pas gnre...
	if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
	m_iN=0;SetTimer(10,50,NULL);
}
//________________________________________
void CProjAutoDlg::Calcul() 
{
	//Calcul de l'image phase
	UpdateData(TRUE);
	CRect	 MMRect;
	MMRect.SetRect(0,0,m_ps->m_iL+14,m_ps->m_iH+30);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	long w,w1,w2,w3,w4;
	float r;
	short i,j,k;
	m_s="Calcul image phase soustraction M256...";
	UpdateData(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	for (i=0;i<m_ps->m_iL;i++)
	{
		for (j=0;j<m_ps->m_iH;j++)
		{
			w1=getpixelcolor(im0,i,j);
			w2=getpixelcolor(im90,i,j);
			w3=getpixelcolor(im180,i,j);
			w4=getpixelcolor(im270,i,j);
		
			if(w1-w3==0)
			{
				r=0;
			}
			else
			{
				r=atan3(1.0*(w4-w2),1.0*(w1-w3));
			}
			//Intervalle [0, 255]
			r=255.0*r/6.28;
			if (r<0) r=0;
			if (r>255) r=255;
			w=(long)(r);
			setpixelcolor(m_pp->image,i,j,w);
		}
	}
	if (m_pr==NULL)
	{
		//AfxMessageBox("Image phase rfrence non dfinie !");
		m_s="Image phase rfrence non dfinie !";
		UpdateData(FALSE);
	}
	else
	{
		for (i=0;i<m_ps->m_iL;i++)
		{
			for (j=0;j<m_ps->m_iH;j++)
			{
				w1=getpixelcolor(m_pp->image,i,j);
				w2=getpixelcolor(m_pr->image,i,j);
				if (w2-w1<0)
					w3=256+w2-w1;
				else
					w3=w2-w1;
				setpixelcolor(m_pp->image,i,j,w3);
			}
		}
		m_btnDemodul.EnableWindow(TRUE);
		m_btnTempo.EnableWindow(TRUE);

		m_s="Image phase soustraction calcule.";
		UpdateData(FALSE);
	}
	//Dimensionner et positionner l'image phase en haut  gauche et la mettre au dessus
	m_pp->UpdateAllViews(NULL);
	m_pp->PositionnerFenetre(20,20);
	m_btnAuto.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	//GetDlgItem(IDC_FREQ)->EnableWindow(TRUE);
	//m_pp->m_pView->MAJ_Fen();

}
//________________________________________
void CProjAutoDlg::OnEmodul() 
{
	//Clic sur dmodulation dans la foule
	GetDlgItem(IDC_FREQ)->EnableWindow(FALSE);
	m_btnDemodul.EnableWindow(FALSE);
	m_btnTempo.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnAuto.EnableWindow(FALSE);
	CDemodul *m_pDemodul;
	short 
		i,
		mode=16;

	m_pDemodul=new CDemodul(m_pp,m_ps,mode,m_pp,0,0);
	i=m_pDemodul->sdewrap();
	if (i>0) m_ps->m_iM=i; 
	//Affichage rsulat de la dmodulation
	//CString z,zz;
	//z.Format("");
	//for (short k=0;k<m_pDemodul->m_liste.GetSize();k++)
	{
		//zz.Format("%s\n",m_pDemodul->m_liste.GetAt(k));
		//z=z+zz;
	}
	//AfxMessageBox(z);

	delete m_pDemodul,
	m_ps->m_sNomFic.Format("ImDemodul_M%d",i);
	m_ps->PositionnerFenetre(40,40);
	//Les images tempo sont perdues...
	m_btnTempo.EnableWindow(FALSE);
	//Tout est fini...
	m_s="Image dmodule calcule et mise dans l'image camra...";
	UpdateData(FALSE);
	//CDialog::OnCancel();
}
//________________________________________
void CProjAutoDlg::OnChangeInterFr() 
{
	int i,j;
	UpdateData(TRUE);	
	i=sscanf(m_sInterFr,"%d",&j);
	if (i==1 && j>1 && j<500) m_iInterFr=j;
}
//________________________________________
void CProjAutoDlg::PostNcDestroy() 
{
	//KillTimer(0);
	//Mettre l'image camra courante, on se trompe moins en reprenant la procdure...
	if (!m_OKP)	m_ps->PositionnerFenetre(30,30);
	CDialog::PostNcDestroy();
}
//________________________________________
void CProjAutoDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CProjAutoDlg::OnCancel() 
{
	//CDialog::OnCancel();
}
//________________________________________
void CProjAutoDlg::OnImtempo() 
{
	switch (m_iI)
	{
		case 0:
			copyimage(im0,m_ps->image);
			m_s="Image temporaire 0 visualise.";
			m_ps->m_sNomFic.Format("ImTempo0");
		break;
		case 1:
			copyimage(im90,m_ps->image);
			m_s="Image temporaire 90 visualise.";
			m_ps->m_sNomFic.Format("ImTempo90");
		break;
		case 2:
			copyimage(im180,m_ps->image);
			m_s="Image temporaire 180 visualise.";
			m_ps->m_sNomFic.Format("ImTempo180");
		break;
		case 3:
			copyimage(im270,m_ps->image);
			m_s="Image temporaire 270 visualise.";
			m_ps->m_sNomFic.Format("ImTempo270");
		break;
	}
	UpdateData(FALSE);
	m_ps->UpdateAllViews(NULL);
	m_iI++; if (m_iI>3) m_iI=0;
}
