// ProjDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "Vicdefs.h"
#include "ProjDlg.h"
#include "Bkdoc.h"
#include "Bkview.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CProjDlg dialog
CProjDlg::CProjDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProjDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProjDlg)
	m_sInterFr = _T("");
	m_s6 = _T("");
	//}}AFX_DATA_INIT
}
void CProjDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProjDlg)
	DDX_Control(pDX, IDIMTEMPO, m_btnImTempo);
	DDX_Control(pDX, IDVISU1, m_btnVisu);
	DDX_Control(pDX, IDC_IMPHASE1, m_comboPhase);
	DDX_Control(pDX, IDC_DEST1, m_comboDest);
	DDX_Control(pDX, IDACQAUTO1, m_btnAuto);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Text(pDX, IDC_FREQ1, m_sInterFr);
	DDX_Text(pDX, IDC_STATIC6, m_s6);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CProjDlg, CDialog)
	//{{AFX_MSG_MAP(CProjDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDVISU1, OnVisu)
	ON_EN_CHANGE(IDC_FREQ1, OnChangeFreq)
	ON_BN_CLICKED(IDACQAUTO1, OnAcqauto)
	ON_BN_CLICKED(IDIMTEMPO, OnImtempo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CProjDlg message handlers
BOOL CProjDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j,k;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	//Image camra
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboPhase.AddString(s);
			m_comboDest.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboDest.AddString(s);
	m_comboPhase.AddString(s);
	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	//Par dfaut sur nouvelle image
	m_comboPhase.GetLBText(m_comboPhase.GetCount()-1,s);
	m_comboPhase.SetWindowText(s);	
	m_iInterFr=m_pApp->m_iInterFr;
	m_sInterFr.Format("%d",m_iInterFr);
	UpdateData(FALSE);
	GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 0");
	m_OKP=TRUE;
	m_iNb=0;
	m_iI=0;//N image temporaire pour visualisation
	m_btnImTempo.EnableWindow(FALSE);
	//On part d'une acquisition fige
	if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();

	//Validit des images
	SetTimer(0,100,NULL);
	return TRUE;
}
//__________________________________________________
void CProjDlg::OnCancel() 
{
	KillTimer(0);
	KillTimer(1);
	KillTimer(2);
	KillTimer(3);
	//Mettre l'image camra courante, on se trompe moins en reprenant la procdure...
	m_ps->PositionnerFenetre(m_pApp->m_iL+20,0);

	m_pApp->m_iInterFr=m_iInterFr;
	CDialog::OnCancel();
}
//__________________________________________________
void CProjDlg::OnOK() 
{
	//CDialog::OnOK();
}
//__________________________________________________
void CProjDlg::GenererMire(short interfr,float phase) 
{
	short i,j;
	float 
		x,x0,xn,
		y,PI=4*atan(1);
	for (i=0;i<m_pd->m_iL;i++)
	{
		y=sin(2*PI*i/interfr+phase*PI);
		for (j=0;j<m_pd->m_iH;j++)
		{
			setpixelcolor(m_pd->image,i,j,(int)((y+1)*127));
		}
	}
	m_pd->m_iType=0;
	m_pd->UpdateAllViews(NULL);
}
//_________________________________________________
void CProjDlg::PremiereFois() 
{
	m_OKP=FALSE;
	m_ps->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,8);
	m_ps->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_ps->DupliquerImageDansTempo(0);
	m_ps->DupliquerImageDansTempo(1);
	m_ps->DupliquerImageDansTempo(2);
	m_ps->DupliquerImageDansTempo(3);

	im0=m_pApp->imt[0];
	im90=m_pApp->imt[1];
	im180=m_pApp->imt[2];
	im270=m_pApp->imt[3];
	
	GetDlgItem(IDC_DEST1)->EnableWindow(FALSE);
	GetDlgItem(IDC_IMPHASE1)->EnableWindow(FALSE);
	//Image source (camra): m_ps
	//Image destination phase: m_pp
	//Si la fentre destination des franges n'existe pas, il faut la crer...
	if (m_pp==NULL)	m_pp=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);
	//Caractristiques de l'image phase
	m_pp->InitialiserImage(m_ps->m_iL,m_ps->m_iH,8);
	//Dimensionner l'image phase  la taille source
	m_pp->m_iH=m_ps->m_iH;
	m_pp->m_iL=m_ps->m_iL;
	m_pp->m_iNbB=8;
	m_pp->m_iType=0;
	m_pp->InitTracker();//Pas de tracker sur la destination...
	m_pp->m_sNomFic.Format("ImPhase");
	m_pp->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_pp->DimensionnerFenetre(m_ps->m_iL,m_ps->m_iH);
	//Image destination des franges
	//Si la fentre destination des franges n'existe pas, il faut la crer...
	if (m_pd==NULL)	m_pd=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);
	//Caractristiques de l'image destination
	m_pd->InitialiserImage(m_ps->m_iL,m_ps->m_iH,8);
	m_pd->DefinirCurseurs(m_ps->m_iL,m_ps->m_iH);
	m_pd->m_iType=0;
	m_pd->InitTracker();//Pas de tracker sur la destination...
	m_pd->m_sNomFic.Format("Im0_270");

	//Nom des images
	m_comboPhase.SetWindowText(m_pp->m_sNomFic);	
	m_comboDest.SetWindowText(m_pd->m_sNomFic);	

	m_ps->m_sNomFic.Format("ImCamera");
	m_ps->UpdateAllViews(NULL);
}
//_________________________________________________
void CProjDlg::Calcul() 
{
	//Calcul de l'image phase
	UpdateData(TRUE);
	CRect	 MMRect;
	MMRect.SetRect(0,0,m_ps->m_iL+14,m_ps->m_iH+30);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	long w,w1,w2,w3,w4;
	float r;
	short i,j;

	m_s6="Calcul image phase...";
	UpdateData(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	for (i=0;i<m_ps->m_iL;i++)
	{
		for (j=0;j<m_ps->m_iH;j++)
		{
			w1=getpixelcolor(im0,i,j);
			w2=getpixelcolor(im90,i,j);
			w3=getpixelcolor(im180,i,j);
			w4=getpixelcolor(im270,i,j);
			if(w1-w3==0)
			{
				r=0;
			}
			else
			{
				r=atan3(1.0*(w4-w2),1.0*(w1-w3));
			}
			//Intervalle [0, 255]
			r=255.0*r/6.28;
			if (r<0) r=0;
			if (r>255) r=255;
			w=(long)(r);
			setpixelcolor(m_pp->image,i,j,w);
		}
	}
	//Dimensionner et positionner l'image phase en haut  gauche et la mettre au dessus
	m_pp->UpdateAllViews(NULL);
	m_pp->PositionnerFenetre(20,20);

	m_btnVisu.EnableWindow(TRUE);
	m_btnAuto.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	GetDlgItem(IDC_FREQ1)->EnableWindow(TRUE);
	m_s6="Image phase calcule. Cliquer sur Fermer ou Acquisition.";
	UpdateData(FALSE);
	//m_pp->m_pView->MAJ_Fen();
}
//_________________________________________________
void CProjDlg::OnVisu() 
{
	KillTimer(0);
	if (m_OKP) PremiereFois();

	UpdateData(TRUE);
	GetDlgItem(IDC_DEST1)->EnableWindow(FALSE);
	GetDlgItem(IDC_IMPHASE1)->EnableWindow(FALSE);
	m_btnAuto.EnableWindow(FALSE);
	//Dimensionner et positionner les images
	m_ps->m_sNomFic.Format("ImCamera");
	m_ps->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_ps->PositionnerFenetre(m_pApp->m_iL+20,0);
	m_ps->DefinirCurseurs(m_pApp->m_iL,m_pApp->m_iH);

	m_pd->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_pd->PositionnerFenetre(0,0);
	m_pd->DefinirCurseurs(m_pApp->m_iL,m_pApp->m_iH);
	
	switch (m_iNb)
	{
		case 0://im0
			m_sInterFr.Format("%d",m_iInterFr);
			UpdateData(FALSE);
			GetDlgItem(IDC_FREQ1)->EnableWindow(FALSE);
			m_btnVisu.EnableWindow(FALSE);
			GenererMire(m_iInterFr,0.0);
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 1://im90
			m_btnVisu.EnableWindow(FALSE);
			GenererMire(m_iInterFr,0.5);
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 2://im180
			m_btnVisu.EnableWindow(FALSE);
			GenererMire(m_iInterFr,1.0);
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 3://im270
			m_btnVisu.EnableWindow(FALSE);
			if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
			GenererMire(m_iInterFr,1.5);
			m_iN=0;SetTimer(3,50,NULL);
		break;
		case 4://calcul image phase
			m_btnVisu.EnableWindow(FALSE);
			m_iN=0;SetTimer(3,50,NULL);
		break;
	}
}
//_________________________________________________
void CProjDlg::OnTimer(UINT nIDEvent) 
{
CString z;
short err;
	short duree;
	if (m_pApp->m_iCarte==3) duree=10; else duree=5;
	switch (nIDEvent)
	{
		case 0://Test validit images
			UpdateData(TRUE);
			if (m_comboDest.GetCurSel()<0) 
				m_pd=m_pDoc[m_comboDest.GetCount()-1];
			else
				m_pd=m_pDoc[m_comboDest.GetCurSel()];

			if (m_comboPhase.GetCurSel()<0) 
				m_pp=m_pDoc[m_comboPhase.GetCount()-1];
			else
				m_pp=m_pDoc[m_comboPhase.GetCurSel()];

			if (m_pp!=NULL && m_pd!=NULL)
			{
				if (m_pp==m_pd)
				{
					m_s6="Les 2 images sont identiques !";
					m_btnVisu.EnableWindow(FALSE); 
				}
				else
				{
					m_s6.Format("Image camra: %s\nTaille: %d x %d pixels",m_ps->m_sNomFic,m_ps->m_iL,m_ps->m_iH);
					m_btnVisu.EnableWindow(TRUE);
				}
			}
			else
			{
				m_s6.Format("Image camra: %s\nTaille: %d x %d pixels",m_ps->m_sNomFic,m_ps->m_iL,m_ps->m_iH);
				m_btnVisu.EnableWindow(TRUE);
			}
			UpdateData(FALSE);
		break;
		case 3://Temporisation 250 ms, puis acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(3);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(1,50,NULL);
			}
		break;
		case 1://Temporisation 250 ms, puis acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(1);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(2,50,NULL);
			}
		break;
		case 2://Mmorisation des images
			m_iN++;
			if (m_iN>duree)//Attente aprs acq. fige 1 seconde pour carte primo
			{
				KillTimer(2);
				switch (m_iNb)
				{
					case 0://im0
						if (m_pApp->m_iCarte!=0)
						{
							copyimage(m_ps->image,im0);
							m_s6="Image phase 0 acquise.";
						}
						else
						{
							//Simulation
							copyimage(m_pd->image,im0);
							m_s6="Image phase 0 simule.";
						}
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 90");
						m_iNb++;
						UpdateData(FALSE);
						m_btnVisu.EnableWindow(TRUE);
					break;
					case 1://im90
						if (m_pApp->m_iCarte!=0)
						{
							copyimage(m_ps->image,im90);
							m_s6="Image phase 90 acquise.";
						}
						else
						{
							//Simulation
							copyimage(m_pd->image,im90);
							m_s6="Image phase 90 simule.";
						}
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 180");
						m_iNb++;
						UpdateData(FALSE);
						m_btnVisu.EnableWindow(TRUE);
					break;
					case 2://im180
						if (m_pApp->m_iCarte!=0)
						{
							copyimage(m_ps->image,im180);
							m_s6="Image phase 180 acquise.";
						}
						else
						{
							//Simulation
							copyimage(m_pd->image,im180);
							m_s6="Image phase 180 simule.";
						}
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 270");
						m_iNb++;
						UpdateData(FALSE);
						m_btnVisu.EnableWindow(TRUE);
					break;
					case 3://im270
						if (m_pApp->m_iCarte!=0)
						{
							copyimage(m_ps->image,im270);
							m_s6="Image phase 270 acquise.";
						}
						else
						{
							//Simulation
							copyimage(m_pd->image,im270);
							m_s6="Image phase 270 simule.\nCalcul image phase...";
						}
						m_iNb++;
						UpdateData(FALSE);
						GetDlgItem(IDVISU1)->SetWindowText("&Calcul im. phase");
						m_btnVisu.EnableWindow(TRUE);
						m_btnImTempo.EnableWindow(TRUE);
					break;
					case 4://image phase
						m_iNb=0;
						m_btnVisu.EnableWindow(FALSE);
						Calcul();
						m_btnVisu.EnableWindow(TRUE);
						GetDlgItem(IDVISU1)->SetWindowText("&Acq. phase 0");
					break;
				}
			}
		break;
		//Acq. automatique_____________________________
		case 10://Gnration mire 0
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(10);
				m_sInterFr.Format("%d",m_iInterFr);
				UpdateData(FALSE);
				GenererMire(m_iInterFr,0.0);
				m_iN=0;SetTimer(11,50,NULL);
			}
		break;
		case 11://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(11);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(12,50,NULL);
			}
		break;
		case 12://Acquisition Im0
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(12);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(13,50,NULL);
			}
		break;
		case 13://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(13);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im0);
					m_s6="Image phase 0 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im0);
					m_s6="Image phase 0 simule.";
				}
				GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 90");
				UpdateData(FALSE);
				m_iN=0;SetTimer(14,50,NULL);
			}
		break;
		case 14://Gnration mire 90
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(14);
				m_sInterFr.Format("%d",m_iInterFr);
				UpdateData(FALSE);
				GenererMire(m_iInterFr,0.5);
				m_iN=0;SetTimer(15,50,NULL);
			}
		break;
		case 15://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(15);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(16,50,NULL);
			}
		break;
		case 16://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(16);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(17,50,NULL);
			}
		break;
		case 17://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(17);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im90);
					m_s6="Image phase 90 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im90);
					m_s6="Image phase 90 simule.";
				}
				GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 180");
				UpdateData(FALSE);
				m_iN=0;SetTimer(18,50,NULL);
			}
		break;
		case 18://Gnration mire 180
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(18);
				m_sInterFr.Format("%d",m_iInterFr);
				UpdateData(FALSE);
				GenererMire(m_iInterFr,1.0);
				m_iN=0;SetTimer(19,50,NULL);
			}
		break;
		case 19://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(19);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(20,50,NULL);
			}
		break;
		case 20://Acq. fige
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(20);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(21,50,NULL);
			}
		break;
		case 21://Copie vers image temporaire
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(21);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im180);
					m_s6="Image phase 180 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im180);
					m_s6="Image phase 180 simule.";
				}
				GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 270");
				UpdateData(FALSE);
				m_iN=0;SetTimer(22,50,NULL);
			}
		break;
		case 22://Gnration mire 270
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(22);
				m_sInterFr.Format("%d",m_iInterFr);
				UpdateData(FALSE);
				GenererMire(m_iInterFr,1.5);
				m_iN=0;SetTimer(23,50,NULL);
			}
		break;
		case 23://Acq. permanente
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(23);
				if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
				m_iN=0;SetTimer(24,50,NULL);
			}
		break;
		case 24://Acquisition Im270
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(24);
				if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
				m_iN=0;SetTimer(25,50,NULL);
			}
		break;
		case 25://Copie vers image temporaire
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(25);
				if (m_pApp->m_iCarte!=0)
				{
					copyimage(m_ps->image,im270);
					m_s6="Image phase 270 acquise.";
				}
				else
				{
					//Simulation
					copyimage(m_pd->image,im270);
					m_s6="Image phase 270 simule.";
				}
				GetDlgItem(IDVISU1)->SetWindowText("&Calcul im. phase");
				UpdateData(FALSE);
				m_iN=0;SetTimer(26,50,NULL);
			}
		break;
		case 26://Calcul image phase
			KillTimer(26);
			Calcul();
			GetDlgItem(IDVISU1)->SetWindowText("&Acq. image phase 0");
			m_btnImTempo.EnableWindow(TRUE);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//_________________________________________________
void CProjDlg::OnAcqauto() 
{
	//Acq. automatique suivie du calcul de l'image phase
	KillTimer(0);
	if (m_OKP) PremiereFois();

	UpdateData(TRUE);
	GetDlgItem(IDC_DEST1)->EnableWindow(FALSE);
	GetDlgItem(IDC_IMPHASE1)->EnableWindow(FALSE);
	GetDlgItem(IDC_FREQ1)->EnableWindow(FALSE);
	m_btnVisu.EnableWindow(FALSE);
	m_btnAuto.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnImTempo.EnableWindow(FALSE);
	//Dimensionner et positionner les images
	//Image live
	//m_ps->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_ps->m_sNomFic.Format("ImCamera");
	m_ps->PositionnerFenetre(m_pApp->m_iL+20,0);

	m_pd->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_pd->PositionnerFenetre(0,0);
	m_pd->DefinirCurseurs(m_pApp->m_iL,m_pApp->m_iH);
	if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
	m_iN=0;SetTimer(10,50,NULL);
}
//_________________________________________________
void CProjDlg::OnChangeFreq() 
{
	int i,j;
	UpdateData(TRUE);	
	i=sscanf(m_sInterFr,"%d",&j);
	if (i==1 && j>1 && j<500) m_iInterFr=j;
}
//________________________________________
float CProjDlg::atan3(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=1e10;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}
		}
	}
	return r;
}
//________________________________________
void CProjDlg::OnImtempo() 
{
	switch (m_iI)
	{
		case 0:
			copyimage(im0,m_ps->image);
			m_s6="Image temporaire 0 visualise.";
			m_ps->m_sNomFic.Format("ImTempo0");
		break;
		case 1:
			copyimage(im90,m_ps->image);
			m_s6="Image temporaire 90 visualise.";
			m_ps->m_sNomFic.Format("ImTempo90");
		break;
		case 2:
			copyimage(im180,m_ps->image);
			m_s6="Image temporaire 180 visualise.";
			m_ps->m_sNomFic.Format("ImTempo180");
		break;
		case 3:
			copyimage(im270,m_ps->image);
			m_s6="Image temporaire 270 visualise.";
			m_ps->m_sNomFic.Format("ImTempo270");
		break;
	}
	UpdateData(FALSE);
	m_ps->UpdateAllViews(NULL);
	m_iI++; if (m_iI>3) m_iI=0;
}
