// PseuDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "PseuDlg.h"
#include "BkDoc.h"
#include "vicdefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CPseuDlg dialog
CPseuDlg::CPseuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPseuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPseuDlg)
	m_s11 = _T("");
	//}}AFX_DATA_INIT
}
void CPseuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPseuDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDVISU, m_btnVisu);
	DDX_Control(pDX, IDC_DEST, m_comboPseu);
	DDX_Text(pDX, IDC_STATIC11, m_s11);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPseuDlg, CDialog)
	//{{AFX_MSG_MAP(CPseuDlg)
	ON_BN_CLICKED(IDVISU, OnVisu)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CPseuDlg message handlers
BOOL CPseuDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	//Image camra
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pCam=(CBkDoc*)pChild->GetActiveDocument(); else m_pCam=NULL;
	m_OKP=TRUE;
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboPseu.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboPseu.AddString(s);
	//Par dfaut sur nouvelle image
	m_comboPseu.GetLBText(m_comboPseu.GetCount()-1,s);
	m_comboPseu.SetWindowText(s);
	m_s11=m_pCam->m_sNomFic;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CPseuDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CPseuDlg::OnCancel() 
{
	if (m_OKP==FALSE)
	{
		 KillTimer(40);
		 KillTimer(41);
		 KillTimer(42);
	}
	m_pCam->FigerAcq();
	CDialog::OnCancel();
}
//________________________________________
void CPseuDlg::OnVisu() 
{
	//On part d'une acquisition fige
	m_btnVisu.EnableWindow(FALSE);
	if (m_OKP) PremiereFois();
	if (m_pApp->m_iCarte!=0) m_pCam->FigerAcq();
	m_iN=0;SetTimer(40,50,NULL);	
}
//_________________________________________________
void CPseuDlg::PremiereFois() 
{
	m_OKP=FALSE;
	if (m_comboPseu.GetCurSel()<0) 
		m_pPseu=m_pDoc[m_comboPseu.GetCount()-1];
	else
		m_pPseu=m_pDoc[m_comboPseu.GetCurSel()];

	m_pCam->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,8);
	m_pCam->DefinirCurseurs(m_pCam->m_iL,m_pCam->m_iH);

	//Image source (camra): m_pCam
	//Image pseudo: m_pPseu
	//Si la fentre destination des franges n'existe pas, il faut la crer...
	if (m_pPseu==NULL)	m_pPseu=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	m_pPseu->InitialiserImage(m_pPseu->m_iL,m_pPseu->m_iH,24);

	//Dimensionner l'image phase  la taille source
	m_pPseu->m_iH=m_pCam->m_iH;
	m_pPseu->m_iL=m_pCam->m_iL;
	m_pPseu->m_iNbB=24;
	m_pPseu->m_iType=0;
	m_pPseu->InitTracker();//Pas de tracker sur la destination...
	m_pPseu->m_sNomFic.Format("ImPseudo");
	m_pPseu->DefinirCurseurs(m_pCam->m_iL,m_pCam->m_iH);
	m_pPseu->DimensionnerFenetre(m_pCam->m_iL,m_pCam->m_iH);
	m_comboPseu.SetWindowText("ImPseudo");
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	m_pCam->m_sNomFic.Format("ImCamera");
	m_s11="ImCamera";
	m_pCam->PositionnerFenetre(m_pCam->m_iL+20,0);
	m_pPseu->PositionnerFenetre(0,0);
	UpdateData(FALSE);
}
//_________________________________________________
void CPseuDlg::OnTimer(UINT nIDEvent) 
{
	short i,j,duree=1,duree1;
	long w;
	unsigned char R,V,B;
	if (m_pApp->m_iCarte==3) duree1=1; else duree1=1;//Pour carte Primo, duree1=1 s
	switch(nIDEvent)
	{
		case 40://Acq. permanente
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(40);
				if (m_pApp->m_iCarte!=0) m_pCam->AcqPerm();
				m_iN=0;SetTimer(41,50,NULL);
			}
		break;
		case 41://Temporisation 150 ms, puis acq. fige
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(41);
				if (m_pApp->m_iCarte!=0) m_pCam->FigerAcq();
				m_iN=0;SetTimer(42,50,NULL);
			}
		break;
		case 42://Conversion en pseudo-couleurs
			m_iN++;
			if (m_iN>duree1)
			{
				KillTimer(42);
				for (i=m_pCam->image->stx;i<=m_pCam->image->endx;i++)
				{
					for (j=m_pCam->image->sty;j<=m_pCam->image->endy;j++)
					{
						w=getpixelcolor(m_pCam->image,i,j);
						m_pApp->PseudoCoul(w,&R,&V,&B);
						w=(long)R+256*V+65536*B;
						setpixelcolor(m_pPseu->image,i,j,w);
					}
				}
				m_pPseu->UpdateAllViews(NULL);
				m_iN=0;SetTimer(40,50,NULL);
			}
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
