// PsiDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "PsiDlg.h"
#include "Piezo.h"
#include "BkDoc.h"
#include "math.h"
#include "demodul.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CPsiDlg dialog
CPsiDlg::CPsiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPsiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPsiDlg)
	m_fX90 = 0.0f;
	m_fXD = 0.0f;
	m_fX0 = 0.0f;
	m_fX180 = 0.0f;
	m_fX270 = 0.0f;
	m_s = _T("");
	m_s1 = _T("");
	m_OKAffiche = FALSE;
	//}}AFX_DATA_INIT
}
void CPsiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPsiDlg)
	DDX_Control(pDX, IDC_COMBO3, m_comboMasque);
	DDX_Control(pDX, IDCANCEL, m_btnFermer);
	DDX_Control(pDX, IDC_DEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDC_COMBO2, m_comboTopo);
	DDX_Control(pDX, IDC_COMBO1, m_comboPhas);
	DDX_Text(pDX, IDC_X90, m_fX90);
	DDX_Text(pDX, IDC_XD, m_fXD);
	DDX_Text(pDX, IDC_X0, m_fX0);
	DDX_Text(pDX, IDC_X180, m_fX180);
	DDX_Text(pDX, IDC_X270, m_fX270);
	DDX_Text(pDX, IDC_STATIC50, m_s);
	DDX_Text(pDX, IDC_STATIC51, m_s1);
	DDX_Check(pDX, IDC_CHECK1, m_OKAffiche);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPsiDlg, CDialog)
	//{{AFX_MSG_MAP(CPsiDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_DEMARRER, OnDemarrer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CPsiDlg message handlers

BOOL CPsiDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	CString s;

	m_pApp=((CBkApp*)AfxGetApp());
	//Image camra
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pCam=(CBkDoc*)pChild->GetActiveDocument(); else m_pCam=NULL;

	m_s="Spcifier les positions pizo de dphasage...";
	m_fXD=0;	
	m_fX0=m_pApp->m_fPhX[0];	
	m_fX90=m_pApp->m_fPhX[1];	
	m_fX180=m_pApp->m_fPhX[2];	
	m_fX270=m_pApp->m_fPhX[3];
	UpdateData(FALSE);
	//Dphaseurs
	m_pPiezo=new CPiezo(m_pApp->m_radioPortSeriePiezo);
	m_OKP=TRUE;


	if (pChild) m_pCam=(CBkDoc*)pChild->GetActiveDocument(); else m_pCam=NULL;
	//Tableau de pointeurs sur les documents ouverts, sauf l'image camra qui est exclue de la liste...
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			//Images dj ouvertes
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboTopo.AddString(s);
			m_comboPhas.AddString(s);
			m_comboMasque.AddString(s);
		}         
	}
	//Possibilit d'ouvrir aussi une nouvelle image
	s="NOUVELLE IMAGE";
	m_comboTopo.AddString(s);
	m_comboPhas.AddString(s);
	s="AUCUNE";
	m_comboMasque.AddString(s);
	//Par dfaut sur nouvelle image
	m_comboTopo.GetLBText(m_comboTopo.GetCount()-1,s);
	m_comboTopo.SetWindowText(s);	
	m_comboPhas.GetLBText(m_comboPhas.GetCount()-1,s);
	m_comboPhas.SetWindowText(s);	
	m_comboMasque.GetLBText(m_comboMasque.GetCount()-1,s);
	m_comboMasque.SetWindowText(s);	
	m_s1.Format("%s",m_pCam->m_sNomFic);

	//Si le nombre de fentre dja ouverte est infrieur  4, on propose l'affichage
	//des images intermdiaires
	m_OKAffiche=FALSE;
	if (m_pApp->m_iNb>m_pApp->m_iNbMax-1-3) GetDlgItem(IDC_CHECK1)->EnableWindow(FALSE);

	UpdateData(FALSE);
	SetTimer(44,200,NULL);
	return TRUE;
}
//________________________________________
void CPsiDlg::OnCancel() 
{
	KillTimer(44);
	delete m_pPiezo;

	//Dconnexion de la camra
	if (!m_OKP)
	{
		m_pCam->PositionnerFenetre(0,0);
		m_pCam->Deconnexion();
	}
	CDialog::OnCancel();
}
//________________________________________
void CPsiDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CPsiDlg::PremiereFois() 
{
	m_OKP=FALSE;
	m_pCam->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,8);
	//Eventuellement ouverture des nouvelles fentres
	if (m_pTopo==NULL)	m_pTopo=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	if (m_pPhas==NULL)	m_pPhas=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	
	short l,h;
	//Taille de l'image camra
	l=m_pCam->image->endx-m_pCam->image->stx+1;
	h=m_pCam->image->endy-m_pCam->image->sty+1;


	m_pTopo->InitialiserImage(l,h,8);
	m_pPhas->InitialiserImage(l,h,8);

	m_pCam->DimensionnerFenetre(l,h);
	m_pTopo->DimensionnerFenetre(l,h);
	m_pPhas->DimensionnerFenetre(l,h);

	m_pCam->DefinirCurseurs(l,h);
	m_pTopo->DefinirCurseurs(l,h);
	m_pPhas->DefinirCurseurs(l,h);

	m_pTopo->m_iType=0;
	m_pCam->m_iType=0;
	m_pPhas->m_iType=0;

	m_pCam->m_sNomFic.Format("Camera%d",m_pCam->m_iNo);
	m_pPhas->m_sNomFic.Format("ImPhasee%d",m_pPhas->m_iNo);
	m_pTopo->m_sNomFic.Format("Topo%d",m_pTopo->m_iNo);

	m_pCam->InitTracker();
	m_pTopo->InitTracker();
	m_pPhas->InitTracker();

	m_comboTopo.SetWindowText(m_pTopo->m_sNomFic);m_comboTopo.EnableWindow(FALSE);
	m_comboPhas.SetWindowText(m_pPhas->m_sNomFic);m_comboPhas.EnableWindow(FALSE);
	m_s1=m_pCam->m_sNomFic;

	m_pPhas->PositionnerFenetre(0,h+30);
	m_pTopo->PositionnerFenetre(l+15,0);

	if (m_OKAffiche) OuvreImagesIntermediaires();


	m_pCam->PositionnerFenetre(0,0);
	m_pCam->Connexion();

	if (m_pMasque!=NULL)
	{
		m_pMasque->PositionnerFenetre(l+15,h+30);
		m_pMasque->m_sNomFic.Format("Masque%d",m_pTopo->m_iNo);
		m_comboMasque.SetWindowText(m_pMasque->m_sNomFic);
	}
	m_comboMasque.EnableWindow(FALSE);

	m_pCam->DupliquerImageDansTempo(0);
	m_pCam->DupliquerImageDansTempo(1);
	m_pCam->DupliquerImageDansTempo(2);
	m_pCam->DupliquerImageDansTempo(3);
	im0=m_pApp->imt[0];
	im90=m_pApp->imt[1];
	im180=m_pApp->imt[2];
	im270=m_pApp->imt[3];

	UpdateData(FALSE);
}
//________________________________________
void CPsiDlg::OnTimer(UINT nIDEvent) 
{
	BOOL ok;
	short p,u;
	switch (nIDEvent)
	{
		case 44://Test de la validit des images slectionnes
			//L'image Coul doit tre diffrente de Dest, sauf si elles sont nouvelles
			if (m_comboMasque.GetCurSel()<0)
				m_pMasque=m_pDoc[m_comboMasque.GetCount()-1];
			else
				m_pMasque=m_pDoc[m_comboMasque.GetCurSel()];
			if (m_comboPhas.GetCurSel()<0)
				m_pPhas=m_pDoc[m_comboPhas.GetCount()-1];
			else
				m_pPhas=m_pDoc[m_comboPhas.GetCurSel()];
			if (m_comboTopo.GetCurSel()<0)
				m_pTopo=m_pDoc[m_comboTopo.GetCount()-1];
			else
				m_pTopo=m_pDoc[m_comboTopo.GetCurSel()];

			if (m_pTopo==NULL && m_pPhas==NULL) 
				ok=TRUE;
			else
			if (m_pTopo==m_pPhas)
				ok=FALSE;
			else
				ok=TRUE;

			if (ok)
			{
				if (m_pMasque!=NULL && (m_pMasque==m_pPhas ||m_pMasque==m_pTopo)) ok=FALSE;
			}

			m_btnDemarrer.EnableWindow(ok);
		break;
		case 50:
			KillTimer(50);
			p=PositionnerPiezo(1e-3*m_fXD);//Paramtre en m, retourne p dans l'intervalle [0, 1023]
			//u=(short)(100.0*p/1023.0);//Calcul de la tension piezo dans [0, 100]
			m_s.Format("xd(nm): %1.1f\nPizo(V): %1.2f",m_fXD,100.0*p/1024);
			UpdateData(FALSE);
			m_iN=0;SetTimer(51,50,NULL);
		break;
		case 51:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(51);
				m_pCam->AcqPerm();
				p=PositionnerPiezo(1e-3*m_fX0);//Paramtre en m, retourne p dans l'intervalle [0, 1023]
				//u=(short)(100.0*p/1023.0);//Calcul de la tension piezo dans [0, 100]
				m_s.Format("x0(nm): %1.1f\nPizo(V): %1.2f",m_fX0,100.0*p/1024);
				UpdateData(FALSE);
				m_iN=0;SetTimer(52,50,NULL);
			}
		break;
		case 52:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(52);
				m_pCam->FigerAcq();
				copyimage(m_pCam->image,im0);
			
				m_iN=0;SetTimer(53,50,NULL);
			}
		break;
		case 53:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(53);
				m_pCam->AcqPerm();
				p=PositionnerPiezo(1e-3*m_fX90);//Paramtre en m, retourne p dans l'intervalle [0, 1023]
				u=(short)(100.0*p/1023.0);//Calcul de la tension piezo dans [0, 100]
				m_s.Format("x90(nm): %1.1f\nPizo(V): %1.2f",m_fX90,100.0*p/1024);
				UpdateData(FALSE);
				m_iN=0;SetTimer(54,50,NULL);
			}
		break;
		case 54:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(54);
				m_pCam->FigerAcq();
				copyimage(m_pCam->image,im90);
			
				m_iN=0;SetTimer(55,50,NULL);
			}
		break;
		case 55:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(55);
				m_pCam->AcqPerm();
				p=PositionnerPiezo(1e-3*m_fX180);//Paramtre en m, retourne p dans l'intervalle [0, 1023]
				u=(short)(100.0*p/1023.0);//Calcul de la tension piezo dans [0, 100]
				m_s.Format("x180(nm): %1.1f\nPizo(V): %1.2f",m_fX180,100.0*p/1024);
				UpdateData(FALSE);
				m_iN=0;SetTimer(56,50,NULL);
			}
		break;
		case 56:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(56);
				m_pCam->FigerAcq();
				copyimage(m_pCam->image,im180);
				m_iN=0;SetTimer(57,50,NULL);
			}
		break;
		case 57:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(57);
				m_pCam->AcqPerm();
				p=PositionnerPiezo(1e-3*m_fX270);//Paramtre en m, retourne p dans l'intervalle [0, 1023]
				u=(short)(100.0*p/1023.0);//Calcul de la tension piezo dans [0, 100]
				m_s.Format("x270(nm): %1.1f\nPizo(V): %1.2f",m_fX270,100.0*p/1024);
				UpdateData(FALSE);
				m_iN=0;SetTimer(58,50,NULL);
			}
		break;
		case 58:
			m_iN++;
			if (m_iN>10)
			{
				KillTimer(58);
				m_pCam->FigerAcq();
				copyimage(m_pCam->image,im270);
				if (m_OKAffiche)
				{
					//Affectation images intermdiaires  faire avant dmodulation
					//Car les images temporaires sont rutilises
					copyimage(im0,m_pInter0->image);
					copyimage(im90,m_pInter90->image);
					copyimage(im180,m_pInter180->image);
					copyimage(im270,m_pInter270->image);
				}
				//On fait les calculs de l'image phase et dmodule
				Calcul();
				//Remettre le piezo  0
				PositionnerPiezo(1e-3*m_fXD);
				//On ferme la bote de dialogue
				OnCancel();
			}
		break;
	}	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CPsiDlg::OnDemarrer() 
{
	KillTimer(44);
	UpdateData(TRUE);
	//Vrification des saisies utilisateur
	if (m_fX0<m_fXD) m_fX0=m_fXD;
	if (m_fX90<m_fX0) m_fX90=m_fX0+1;
	if (m_fX180<m_fX90) m_fX180=m_fX90+1;
	if (m_fX270<m_fX180) m_fX270=m_fX180+1;

	UpdateData(FALSE);

	m_pApp->m_fPhX[0]=m_fX0;	
	m_pApp->m_fPhX[1]=m_fX90;	
	m_pApp->m_fPhX[2]=m_fX180;	
	m_pApp->m_fPhX[3]=m_fX270;
	
	m_btnFermer.EnableWindow(FALSE);
	m_btnDemarrer.EnableWindow(FALSE);
	GetDlgItem(IDC_X0)->EnableWindow(FALSE);
	GetDlgItem(IDC_X90)->EnableWindow(FALSE);
	GetDlgItem(IDC_X180)->EnableWindow(FALSE);
	GetDlgItem(IDC_X270)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK1)->EnableWindow(FALSE);

	//La premire que l'on clique sur Dmarrer, il faut peut-tre ouvrir les images et les dimensionner
	if (m_OKP) PremiereFois();	

	zeroimage(0,m_pTopo->image);
	zeroimage(0,m_pPhas->image);

	zeroimage(0,im0);
	zeroimage(0,im90);
	zeroimage(0,im180);
	zeroimage(0,im270);

	SetTimer(50,50,NULL);
	
}

//________________________________________
short CPsiDlg::PositionnerPiezo(float x)//En m 
{
	short i;
	i=m_pCam->Hysteresis(x);
	m_pPiezo->Pilote(i);
	return i;
}
//________________________________________
float CPsiDlg::atan3(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=1e10;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}
		}
	}
	return r;
}
//_________________________________________________
void CPsiDlg::Calcul() 
{
	//Calcul de l'image phase
	long w,w1,w2,w3,w4;
	float r;
	short i,j;

	m_s="Calcul image phase...";
	UpdateData(FALSE);

	for (i=0;i<m_pPhas->m_iL;i++)
	{
		for (j=0;j<m_pPhas->m_iH;j++)
		{
			w1=getpixelcolor(im0,i,j);
			w2=getpixelcolor(im90,i,j);
			w3=getpixelcolor(im180,i,j);
			w4=getpixelcolor(im270,i,j);
			if(w1-w3==0)
			{
				r=0;
			}
			else
			{
				r=atan3(1.0*(w4-w2),1.0*(w1-w3));
			}
			//Intervalle [0, 255]
			r=255.0*r/6.28;
			if (r<0) r=0;
			if (r>255) r=255;
			w=(long)(r);
			setpixelcolor(m_pPhas->image,i,j,w);
		}
	}
	m_pPhas->UpdateAllViews(NULL);
	m_s="Image phase calcule...";
	UpdateData(FALSE);

	CDemodul *m_pDemodul;
	//													in			out					masque
	//256: masque dfini
	//4096: inversion sens dmodulation
	if (m_pMasque==NULL)
		m_pDemodul=new CDemodul(m_pPhas,m_pTopo,16+4096,m_pPhas,0,0);
	else
		m_pDemodul=new CDemodul(m_pPhas,m_pTopo,16+256+4096,m_pMasque,0,0);

	//Utilisation des iamges temporaires 0  3...
	i=m_pDemodul->sdewrap();
	if (i>0) m_pTopo->m_iM=i; 

	delete m_pDemodul,
	m_pTopo->m_sNomFic.Format("Topo%d_M%d",m_pTopo->m_iNo,i);

	m_pTopo->UpdateAllViews(NULL);
	m_s.Format("Image dmodule calcule...\nM=%d (saut de phase)",i);
	UpdateData(FALSE);
}
//_________________________________________________
void CPsiDlg::OuvreImagesIntermediaires() 
{
	m_pInter0=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	m_pInter90=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	m_pInter180=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	m_pInter270=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);

	m_pInter0->m_sNomFic.Format("I0_%d",m_pInter0->m_iNo);
	m_pInter90->m_sNomFic.Format("I90_%d",m_pInter90->m_iNo);
	m_pInter180->m_sNomFic.Format("I180_%d",m_pInter180->m_iNo);
	m_pInter270->m_sNomFic.Format("I270_%d",m_pInter270->m_iNo);

	m_pInter0->InitTracker();
	m_pInter90->InitTracker();
	m_pInter180->InitTracker();
	m_pInter270->InitTracker();

	m_pInter0->PositionnerFenetre(m_pCam->m_iL+15,m_pCam->m_iH+30);
	m_pInter90->PositionnerFenetre(m_pCam->m_iL+15+10,m_pCam->m_iH+30+10);
	m_pInter180->PositionnerFenetre(m_pCam->m_iL+15+20,m_pCam->m_iH+30+20);
	m_pInter270->PositionnerFenetre(m_pCam->m_iL+15+30,m_pCam->m_iH+30+30);

	m_pInter0->InitialiserImage(m_pCam->m_iL,m_pCam->m_iH,8);
	m_pInter90->InitialiserImage(m_pCam->m_iL,m_pCam->m_iH,8);
	m_pInter180->InitialiserImage(m_pCam->m_iL,m_pCam->m_iH,8);
	m_pInter270->InitialiserImage(m_pCam->m_iL,m_pCam->m_iH,8);
}