// TemMo2Dlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "TemMo2Dlg.h"
#include "Bkdoc.h"
#include "piezo.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CTemMo2Dlg dialog
CTemMo2Dlg::CTemMo2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTemMo2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemMo2Dlg)
	m_iGain = 0;
	m_sTexte = _T("");
	m_iU0 = 0;
	m_iU180 = 0;
	m_iU270 = 0;
	m_iU90 = 0;
	//}}AFX_DATA_INIT
}
void CTemMo2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemMo2Dlg)
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Control(pDX, IDDEMARRER2, m_btnDemarrer);
	DDX_Text(pDX, IDC_GAIN, m_iGain);
	DDX_Text(pDX, IDC_STATIC_NB, m_sTexte);
	DDX_Text(pDX, IDC_U0, m_iU0);
	DDX_Text(pDX, IDC_U180, m_iU180);
	DDX_Text(pDX, IDC_U270, m_iU270);
	DDX_Text(pDX, IDC_U90, m_iU90);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTemMo2Dlg, CDialog)
	//{{AFX_MSG_MAP(CTemMo2Dlg)
	ON_BN_CLICKED(IDDEMARRER2, OnDemarrer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CTemMo2Dlg message handlers
BOOL CTemMo2Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	m_sTexte.Format("%s",m_ps->m_sNomFic);
	m_iU0=0;	
	m_iU0=m_pApp->m_iPhU[0];	
	m_iU90=m_pApp->m_iPhU[1];	
	m_iU180=m_pApp->m_iPhU[2];	
	m_iU270=m_pApp->m_iPhU[3];
	m_iGain=5;
	//Dimensionner l'image camra
	m_ps->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,m_pApp->m_iNbB);
	m_ps->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_ps->DefinirCurseurs(m_pApp->m_iL,m_pApp->m_iH);
	m_ps->m_iType=0;

	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboDest.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboDest.AddString(s);
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	
	//Dphaseur
	m_pPiezo=new CPiezo(m_pApp->m_radioPortSeriePiezo);
	m_OKP=TRUE;
	m_OK=FALSE;

	//Dupliquer l'image source vers l'image temporaire n0 (phase 0)
	m_ps->DupliquerImageDansTempo(0);
	//Dupliquer l'image source vers l'image temporaire n1 (phase 90)
	m_ps->DupliquerImageDansTempo(1);
	//Dupliquer l'image source vers l'image temporaire n2 (phase 180)
	m_ps->DupliquerImageDansTempo(2);
	//Dupliquer l'image source vers l'image temporaire n3 (phase 270)
	m_ps->DupliquerImageDansTempo(3);
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CTemMo2Dlg::OnCancel() 
{
	//CDialog::OnCancel();
}
//________________________________________
void CTemMo2Dlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CTemMo2Dlg::OnDemarrer() 
{
	if (!m_OK)
	{
		//Dmarrer
		UpdateData(TRUE);
		m_btnDemarrer.SetWindowText("&Arrter");
		GetDlgItem(IDC_U0)->EnableWindow(FALSE);
		GetDlgItem(IDC_U90)->EnableWindow(FALSE);
		GetDlgItem(IDC_U180)->EnableWindow(FALSE);
		GetDlgItem(IDC_U270)->EnableWindow(FALSE);
		GetDlgItem(IDC_GAIN)->EnableWindow(FALSE);
		if (m_OKP) PremiereFois();
		//Test de validit des entres
		if (m_iU0<0) m_iU0=0;
		if (m_iU0>495) m_iU0=495;
		m_pApp->m_iPhU[0]=m_iU0;	

		if (m_iU90<1) m_iU90=1;
		if (m_iU90>496) m_iU90=496;
		if (m_iU90<m_iU0) m_iU90=m_iU0+1;
		m_pApp->m_iPhU[1]=m_iU90;	

		if (m_iU180<2) m_iU180=2;
		if (m_iU180>497) m_iU180=497;
		if (m_iU180<m_iU90) m_iU180=m_iU90+1;
		m_pApp->m_iPhU[2]=m_iU180;	

		if (m_iU270<3) m_iU270=3;
		if (m_iU270>498) m_iU270=498;
		if (m_iU270<m_iU180) m_iU270=m_iU180+1;
		m_pApp->m_iPhU[3]=m_iU270;	

		if (m_iGain<1) m_iGain=1;
		if (m_iGain>20) m_iGain=20;

		UpdateData(FALSE);
		m_iNb=0;
		m_OKBusy=FALSE;SetTimer(1,50,NULL);
	}
	else
	{
		//Arrter
		KillTimer(1);
		m_btnDemarrer.SetWindowText("&Dmarrer");
		GetDlgItem(IDC_U0)->EnableWindow(TRUE);
		GetDlgItem(IDC_U90)->EnableWindow(TRUE);
		GetDlgItem(IDC_U180)->EnableWindow(TRUE);
		GetDlgItem(IDC_U270)->EnableWindow(TRUE);
		GetDlgItem(IDC_GAIN)->EnableWindow(TRUE);
	}
	m_OK=!m_OK;
}
//_______________________________________
void CTemMo2Dlg::OnTimer(UINT nIDEvent) 
{
	float r;
	short i,j;
	long w;
	if (m_OKBusy==FALSE)
	{	
		m_OKBusy=TRUE;
		//Acquisition image 0________________
		m_ps->AcqPerm();
		m_pPiezo->Tension(0);
		Sleep(50);
		m_pPiezo->Tension(m_iU0);
		Sleep(50);
		m_ps->FigerAcq();
		copyimage(m_ps->image,m_pApp->imt[0]);
		//Acquisition image 90_______________
		m_ps->AcqPerm();
		m_pPiezo->Tension(m_iU90);
		Sleep(50);
		m_ps->FigerAcq();
		copyimage(m_ps->image,m_pApp->imt[1]);
		//Acquisition image 180______________
		m_ps->AcqPerm();
		m_pPiezo->Tension(m_iU180);
		Sleep(50);
		m_ps->FigerAcq();
		copyimage(m_ps->image,m_pApp->imt[2]);
		//Acquisition image 270______________
		m_ps->AcqPerm();
		m_pPiezo->Tension(m_iU270);
		Sleep(50);
		m_ps->FigerAcq();
		copyimage(m_ps->image,m_pApp->imt[3]);
		//Calcul image phase d'aprs formule internet
		for (i=m_ps->image->stx;i<=m_ps->image->endx;i++)
		{
			for (j=m_ps->image->sty;j<=m_ps->image->endy;j++)
			{
				r=pow(pow(getpixelcolor(m_pApp->imt[0],i,j)-getpixelcolor(m_pApp->imt[2],i,j),2)+pow(getpixelcolor(m_pApp->imt[1],i,j)-getpixelcolor(m_pApp->imt[3],i,j),2),0.5);
				r=r*m_iGain;
				if (r>255) r=255;
				w=(long)r;
				setpixelcolor(m_pd->image,i,j,w);
			}
		}
		m_pd->UpdateAllViews(NULL);
		m_iNb++;
		//m_s.Format("(%d)",m_iNb);
		//UpdateData(FALSE);
		m_OKBusy=FALSE;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CTemMo2Dlg::PremiereFois() 
{
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	//Image source: m_ps
	//Image destination
	//Si l'utilisateur n'a pas touch au combo...
	if (m_comboDest.GetCurSel()<0)
		m_pd=m_pDoc[m_comboDest.GetCount()-1];
	else
		m_pd=m_pDoc[m_comboDest.GetCurSel()];

	if (m_pd==NULL)	m_pd=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);
	
	short l,h,nbB;
	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;
	m_pd->InitialiserImage(l,h,8);
	//Dimensionner l'image destination  la taille source
	m_pd->DimensionnerFenetre(l,h);
	m_pd->DefinirCurseurs(l,h);
	m_pd->m_iType=0;
	m_pd->m_sNomFic.Format("TempsMoy%d",m_pd->m_iNo);
	m_pd->InitTracker();//Pas de tracker sur la destination...
	m_comboDest.SetWindowText(m_pd->m_sNomFic);	
	m_ps->m_sNomFic.Format("Camera%d",m_ps->m_iNo);
	m_sTexte=m_ps->m_sNomFic;UpdateData(FALSE);

	m_ps->PositionnerFenetre(l+15,0);
	m_pd->PositionnerFenetre(0,0);
}
//________________________________________
