// TemMoDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "TemMoDlg.h"
#include "BkDoc.h"
#include "piezo.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CTemMoDlg dialog
CTemMoDlg::CTemMoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTemMoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemMoDlg)
	m_iGain = 0;
	m_iU0 = 0;
	m_iU180 = 0;
	m_sTexte = _T("");
	m_iMoy = 0;
	//}}AFX_DATA_INIT
}
void CTemMoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemMoDlg)
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Text(pDX, IDC_GAIN, m_iGain);
	DDX_Text(pDX, IDC_U0, m_iU0);
	DDX_Text(pDX, IDC_U180, m_iU180);
	DDX_Text(pDX, IDC_STATIC_NB, m_sTexte);
	DDX_Text(pDX, IDC_MOY, m_iMoy);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTemMoDlg, CDialog)
	//{{AFX_MSG_MAP(CTemMoDlg)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CTemMoDlg message handlers
BOOL CTemMoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j,rcode;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	m_sTexte.Format("%s",m_ps->m_sNomFic);
	//Dimensionner l'image camra
	m_ps->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,m_pApp->m_iNbB);
	m_ps->DimensionnerFenetre(m_pApp->m_iL,m_pApp->m_iH);
	m_ps->DefinirCurseurs(m_pApp->m_iL,m_pApp->m_iH);
	m_ps->m_iType=0;

	//Dupliquer l'image source vers l'image temporaire n0 (phase 0)
	m_ps->DupliquerImageDansTempo(0);
	
	short l,h,nbB,l1,h1,nbB1;
	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;

	//Image temporaire n1 en 24 bits pour recevoir somme des images
	l1=m_pApp->imt[1]->endx-m_pApp->imt[1]->stx+1;
	h1=m_pApp->imt[1]->endy-m_pApp->imt[1]->sty+1;
	nbB1=m_pApp->imt[1]->bmh->biBitCount;
	
	if (l!=l1 || h!=h1 || nbB1!=24)
	{
		freeimage(m_pApp->imt[1]);
		allocimage(m_pApp->imt[1],l,h,24);
	}

	m_iGain=5;
	m_iMoy=3;
	m_OKP=TRUE;
	m_OK=FALSE;
	m_iU0=m_pApp->m_iPhU[0];	
	m_iU180=m_pApp->m_iPhU[2];	
	
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboDest.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboDest.AddString(s);
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	//Dphaseur
	m_pPiezo=new CPiezo(m_pApp->m_radioPortSeriePiezo);
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CTemMoDlg::PostNcDestroy() 
{
	delete m_pPiezo;	
	CDialog::PostNcDestroy();
}
//________________________________________
void CTemMoDlg::OnCancel() 
{
	//CDialog::OnCancel();
}
//________________________________________
void CTemMoDlg::PremiereFois() 
{
	GetDlgItem(IDC_DEST)->EnableWindow(FALSE);
	//Image source: m_ps
	//Image destination
	//Si l'utilisateur n'a pas touch au combo...
	if (m_comboDest.GetCurSel()<0)
		m_pd=m_pDoc[m_comboDest.GetCount()-1];
	else
		m_pd=m_pDoc[m_comboDest.GetCurSel()];

	if (m_pd==NULL)	m_pd=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);

	short l,h,nbB;
	l=m_ps->image->endx-m_ps->image->stx+1;
	h=m_ps->image->endy-m_ps->image->sty+1;
	nbB=m_ps->image->bmh->biBitCount;
	m_pd->InitialiserImage(l,h,8);
	//Dimensionner l'image destination  la taille source
	m_pd->DimensionnerFenetre(l,h);
	m_pd->DefinirCurseurs(l,h);
	m_pd->m_iType=0;
	m_pd->m_sNomFic.Format("TempsMoy%d",m_pd->m_iNo);
	m_comboDest.SetWindowText(m_pd->m_sNomFic);	
	m_pd->InitTracker();//Pas de tracker sur la destination...

	m_ps->m_sNomFic.Format("Camera%d",m_ps->m_iNo);
	m_sTexte=m_ps->m_sNomFic;UpdateData(FALSE);
	m_ps->PositionnerFenetre(l+15,0);
	m_pd->PositionnerFenetre(0,0);
}
//________________________________________
void CTemMoDlg::OnDemarrer() 
{
	if (!m_OK)
	{
		//Dmarrer
		UpdateData(TRUE);
		if (m_iGain<1) m_iGain=1;
		if (m_iGain>100) m_iGain=100;
		if (m_iU0>490) m_iU0=490;
		if (m_iU0<0) m_iU0=0;

		if (m_iU180<10) m_iU180=10;
		if (m_iU180>500) m_iU180=500;

		if (m_iU180<=m_iU0) m_iU180=m_iU0+1;
		if (m_iU0>=m_iU180) m_iU0=m_iU180-1;
		
		if (m_iMoy<1) m_iMoy=1;
		if (m_iMoy>20) m_iMoy=20;
		UpdateData(FALSE);
		m_btnDemarrer.SetWindowText("&Arrter");
		GetDlgItem(IDC_U0)->EnableWindow(FALSE);
		GetDlgItem(IDC_U180)->EnableWindow(FALSE);
		GetDlgItem(IDC_GAIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_MOY)->EnableWindow(FALSE);
		if (m_OKP) PremiereFois();
		m_iNb=0;
		m_OKBusy=FALSE;SetTimer(1,50,NULL);
	}
	else
	{
		//Arrter
		KillTimer(1);
		m_btnDemarrer.SetWindowText("&Dmarrer");
		GetDlgItem(IDC_U0)->EnableWindow(TRUE);
		GetDlgItem(IDC_U180)->EnableWindow(TRUE);
		GetDlgItem(IDC_GAIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_MOY)->EnableWindow(TRUE);
	}
	m_OK=!m_OK;
}
//________________________________________
void CTemMoDlg::OnTimer(UINT nIDEvent) 
{
	short i,j;
	long w,w1;
	float r;
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		m_iNb++;
		if (m_iNb<=m_iMoy)
		{
			//m_sNb.Format("(%2d/%2d)",m_iNb,m_iMoy);
			//UpdateData(FALSE);
			//Dphaseur sur tension 0 V
			m_pPiezo->Tension(0);
			Sleep(50);
			m_pPiezo->Tension(m_iU0);
			Sleep(50);
			if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
			if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
			//Copie dans l'image temporaire n0
			copyimage(m_ps->image,m_pApp->imt[0]);
		
			//Dphaseur sur tension phase 180
			m_pPiezo->Tension(m_iU180);
			Sleep(50);
			if (m_pApp->m_iCarte!=0) m_ps->AcqPerm();
			if (m_pApp->m_iCarte!=0) m_ps->FigerAcq();
			//Calcul de l'image temps moyenn
			for (i=m_ps->image->stx;i<=m_ps->image->endx;i++)
			{
				for (j=m_ps->image->sty;j<=m_ps->image->endy;j++)
				{
					//Soustraction image 0 - image 180
					r=getpixelcolor(m_pApp->imt[0],i,j)-getpixelcolor(m_ps->image,i,j);
					//if (r<0) r=0;
					//Soustraction M256
					/*
					if (r<0)
					{
						r=256+r;
					}
					*/
					//Soustraction absolue
					r=fabs(r);
					w=(long)r;
					w1=getpixelcolor(m_pApp->imt[1],i,j);
					w1=w1+w;
					//Addition dans image temporaire n1
					setpixelcolor(m_pApp->imt[1],i,j,w1);
				}
			}
		}
		else
		{
			//Calcul de la moyenne sur m_iMoy images
			for (i=m_ps->image->stx;i<=m_ps->image->endx;i++)
			{
				for (j=m_ps->image->sty;j<=m_ps->image->endy;j++)
				{
					w1=getpixelcolor(m_pApp->imt[1],i,j);
					r=1.0*w1*m_iGain/m_iMoy;
					if (r>255) r=255;
					w=(long)r;
					setpixelcolor(m_pd->image,i,j,w);
				}
			}
			//Remise  0 de l'image somme
			for (i=m_ps->image->stx;i<=m_ps->image->endx;i++)
			{
				for (j=m_ps->image->sty;j<=m_ps->image->endy;j++)
				{
					setpixelcolor(m_pApp->imt[1],i,j,0);
				}
			}
			//m_pd->m_pView->MAJ_Fen();
			m_pd->UpdateAllViews(NULL);
			m_iNb=0;
		}
		m_OKBusy=FALSE;
	}
	CDialog::OnTimer(nIDEvent);
}
