// TemReDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "TemReDlg.h"
#include "BkDoc.h"
#include "vicdefs.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CTemReDlg dialog
CTemReDlg::CTemReDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTemReDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTemReDlg)
	m_s12 = _T("");
	m_sGain = _T("");
	//}}AFX_DATA_INIT
}
void CTemReDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemReDlg)
	DDX_Control(pDX, IDVISU2, m_btnVisu);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_TEMPS_R, m_comboTem);
	DDX_Text(pDX, IDC_STATIC12, m_s12);
	DDX_Text(pDX, IDC_GAIN, m_sGain);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTemReDlg, CDialog)
	//{{AFX_MSG_MAP(CTemReDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDVISU2, OnVisu2)
	ON_EN_CHANGE(IDC_GAIN, OnChangeGain)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CTemReDlg message handlers
void CTemReDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CTemReDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i;
	CString s;
	m_pApp=((CBkApp*)AfxGetApp());
	//Image camra
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pCam=(CBkDoc*)pChild->GetActiveDocument(); else m_pCam=NULL;
	m_OKP=TRUE;
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboTem.AddString(s);
		}
	}
	s="NOUV. IMAGE";
	m_comboTem.AddString(s);
	//Par dfaut sur nouvelle image
	m_comboTem.GetLBText(m_comboTem.GetCount()-1,s);
	m_comboTem.SetWindowText(s);
	m_s12=m_pCam->m_sNomFic;
	m_iGain=8;
	m_sGain.Format("%d",m_iGain);
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CTemReDlg::OnCancel() 
{
	if (!m_OKP)
	{
		KillTimer(45);
		KillTimer(46);
		KillTimer(47);
	}
	m_pCam->FigerAcq();
	//La fentre camra devient courante
	if (!m_OKP) m_pCam->PositionnerFenetre(m_pCam->m_iL+20,0);

	CDialog::OnCancel();
}
//________________________________________
void CTemReDlg::OnTimer(UINT nIDEvent) 
{
	short 
		i,j,
		duree=1,duree1;
	long w,w1;
	float r;

	if (m_pApp->m_iCarte==3) duree1=1; else duree1=1;//Pour carte Primo, duree1=1 s
	switch(nIDEvent)
	{
		case 45://Acq. permanente
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(45);
				if (m_pApp->m_iCarte!=0) m_pCam->AcqPerm();
				m_iN=0;SetTimer(46,50,NULL);
			}
		break;
		case 46://Temporisation 150 ms, puis acq. fige
			m_iN++;
			if (m_iN>duree)
			{
				KillTimer(46);
				if (m_pApp->m_iCarte!=0) m_pCam->FigerAcq();
				m_iN=0;SetTimer(47,50,NULL);
			}
		break;
		case 47://Affichage image temps rel
			m_iN++;
			if (m_iN>duree1)
			{
				KillTimer(47);
				for (i=m_pCam->image->stx;i<=m_pCam->image->endx;i++)
				{
					for (j=m_pCam->image->sty;j<=m_pCam->image->endy;j++)
					{
						w=getpixelcolor(m_pCam->image,i,j);
						w1=getpixelcolor(m_ImTempo,i,j);
						r=fabs(1.0*m_iGain*(w-w1));
						if (r>255) r=255;
						if (r<0) r=0;
						w=(long)(r);
						setpixelcolor(m_pTem->image,i,j,w);
					}
				}
				m_pTem->UpdateAllViews(NULL);
				m_iN=0;SetTimer(45,50,NULL);
			}
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CTemReDlg::OnVisu2() 
{
	//Clic sur Visualiser ou Rfrence
	if (m_OKP)
	{
		PremiereFois();
		m_btnVisu.SetWindowText("&Rfrence");
		Reference();
		m_iN=0;SetTimer(45,50,NULL);
	}
	else
	{
		Reference();
	}
}
//________________________________________
void CTemReDlg::PremiereFois() 
{
	m_OKP=FALSE;
	if (m_comboTem.GetCurSel()<0) 
		m_pTem=m_pDoc[m_comboTem.GetCount()-1];
	else
		m_pTem=m_pDoc[m_comboTem.GetCurSel()];
	m_pCam->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,8);
	m_pCam->DefinirCurseurs(m_pCam->m_iL,m_pCam->m_iH);
	//Image source (camra): m_pCam
	//Image temps rel: m_pTem
	//Si la fentre destination n'existe pas, il faut la crer...
	if (m_pTem==NULL)	m_pTem=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	m_pTem->InitialiserImage(m_pTem->m_iL,m_pTem->m_iH,8);
	//Dimensionner l'image phase  la taille source
	m_pTem->m_iH=m_pCam->m_iH;
	m_pTem->m_iL=m_pCam->m_iL;
	m_pTem->m_iNbB=8;
	m_pTem->m_iType=0;
	m_pTem->InitTracker();//Pas de tracker sur la destination...
	m_pTem->m_sNomFic.Format("ImTempsReel%d",m_pTem->m_iNo);
	m_pTem->DefinirCurseurs(m_pCam->m_iL,m_pCam->m_iH);
	m_pTem->DimensionnerFenetre(m_pCam->m_iL,m_pCam->m_iH);
	m_comboTem.SetWindowText(m_pTem->m_sNomFic);
	GetDlgItem(IDC_TEMPS_R)->EnableWindow(FALSE);
	m_pCam->m_sNomFic.Format("ImCamera%d",m_pCam->m_iNo);
	m_s12=m_pCam->m_sNomFic;
	m_pCam->PositionnerFenetre(m_pCam->m_iL+20,0);
	m_pTem->PositionnerFenetre(0,0);
	m_ImTempo=m_pApp->imt[0];//Ne pas prendre la 7, utilise par Primo
	UpdateData(FALSE);
}
//________________________________________
void CTemReDlg::Reference() 
{
	m_pCam->DupliquerImageDansTempo(0);
}
//________________________________________
void CTemReDlg::OnChangeGain() 
{
	//Vrification de la validit du changement de gain
	int i,j;
	UpdateData(TRUE);
	if (m_sGain.GetLength()>0)
	{
		j=sscanf(m_sGain,"%d",&i);
		if (j==0)
			m_iGain=1;
		else
			m_iGain=abs(i);
		m_sGain.Format("%d",m_iGain);
	}
	else
	{
		m_iGain=1;
		m_sGain="1";
	}
	UpdateData(FALSE);
}
