// TopoDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "TopoDlg.h"
#include "bkdoc.h"
#include "piezo.h"
#include "math.h"
#include "altitudedlg.h"
#include "bkview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CTopoDlg dialog
CTopoDlg::CTopoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTopoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTopoDlg)
	m_iAcquisitions = 0;
	m_fScanning = 0.0f;
	m_iPas = 0;
	m_s1 = _T("");
	m_s2 = _T("");
	//}}AFX_DATA_INIT
}
void CTopoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTopoDlg)
	DDX_Control(pDX, IDC_COMBO2, m_comboCoul);
	DDX_Control(pDX, IDCANCEL, m_btnFermer);
	DDX_Control(pDX, IDC_PROGRESS1, m_progress);
	DDX_Control(pDX, IDC_DEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDC_COMBO1, m_comboDest);
	DDX_Control(pDX, IDC_ARRETER, m_btnArreter);
	DDX_Text(pDX, IDC_SCANNING, m_fScanning);
	DDX_Text(pDX, IDC_PAS, m_iPas);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Text(pDX, IDC_STATIC2, m_s2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTopoDlg, CDialog)
	//{{AFX_MSG_MAP(CTopoDlg)
	ON_BN_CLICKED(IDC_ARRETER, OnArreter)
	ON_BN_CLICKED(IDC_DEMARRER, OnDemarrer)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CTopoDlg message handlers
BOOL CTopoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short i,j;
	CString s;
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Document camra: m_pApp->m_pCam->, image: m_pApp->m_pCam->-image
	if (pChild) m_pCam=(CBkDoc*)pChild->GetActiveDocument(); else m_pCam=NULL;
	//Tableau de pointeurs sur les documents ouverts, sauf l'image camra qui est exclue de la liste...
	m_pApp->GetDocumentSansCourant(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			//Images dj ouvertes
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboDest.AddString(s);
			m_comboCoul.AddString(s);
		}         
	}
	//Possibilit d'ouvrir aussi une nouvelle image
	s="NOUVELLE IMAGE";
	m_comboDest.AddString(s);
	m_comboCoul.AddString(s);
	//Par dfaut sur nouvelle image
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	m_comboCoul.GetLBText(m_comboCoul.GetCount()-1,s);
	m_comboCoul.SetWindowText(s);	
	m_OKP=TRUE;
	//Pointeur sur classe CPiezo
	m_pPiezo=new CPiezo(m_pApp->m_radioPortSeriePiezo);
	//Paramtres de l'acquisition par dfaut en provenance de l'application (Bk.cpp)
	m_fScanning=m_pApp->m_fScanning;
	m_iPas=m_pApp->m_iPas;
	
	m_btnArreter.EnableWindow(FALSE);
	m_s1.Format("%s",m_pCam->m_sNomFic);
	UpdateData(FALSE);

	SetTimer(44,200,NULL);
	return TRUE;
}
//________________________________________
void CTopoDlg::OnArreter() 
{
	//Par tapes
	KillTimer(45);
	KillTimer(46);
	KillTimer(47);
	KillTimer(48);
	//Dans la foule
	KillTimer(50);
	m_btnArreter.EnableWindow(FALSE);
	m_btnFermer.EnableWindow(TRUE);
	m_btnDemarrer.EnableWindow(TRUE);
}
//________________________________________
void CTopoDlg::OnDemarrer() 
{
	float r;
	short i;
	KillTimer(44);
	UpdateData(TRUE);
	//Vrification des saisies utilisateur
	if (m_fScanning<0.1) m_fScanning=0.1;
	if (m_fScanning>25) m_fScanning=25;
	r=25000.0/1024;i=(short)r;
	if (m_iPas<i) m_iPas=i;
	if (m_iPas>500*m_fScanning) m_iPas=500*m_fScanning;
	UpdateData(FALSE);
	//Nombre d'acquisitions  faire
	m_iNbAcq=(short)(1.0+1000*m_fScanning/m_iPas);
	if (m_iNbAcq>1024) m_iNbAcq=1024;
	
	m_btnArreter.EnableWindow(TRUE);
	m_btnFermer.EnableWindow(FALSE);
	m_btnDemarrer.EnableWindow(FALSE);
	UpdateData(FALSE);
	//Barre de progression
	m_progress.SetRange(0,m_iNbAcq-1);
	m_progress.SetPos(0);
	//La premire que l'on clique sur Dmarrer, il faut peut-tre ouvrir les images et les dimensionner
	if (m_OKP) PremiereFois();	


	zeroimage(255,m_pDest->image);
	zeroimage(0,m_pCoul->image);

	//Initialisation du nb. de mesure dj effectues
	//Initilisation de la temporisation m_iN
	m_iNb=0;m_iN=0;
	//Par tapes
	//SetTimer(45,10,NULL);
	//Dans la foule
	m_OKBusy=FALSE;SetTimer(50,50,NULL);
}
//________________________________________
void CTopoDlg::OnCancel() 
{
	//Dconnexion de la camra
	if (!m_OKP)
	{
		//m_pCam->FigerAcq();
		m_pCam->PositionnerFenetre(0,0);
		m_pCam->Deconnexion();
	}

	UpdateData(TRUE);
	//Mise  jour des paramtres de l'analyse dans l'application (Bk.cpp)
	delete m_pPiezo;
	if (m_OKP==FALSE)
	{
		m_pApp->m_fScanning=m_pCoul->m_fScanning=m_pDest->m_fScanning=m_fScanning;
		m_pApp->m_iPas=m_pCoul->m_iPas=m_pDest->m_iPas=m_iPas;

		m_pDest->m_iType=0;
		m_pCam->m_iType=0;
		m_pCoul->m_iType=0;

		short i,j,l,h;
		h=m_pCam->Hysteresis(m_fScanning);
		//On code la profondeur de scanning dans le coin suprieur gauche de l'image couleur
		for (i=0;i<4;i++)
		{
			for (j=0;j<4;j++)
			{
				setpixelcolor(m_pCoul->image,i,j,(long)(m_fScanning*1000));
			}
		}
		//On code le nombre d'acquisitions
		for (i=4;i<8;i++)
		{
			for (j=0;j<4;j++)
			{
				setpixelcolor(m_pCoul->image,i,j,m_iPas);
			}
		}
		//On code la reconnaissance
		for (i=8;i<12;i++)
		{
			for (j=0;j<4;j++)
			{
				setpixelcolor(m_pCoul->image,i,j,1956);
			}
		}
		m_pDest->UpdateAllViews(NULL);
		m_pCoul->UpdateAllViews(NULL);

		//Ouverture automatique de la boite altitude
		if (m_pApp->m_pAltitudeDlg==NULL) 
		{
			m_pApp->m_pAltitudeDlg=new CAltitudeDlg(m_pCoul->m_pWnd);
		}
	}
	CDialog::OnCancel();
}
//________________________________________
void CTopoDlg::OnTimer(UINT nIDEvent) 
{
	BOOL ok;
	short	Hmax=m_pCam->Hysteresis(m_fScanning);

	switch (nIDEvent)
	{
		case 44://Test de la validit des images slectionnes
			//L'image Coul doit tre diffrente de Dest, sauf si elles sont nouvelles
			if (m_comboCoul.GetCurSel()<0)
				m_pCoul=m_pDoc[m_comboCoul.GetCount()-1];
			else
				m_pCoul=m_pDoc[m_comboCoul.GetCurSel()];
			if (m_comboDest.GetCurSel()<0)
				m_pDest=m_pDoc[m_comboDest.GetCount()-1];
			else
				m_pDest=m_pDoc[m_comboDest.GetCurSel()];
			if (m_pCoul==NULL && m_pDest==NULL) 
				ok=TRUE;
			else
			if (m_pCoul==m_pDest)
				ok=FALSE;
			else
				ok=TRUE;
			m_btnDemarrer.EnableWindow(ok);
		break;
		//Acquisition___________________________
		case 45:
			m_iN++;
			if (m_iN>5)//Au bout de 5x10=50 ms
			{
				KillTimer(45);
				//Dplacer pizo
				m_iI=PositionnerPiezo(1e-3*m_iPas*m_iNb);//Paramtre en m, retourne m_iI dans l'intervalle [0, 1023]
				m_iU=(short)(100.0*m_iI/1023.0);//Calcul de la tension piezo dans [0, 100]
				m_iN=0;SetTimer(46,10,NULL);
			}
		break;
		case 46:
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(46);
				//Acq. permanente
				m_pCam->AcqPerm();
				m_iN=0;SetTimer(47,10,NULL);
			}
		break;
		case 47:
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(47);
				//Acq. fige
				m_pCam->FigerAcq();
				m_iN=0;SetTimer(48,10,NULL);
			}
		break;
		case 48:
			m_iN++;
			if (m_iN>5)
			{
				KillTimer(48);
				//Analyse des images pour l'altitude pizo m_iI
				Analyser(m_iI,Hmax);
				
				m_progress.SetPos(m_iNb);
				m_iNb++;
				m_s2.Format("%d/%d, x(m):%1.3f\n(Pizo(V):%3d, %4d/%4d)",m_iNb,m_iNbAcq,1e-3*m_iPas*(m_iNb-1),m_iU,m_iI,Hmax);
			
				UpdateData(FALSE);
				if (m_iNb>=m_iNbAcq)
				{
					//C'est fini...
					OnArreter();//Comme si on cliquait sur Arrter
				}
				else
					SetTimer(45,10,NULL);//On reprend au timer 45 au bout de 50 ms
			}
		break;
		//Dans la foule______________________
		case 50:
			if (m_OKBusy==FALSE)
			{
				m_OKBusy=TRUE;
				m_iI=PositionnerPiezo(1e-3*m_iPas*m_iNb);//Paramtre en m, retourne m_iI dans l'intervalle [0, 1023]
				Sleep(100);
				m_iU=(short)(100.0*m_iI/1023.0);//Calcul de la tension piezo dans [0, 100]
				m_pCam->AcqPerm();
				m_pCam->FigerAcq();
				Analyser(m_iI,Hmax);
				
				m_progress.SetPos(m_iNb);
				m_iNb++;
				m_s2.Format("%d/%d, x(m):%1.3f\n(Pizo(V):%3d, %4d/%4d)",m_iNb,m_iNbAcq,1e-3*m_iPas*(m_iNb-1),m_iU,m_iI,Hmax);
		
				UpdateData(FALSE);
				if (m_iNb>=m_iNbAcq)
				{
					//C'est fini...
					OnArreter();//Comme si on cliquait sur Arrter
				}
				m_OKBusy=FALSE;
			}
		break;
	}	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CTopoDlg::PremiereFois() 
{
	m_OKP=FALSE;
	m_pCam->InitialiserImage(m_pApp->m_iL,m_pApp->m_iH,8);
	//Eventuellement ouverture des nouvelles fentres
	if (m_pDest==NULL)	m_pDest=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	if (m_pCoul==NULL)	m_pCoul=m_pApp->CreerNouvelleFenetre(m_pCam->m_iL,m_pCam->m_iH);
	
	short l,h;
	//Taille de l'image camra
	l=m_pCam->image->endx-m_pCam->image->stx+1;
	h=m_pCam->image->endy-m_pCam->image->sty+1;


	m_pDest->InitialiserImage(l,h,8);
	m_pCoul->InitialiserImage(l,h,24);

	m_pCam->DimensionnerFenetre(l,h);
	m_pCoul->DimensionnerFenetre(l,h);
	m_pDest->DimensionnerFenetre(l,h);

	m_pCam->DefinirCurseurs(l,h);
	m_pDest->DefinirCurseurs(l,h);
	m_pCoul->DefinirCurseurs(l,h);

	m_pDest->m_iType=0;
	m_pCam->m_iType=0;
	m_pCoul->m_iType=0;

	m_pCam->m_sNomFic.Format("Camera%d",m_pCam->m_iNo);
	m_pDest->m_sNomFic.Format("ImPixelsLu%d",m_pDest->m_iNo);
	m_pCoul->m_sNomFic.Format("Topographie%d",m_pCoul->m_iNo);

	m_pCam->InitTracker();
	m_pDest->InitTracker();
	m_pCoul->InitTracker();

	m_comboDest.SetWindowText(m_pDest->m_sNomFic);m_comboDest.EnableWindow(FALSE);
	m_comboCoul.SetWindowText(m_pCoul->m_sNomFic);m_comboCoul.EnableWindow(FALSE);
	m_s1=m_pCam->m_sNomFic;

	m_pDest->PositionnerFenetre(0,h+30);
	m_pCoul->PositionnerFenetre(l+15,0);
	m_pCam->PositionnerFenetre(0,0);
	if (m_pApp->m_iCarte==4) m_pCam->Connexion();

	UpdateData(FALSE);
}
//________________________________________
//h dans l'intervalle [0, 1023]
long CTopoDlg::Couleur(short h,short hmax)
{
	short R,V,B;

	h=1023*h/hmax;
	
	if (h<256)
	{
		R=0;
		V=h;
		B=255;
	}
	else
	if (h>=256 && h<512)
	{
		B=511-h;
		V=255;
		R=h-256;
	}
	else
	if (h>=512 && h<768)
	{
		R=255;
		V=767-h;
		B=0;
	}
	else
	{
		R=1023-h;
		B=h-768;
		V=0;
	}
	return RGB(R,V,B);
}
//________________________________________
short CTopoDlg::PositionnerPiezo(float x)//En m 
{
	short i;
	//Sans tenir de la courbe d'hystrsis
	i=m_pCam->Hysteresis(x);
	m_pPiezo->Pilote(i);
	return i;
}
//________________________________________
void CTopoDlg::Analyser(short H,short Hmax)
{
	//Dfinition des images: m_pCam->image, m_pDest->image, m_pCoul->image
	//Altitude H dans l'intervalle [0, Hmax]
	//Hmax: profondeur de scanning (maxi:1023, correspond  25 m), pour tendre la gamme de couleur sur tout l'intervalle
	//Taille des images
	short
		R,V,B,
		i,j,k,
		l,h,nbB;
	long w,w1;
	l=m_pCam->image->endx-m_pCam->image->stx+1;
	h=m_pCam->image->endy-m_pCam->image->sty+1;
	for (i=0;i<l;i++)
	{
		for (j=0;j<h;j++)
		{
			
			w=getpixelcolor(m_pCam->image,i,j);
			w1=getpixelcolor(m_pDest->image,i,j);


			if (w<w1)
			{
				w1=w;
				setpixelcolor(m_pDest->image,i,j,w1);
				//Pour de vrai : Calcul de l'image code en 24 bits
				if (m_pApp->m_iCarte!=0) setpixelcolor(m_pCoul->image,i,j,Couleur(H,Hmax));
			}
			//Pour le fun...
			if (m_pApp->m_iCarte==0)
			{
				if (i>=0.75*H) setpixelcolor(m_pCoul->image,i,j,Couleur(H,Hmax));
			}
		}
	}
	//m_pDest->UpdateAllViews(NULL);
	//m_pCoul->UpdateAllViews(NULL);
	m_pDest->m_pView->MAJ_Fen();
	m_pCoul->m_pView->MAJ_Fen();
}
