// ZoomDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ZoomDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CZoomDlg dialog
CZoomDlg::CZoomDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZoomDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZoomDlg)
	m_s = _T("");
	//}}AFX_DATA_INIT
}
void CZoomDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZoomDlg)
	DDX_Control(pDX, IDORIGINAL, m_btnOri);
	DDX_Control(pDX, IDZOOMPLUS, m_btnZoomPlus);
	DDX_Control(pDX, IDZOOMMOINS, m_btnZoomMoins);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CZoomDlg, CDialog)
	//{{AFX_MSG_MAP(CZoomDlg)
	ON_BN_CLICKED(IDZOOMPLUS, OnZoomplus)
	ON_BN_CLICKED(IDZOOMMOINS, OnZoommoins)
	ON_BN_CLICKED(IDORIGINAL, OnOriginal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CZoomDlg message handlers
void CZoomDlg::MAJ()
{
	if (m_pDoc!=NULL) m_s.Format("Image: %s\nCoef: %1.2f\nCliquer sur Image originale pour annuler le zoom.",m_pDoc->m_sNomFic,m_fCoef);
	UpdateData(FALSE);
}
//________________________________________
void CZoomDlg::Zoom()
{
	short 
		l,h,l1,h1;
	if (m_pDoc!=NULL)
	{
		l=m_pApp->imt[0]->endx-m_pApp->imt[0]->stx+1;
		h=m_pApp->imt[0]->endy-m_pApp->imt[0]->sty+1;
		
		l1=(short)(1.0*l*m_fCoef);
		h1=(short)(1.0*h*m_fCoef);

		//La largeur minimale de la fentre est limite  140 pixels
		if (l1<=140)
		{
			m_btnZoomMoins.EnableWindow(FALSE);
		}
		else
		{
			m_btnZoomMoins.EnableWindow(TRUE);
			freeimage(m_pDoc->image);
			m_pDoc->m_iL=l1;
			m_pDoc->m_iH=h1;
			allocimage(m_pDoc->image,l1,h1,m_pApp->imt[0]->bmh->biBitCount);
			resize(m_pApp->imt[0],m_pDoc->image);
			m_pDoc->DefinirCurseurs(l1,h1);
			if (l1<l || h1<h)
				m_pDoc->DimensionnerFenetre(l1,h1);
			else
				m_pDoc->DimensionnerFenetre(l,h);
		}
	}
}
//_________________________________________________
void CZoomDlg::PremiereFois()
{
	short 
		i,l,h,nbB,l1,h1,nbB1;

	if (m_pDoc!=NULL)
	{	
		if (!m_OKZoom)
		{
			//Suppression des profils et cotes
			m_pDoc->m_iType=0;		
			//Suppression calibration
			m_pDoc->m_OKXY=m_pDoc->m_OKZ=FALSE;
			l=m_pDoc->image->endx-m_pDoc->image->stx+1;
			h=m_pDoc->image->endy-m_pDoc->image->sty+1;
			nbB=m_pDoc->image->bmh->biBitCount;
			l1=m_pApp->imt[0]->endx-m_pDoc->image->stx+1;
			h1=m_pApp->imt[0]->endy-m_pDoc->image->sty+1;
			nbB1=m_pApp->imt[0]->bmh->biBitCount;

			m_OKZoom=TRUE;
			//Copie de l'image originale dans l'image temporaire
			if (l!=l1 || h!=h1 || nbB!=nbB1)
			{
				freeimage(m_pApp->imt[0]);
				allocimage(m_pApp->imt[0],l,h,nbB);
			}
			copyimage(m_pDoc->image,m_pApp->imt[0]);
		}	
	}
}
//_________________________________________________
BOOL CZoomDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	if (m_pDoc!=NULL)
	{
		m_fCoef=1;
		m_OKZoom=FALSE;
		m_OK=TRUE;
		m_btnOri.EnableWindow(FALSE);
		m_s.Format("Image: %s\nAttention:\nLes profils, annotations et cotes seront supprims !",m_pDoc->m_sNomFic);
		UpdateData(FALSE);
	}
	return TRUE;
}
//_________________________________________________
void CZoomDlg::OnOK() 
{
	//CDialog::OnOK();
}
//_________________________________________________
void CZoomDlg::OnCancel() 
{
	m_OK=FALSE;	
	CDialog::OnCancel();
}
//_________________________________________________
void CZoomDlg::OnZoomplus() 
{
	m_btnOri.EnableWindow(TRUE);
	if (!m_OKZoom)
	{
		PremiereFois();
	}
	m_fCoef=m_fCoef*1.1;
	MAJ();
	//On applique le zoom
	Zoom();
}
//_________________________________________________
void CZoomDlg::OnZoommoins() 
{
	m_btnOri.EnableWindow(TRUE);
	if (!m_OKZoom)
	{
		PremiereFois();
	}	
	m_fCoef=m_fCoef/1.1;
	MAJ();
	//On applique le zoom
	Zoom();
}
//_________________________________________________
void CZoomDlg::OnOriginal() 
{
	m_fCoef=1;
	MAJ();
	//On applique le zoom
	Zoom();
}
